<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>

<template:include view="hidden.header"/>

<jcr:nodeProperty node="${currentNode}" name="position" var="position"/>
<c:set var="pullClass" value="" />
<c:if test="${not empty position}">
    <c:set var="pullClass" value=" pull-${position.string}" />
</c:if>

<c:set var="isEmpty" value="true"/>

<c:choose>
    <c:when test="${renderContext.editModeConfigName eq 'studiomode' and inWrapper eq false}">
        <ul>
            <c:forEach items="${moduleMap.currentList}" var="subchild">
                <li><template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable}"/></li>
                <c:set var="isEmpty" value="false"/>
            </c:forEach>
            <c:if test="${moduleMap.editable}">
                <li><template:module path="*"/></li>
            </c:if>
            <c:if test="${not empty moduleMap.emptyListMessage and moduleMap.forceEmptyListMessageDisplay and isEmpty}">
                <li>${moduleMap.emptyListMessage}</li>
            </c:if>
        </ul>
    </c:when>
    <c:when test="${renderContext.editModeConfigName eq 'studiovisualmode'}">
        <ul class="nav ${pullClass}">
            <c:forEach items="${moduleMap.currentList}" var="subchild">
                <li <c:if test="${subchild.properties['j:view'].string eq 'docspaceBootstrapNavBarDropdown'}">class="dropdown"</c:if> >
                    <template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable}"/>
                </li>
                <c:set var="isEmpty" value="false"/>
            </c:forEach>
            <c:if test="${moduleMap.editable}">
                <li><template:module path="*"/></li>
            </c:if>
            <c:if test="${not empty moduleMap.emptyListMessage and moduleMap.forceEmptyListMessageDisplay and isEmpty}">
                <li>${moduleMap.emptyListMessage}</li>
            </c:if>
        </ul>
    </c:when>
    <c:otherwise>
        <ul class="nav ${pullClass}">
            <c:forEach items="${moduleMap.currentList}" var="subchild">
                <template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable}"/>
            </c:forEach>
        </ul>
    </c:otherwise>
</c:choose>

<template:include view="hidden.footer"/>
