<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<c:url var="collectionURL" value="${url.basePreview}${functions:escapePath(currentNode.path)}"/>
<c:if test="${not fn:startsWith(currentNode.path,renderContext.user.localPath)}">
<jcr:node var="userCollection" path="${renderContext.user.localPath}/collections"/>
<c:set var="subscribed" value="false"/>
<c:forEach items="${userCollection.properties['subscribedCollections']}" var="sub" varStatus="st">
    <c:if test="${currentNode.identifier eq sub.string}">
        <c:set var="subscribed" value="true"/>
    </c:if>
</c:forEach>
</c:if>

<fmt:message key="docnt_collection.AskForDelete" var="i18nConfirmDelete">
    <fmt:param value="${currentNode.displayableName}"/>
</fmt:message>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });

        function switchCollectionDisplay(identifier) {
            $('#iconChevron_' + identifier).toggleClass('fa-chevron-down fa-chevron-up', 200);
            var $linkCollapse = $('#linkCollapse_' + identifier);
            if ($linkCollapse.attr('title') == wsfi18n['wsf.label.hide']) {
                $linkCollapse.attr('title', wsfi18n['wsf.label.show']);
            } else {
                $linkCollapse.attr('title', wsfi18n['wsf.label.hide']);
            }
            $('.collectionIconChevron').each(function () {
                if (!$(this).is($('#iconChevron_' + identifier)) && $(this).hasClass('fa-chevron-up'))
                    $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
            });
            $('.collectionLink').each(function () {
                if (!$(this).is($('#linkCollapse_' + identifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                    $(this).attr('title', wsfi18n['wsf.label.show']);
            });
            $('.collectionDetails').each(function () {
                if (!$(this).is($('#collapse_' + identifier)) && $(this).hasClass('in')) {
                    $(this).collapse('hide');
                }
            });
        }

        function deleteFromCollection(message, itemURL, itemId, colId) {
            bootbox.confirm(message, function(result) {
                if (result) {
                    $.ajax({
                        type: 'DELETE',
                        url: itemURL,
                        dataType: 'json',
                        success: function (data, textStatus, jqXHR) {
                            location.reload(true);
                        }
                    });
                }
            });
        }

        function bbCollectionDelete(message, itemURL, colId) {
            bootbox.confirm(message, function(result) {
                if (result) {
                    $.ajax({
                        type: 'DELETE',
                        url: itemURL,
                        dataType: 'json',
                        success: function (data, textStatus, jqXHR) {
                            location.reload(true);
                        }
                    });
                }
            });
        }

        function collectionActions(action, collectionId) {
            var data;
            if (action == 'subscribe') {
                data = {
                    action: action,
                    subscribe: collectionId
                };
            } else {
                data = {
                    action: action,
                    unsubscribe: collectionId
                };
            }
            $.post('<c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(renderContext.user.localPath)}.manageCollection.do"/>',
                data, function(result) {
                    location.reload(true);
                },"json");
        }
    </script>
</template:addResources>

<c:set var="referenceType" value="jnt:fileReference,docnt:noteReference"/>
<c:set var="docspaceNode" value="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace') ? renderContext.mainResource.node : jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
<c:set var="userCollections" value="${jcr:getChildrenOfType(currentNode, referenceType)}"/>
<c:set var="docCount" value="0"/>
<c:if test="${!empty docspaceNode}">
    <c:forEach items="${userCollections}" var="child">
        <c:if test="${fn:contains(child.properties['j:node'].node.path, docspaceNode.path)}">
            <c:set var="docCount" value="${docCount + 1}"/>
        </c:if>
    </c:forEach>
</c:if>

<td headers="Title">
    <ul class="unstyled">
        <li>
            <a data-toggle="collapse" href="#collapse_${currentNode.identifier}"
               title="${functions:escapeJavaScript(labelShow)}"
               onclick="switchCollectionDisplay('${currentNode.identifier}')"
               id="linkCollapse_${currentNode.identifier}"
               class="collectionLink no-decoration">
                <i id="iconChevron_${currentNode.identifier}"
                   class="fa fa-chevron-down fa-fw collectionIconChevron"></i>
                <i class="fa fa-bookmark"></i>
                ${fn:escapeXml(currentNode.displayableName)}
            </a>
            <c:if test="${not fn:startsWith(currentNode.path, renderContext.user.localPath)}">
                <c:if test="${subscribed eq 'true'}">
                    <fmt:message key="docnt_collection.unsubscribe" var="unsubscribeCollection"/>
                    <a href="#" class="fa fa-minus-circle no-decoration pull-right"
                       onclick="collectionActions('unsubscribe', '${currentNode.identifier}'); return false;"
                       title="${fn:escapeXml(unsubscribeCollection)}">
                    </a>
                </c:if>
                <c:if test="${subscribed eq 'false'}">
                    <fmt:message key="docnt_collection.subscribe" var="subscribeCollection"/>
                    <a href="#" class="fa fa-plus-circle no-decoration pull-right"
                       onclick="collectionActions('subscribe', '${currentNode.identifier}'); return false;"
                       title="${fn:escapeXml(subscribeCollection)}">
                    </a>
                </c:if>
            </c:if>
            <c:if test="${jcr:hasPermission(currentNode,'jcr:removeNode')}">
                <fmt:message key="docnt_collection.delete" var="deleteCollection"/>
                <a title="${fn:escapeXml(deleteCollection)}"
                   onclick="bbCollectionDelete('${fn:escapeXml(i18nConfirmDelete)}', '${fn:escapeXml(collectionURL)}', '${currentNode.identifier}');return false;"
                   href="#" class="fa fa-trash no-decoration pull-right hidden-phone">
                </a>
            </c:if>
            <c:forEach items="${userCollections}" var="child" varStatus="userCollectionsStatus">
                <c:if test="${userCollectionsStatus.first}">
                    <ul id="collapse_${currentNode.identifier}" class="unstyled collapse collectionDetails">
                </c:if>
                <li>
                    &nbsp;
                    &nbsp;
                    <c:set var="targetNode" value="${child.properties['j:node'].node}"/>
                    <c:if test="${not empty targetNode}">
                        <c:set var="isNote" value="${jcr:isNodeType(child, 'docnt:noteReference')}"/>
                        <c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(targetNode.path)}.workspace-${isNote ? 'note' : 'document'}-details.html" var="docDetailsUrl"/>
                        <c:set var="itemName" value="${isNote ? targetNode.properties['jcr:title'].string : targetNode.name}"/>
                        <template:module node="${child}" view="faiconspan" templateType="html" contextSite="${targetNode.resolveSite}"/>&nbsp;<a href="${docDetailsUrl}">${fn:escapeXml(not empty itemName ? itemName : targetNode.name)}</a>
                        <small>
                            <c:set var="docspaceNode" value="${jcr:getParentOfType(targetNode, 'docmix:docspace')}"/>
                            ${fn:escapeXml(docspaceNode.displayableName)} -
                            <span class="momentToFormat" data-moment-display-type="format"
                                  data-moment-locale="${currentResource.locale}" data-moment-format="LL"
                                  data-moment="<fmt:formatDate value="${targetNode.properties['jcr:lastModified'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                        </small>
                    </c:if>
                    <c:if test="${empty targetNode}">
                        ${fn:escapeXml(child.name)}
                    </c:if>
                    <c:if test="${jcr:hasPermission(child,'jcr:removeNode')}">
                        <c:url var="itemURL" value="${url.basePreview}${functions:escapePath(child.path)}"/>
                        <fmt:message key="docnt_collection.askForRemove" var="removeItem">
                            <fmt:param value="${child.name}"/>
                            <fmt:param value="${currentNode.displayableName}"/>
                        </fmt:message>
                        <fmt:message key="docnt_collection.removeFromCollection" var="removeFromCollection"/>
                        <a title="${fn:escapeXml(removeFromCollection)}"
                           class="fa fa-fw fa-minus-circle text-info no-decoration hidden-phone" href="#"
                           onclick="deleteFromCollection('${functions:escapeJavaScript(removeItem)}', '${functions:escapeJavaScript(itemURL)}', '${functions:escapeJavaScript(child.path)}', '${currentNode.identifier}');return false;">
                        </a>
                </c:if>
                </li>
                <c:if test="${userCollectionsStatus.last}">
                    </ul>
                </c:if>
            </c:forEach>
        </li>
    </ul>
</td>

<td headers="Size">
    ${fn:length(userCollections)}
</td>
