<%@ page contentType="text/html; UTF-8" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:choose>
    <c:when test="${empty param['bindedComponent']}">
        <c:set var="bindedComponent"
               value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent').path}"/>
    </c:when>
    <c:otherwise>
        <c:set var="bindedComponent" value="${param['bindedComponent']}"/>
    </c:otherwise>
</c:choose>

<c:choose>
    <c:when test="${currentResource.workspace eq 'live'}">
        <div id="currentUserTasks${currentNode.identifier}">
            <script type="text/javascript">
                $('#currentUserPosts${currentNode.identifier}').load('<c:url value="${url.basePreview}${functions:escapeJavaScript(functions:escapePath(currentNode.path))}.html.ajax?bindedComponent=${functions:encodeUrlParam(bindedComponent)}"/>');
            </script>
        </div>
    </c:when>
    <c:otherwise>
        <c:set value="" var="todayDisplayed" scope="request"/>
        <query:definition var="listQuery"
                          statement="SELECT * FROM [jnt:post] AS post WHERE isdescendantnode(post,['${functions:sqlencode(bindedComponent)}']) ORDER BY [jcr:created] DESC"/>
        <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
        <c:set target="${moduleMap}" property="subNodesView" value="postList.docspace"/>
    </c:otherwise>
</c:choose>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            var tabContent = $('.commentGetter').parent();
            if (tabContent.hasClass('tab-pane')) {
                var navMenu = tabContent.parent().parent().children()[0],
                    childLI,
                    link;
                if ($('.commentBox').length === 0) {
                    childLI = $(navMenu).children()[1];
                    link = $(childLI).children();
                } else {
                    childLI = $(navMenu).children()[0];
                    link = $(childLI).children();
                }
                setTimeout(function() {
                    $(link).tab('show');
                }, 500);
            }
        });
    </script>
</template:addResources>

<%-- This class is use to get the closest tab --%>
<div class="commentGetter"></div>