<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="dm" uri="http://www.jahia.org/tags/document-management" %>
<%@ taglib prefix="doc" uri="http://www.jahia.org/tags/docspace" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="jquery.fileupload.css"/>
<template:addResources type="css" resources="vendor/bootstrap-tags/bootstrap-tags.css"/>
<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>
<template:addResources type="css" resources="loading.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.fileupload-with-ui.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-tags/bootstrap-tags.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>
<template:addResources type="javascript" resources="loading.js"/>

<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:set var="separator" value="${functions:default(currentResource.moduleParams.separator, ', ')}"/>

<%--Upload file title selector--%>
<c:if test="${!jcr:isNodeType(renderContext.mainResource.node, 'docnt:note')}">
    <c:choose>
        <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
            <fmt:message key="wsf.label.uploadFile" var="fileUploadTitle"/>
        </c:when>
        <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:file')}">
            <fmt:message key="docnt_docspaceActions.uploadVersion" var="fileUploadTitle"/>
        </c:when>
    </c:choose>
</c:if>

<%--Delete selected items title selector--%>
<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
        <fmt:message key="docnt_docspaceActions.deleteMultipleElements" var="deleteSelectedTitle"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer')}">
        <fmt:message key="docnt_docspaceActions.deleteMultipleNotes" var="deleteSelectedTitle"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:pollsContainer')}">
        <fmt:message key="docnt_docspaceActions.deleteMultiplePolls" var="deleteSelectedTitle"/>
    </c:when>
</c:choose>

<%--Copy selected title setter--%>
<c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
    <fmt:message key="docnt_docspaceActions.copyMultipleElements" var="copySelectedTitle"/>
</c:if>

<%--Cut selected title--%>
<c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
    <fmt:message key="docnt_docspaceActions.cutMultipleElements" var="cutSelectedTitle"/>
</c:if>

<%--Paste selected title generation--%>
<c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
    <fmt:message key="docnt_docspaceActions.pasteMultipleElements" var="pasteSelectedTitle"/>
</c:if>

<%--Add collection query--%>
<c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-collections-add')}">
    <c:if test="${not empty docspaceNode}">
        <c:set var="userCollectionsVar" value="${currentUser.userKey}-collections"/>
        <c:choose>
            <c:when test='${queryMap[userCollectionsVar] eq null}'>
                <query:definition var="listQuery"
                                  statement="select * from [docnt:collection] where ischildnode('${functions:sqlencode(currentUser.localPath)}/collections') order by [jcr:title] asc"/>
                <jcr:jqom qomBeanName="listQuery" var="collectionResult"/>
                <c:if test='${queryMap == null}'>
                    <jsp:useBean id="queryMap" class="java.util.HashMap" scope="request"/>
                </c:if>
                <c:set target="${queryMap}" property="${userCollectionsVar}" value="${result}"/>
            </c:when>
            <c:otherwise>
                <c:set var="collectionResult" value="${queryMap[userCollectionsVar]}"/>
            </c:otherwise>
        </c:choose>
    </c:if>
    <%--Make sure collection button is displayed--%>
    <c:if test="${not empty docspaceNode}">
        <c:forEach items="${result.nodes}" var="node">
            <c:set var="hasCollection" value="true"/>
        </c:forEach>
    </c:if>
 </c:if>

<template:addResources>
    <script type="text/javascript">
        var resetInput = false;
        var MenuOnClickFunctions = {
            fileUpload : function() {
                $.ajax({
                    url: '<c:url value="${url.base}${functions:escapePath(currentNode.path)}.loginVerification.do"/>',
                    type: "POST",
                    dataType: "json",
                    success: function(){
                        <c:if test="${!jcr:isNodeType(renderContext.mainResource.node, 'docnt:note')}">
                            if (resetInput) {
                                $('#file_upload_${currentNode.identifier}').fileUploadUI('destroy', 'file_upload_${currentNode.identifier}');
                                $('#file_upload_container_${currentNode.identifier}').css('display', 'block');
                            }

                            $('#uploadModal_${currentNode.identifier}').modal({
                                backdrop: 'static',
                                keyboard: true,
                                show: true
                            });

                            $(document).ready(function() {
                                $('.uploadModalCloseButton').on('click', function() {
                                    if ($('.uploadRow').length > 0){
                                        bootbox.alert(wsfi18n['docnt_docspaceActions.uploadWillContinueInBackground']);
                                        $('#file_upload_container_${currentNode.identifier}').css('display', 'block');
                                        $('#uploadFile').attr('disabled', 'disabled');
                                    }
                                });
                            });
                            $('#file_upload_${currentNode.identifier}').fileUploadUI({
                                namespace: 'file_upload_${currentNode.identifier}',
                                onComplete: function (event, files, index, xhr, handler) {
                                    if ($('tr', handler.uploadTable).size() == 0) {
                                        $('.modal-dialog').hide();
                                        if (xhr.response != null && $.parseJSON(xhr.response).error != null && $.parseJSON(xhr.response)['responseStatus'] != 'negative') {
                                            bootbox.alert($.parseJSON(xhr.response).error);
                                        }

                                        if (xhr.response != null && $.parseJSON(xhr.response)['responseStatus'] == 'negative') {
                                            bootbox.alert(wsfi18n['docnt_docspaceActions.error.uploadMime'], function() {
                                                location.reload(true);
                                            });
                                        }
                                         else {
                                            location.reload(true);
                                        }
                                    }
                                },
                                uploadTable: $('#files_${currentNode.identifier}'),
                                dropZone: $('#file_upload_container_${currentNode.identifier}'),
                                beforeSend: function (event, files, index, xhr, handler, callBack) {
                                    $('#file_upload_container_${currentNode.identifier}').css('display', 'none');
                                    handler.formData = {
                                        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:file')}">
                                            'newVersion': "true",
                                        </c:if>
                                        'jcrNodeType': "jnt:file",
                                        'jcrReturnContentType': "json",
                                        'jcrVersion': "true",
                                        'jcrReturnContentTypeOverride': $.browser.msie ? 'text/plain; charset=UTF-8' : 'application/json; charset=UTF-8',
                                        'jcrRedirectTo': "<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>",
                                        'jcrNewNodeOutputFormat': "${renderContext.mainResource.template}.html"
                                    };
                                    callBack();
                                },
                                buildUploadRow: function (files, index) {
                                    return $('<tr class="uploadRow" ><td>' + files[index].name + '</td>' + '<td class="file_upload_progress"><div></div></td><td class="file_upload_cancel">' +
                                    '<button class="btn btn-danger ui-state-default ui-corner-all" type="button" title="' + wsfi18n['wsf.label.cancel'] + '">' +
                                    '<span class="ui-icon ui-icon-cancel">' + wsfi18n['wsf.label.cancel'] + '</span>' + '</button></td></tr>');
                                },
                                onAbort: function (event, files, index, xhr, handler) {
                                    handler.removeNode(handler.uploadRow);
                                    if ($('.uploadRow').length === 1) {
                                        $('#uploadModal_${currentNode.identifier}').modal('hide');
                                        resetInput = true;
                                    }
                                }
                            });
                        </c:if>
                    },
                    error: function() {
                        bootbox.alert(wsfi18n['docnt_docspaceActions.error.notLogged']);
                    }
                });
                return false;
            },
            createFolder : function() {
                <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-createFolder')}">
                    bootbox.dialog({
                        title: wsfi18n['docnt_docspaceActions.createFolder'],
                        message:  '<form name="createFolder" class="form-horizontal single-submit-form" onsubmit="return false;">' +
                                    '<div class="control-group">' +
                                        '<label class="control-label">' +
                                            wsfi18n['docnt_docspaceActions.createFolder'] +
                                        '</label>' +
                                        '<div class="controls">' +
                                            '<input id="jahia_actions_foldernameField" type="text" value="" name="foldername"/>' +
                                        '</div>' +
                                    '</div>' +
                                '</form>',
                        buttons: {
                            danger: {
                                label: wsfi18n['wsf.label.cancel'],
                                className: 'btn-default',
                                callback: function() {}
                            },
                            success: {
                                label: wsfi18n['docnt_docspaceActions.createFolder'],
                                className: 'btn btn-primary',
                                callback: function() {
                                    showLoading(wsfi18n['wsf.title.workInProgress']);
                                    var path = '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}"/>/*';
                                    var data = {
                                        'jcrNodeName': $('#jahia_actions_foldernameField').val(),
                                        'jcrNodeType':'jnt:folder',
                                        'jcr:mixinTypes':'docmix:docspaceFolder'
                                    };
                                    $.ajax({
                                        type: 'POST',
                                        url: path,
                                        data: data,
                                        dataType: 'json',
                                        success: function(result) {
                                            location.replace("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}'/>/" + encodeURIComponent(result.j_nodename) +
                                            ".${renderContext.mainResource.template}.html");
                                            hideLoading();
                                        }
                                    });
                                }
                            }
                        }
                    });
                </c:if>
                return false;
            },
            deleteFile : function() {
                bootbox.dialog({
                    title: '${functions:escapeJavaScript(deleteSelectedTitle)}',
                    message: wsfi18n['docnt_docspaceActions.itemsWillBeDeleted'],
                    buttons: {
                        danger: {
                            label: wsfi18n['wsf.label.cancel'],
                            className: 'btn-default',
                            callback: function() {}
                        },
                        success: {
                            label: wsfi18n['wsf.label.yes'],
                            className: 'btn btn-danger',
                            callback: function() {
                                showLoading(wsfi18n['wsf.title.workInProgress']);
                                var uuids = getUuids();
                                var datas = {
                                    'uuids':uuids
                                };
                                $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.deleteNodes.do"/>', datas,
                                        function (result) {
                                            location.reload(true);
                                        }
                                );
                            }
                        }
                    }
                });
                return false;
            },
            hasItemsToPaste : false,
            copyItems : function() {
                bootbox.confirm('${functions:escapeJavaScript(copySelectedTitle)}', function(result) {
                    if (result) {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        var uuids = getUuids();
                        var datas = {
                            'uuids':uuids
                        };
                        $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.copy.do"/>', datas,
                                function (result) {
                                    location.reload(true);
                                }
                        );
                    }
                });
                return false;
            },
            cutItems : function() {
                bootbox.confirm('${functions:escapeJavaScript(cutSelectedTitle)}', function(result) {
                    if (result) {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        var uuids = getUuids();
                        var datas = {
                            'uuids':uuids
                        };
                        $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.cut.do"/>', datas,
                                function (result) {
                                    location.reload(true);
                                }
                        );
                    }
                });
                return false;
            },
            pasteItems : function() {
                bootbox.confirm('${functions:escapeJavaScript(pasteSelectedTitle)}', function(result) {
                    if (result) {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        $("#pasteSelectedItems .button").attr("disabled","disabled");
                        var datas = {};
                        $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.paste.do"/>', datas,
                                function (result) {
                                    location.reload(true);
                                }
                        );
                    }
                });
                return false;
            },
            renameItem: function() {
                var box = bootbox.dialog({
                    title: wsfi18n['wsf.label.rename'],
                    message:'<form name="renameFolder" class="single-submit-form">' +
                                '<input id="jahia_actions_newNameField" type="text" class="input-block-level" value="" name="newName"/>' +
                            '</form>',
                    buttons: {
                        danger: {
                            label: wsfi18n['wsf.label.cancel'],
                            className: 'btn-default',
                            callback: function() {}
                        },
                        success: {
                            label: wsfi18n['wsf.label.rename'],
                            className: 'btn btn-primary',
                            callback: function() {
                                showLoading(wsfi18n['wsf.title.workInProgress']);
                                var uuids = getUuids();
                                var data = {
                                    'newName': document.getElementById('jahia_actions_newNameField').value,
                                    'uuid':uuids[0]
                                };
                                $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}"/>.renameItem.do', data,
                                        function (result) {
                                            location.reload();
                                        }, "json"
                                );
                            }
                        }
                    }
                });
                var els = $(".fileCheckbox:checked");
                if (els.length > 0) {
                    $('#jahia_actions_newNameField').val((els.first().attr('alt') || ''));
                }
                $(document).on('change', '#jahia_actions_newNameField', function() {
                    $("#jahia_actions_newNameField").val($(this).val()); //This is very odd but it has to be like that!!!
                });
                box.modal("show");
                return false;
            },
            addTags : function() {
                bootbox.dialog({
                    title: wsfi18n['jnt_tagging.docspace.addTags'],
                    message: '<div id="newTagContainer"></div>',
                    buttons: {
                        success: {
                            label: wsfi18n['wsf.label.close'],
                            className: 'btn',
                            callback: function() {

                            }
                        }
                    }
                });
                (function(){
                    //Tagging.populateTags(); //Make sure this is executed before "itemAdded" listener is set!
                    Tagging.collectAvailableTags();
                    $("#tagging_${currentNode.identifier}").appendTo("#newTagContainer");
                    $("#tagging_${currentNode.identifier}").addClass("TaggingActive").show();
                })();
                return false;
            },
            unlock : function() {
                var uuids = getUuids();
                var data = {
                    'uuids':uuids
                };
                $.post("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.release.do'/>", data,
                        function() {
                            location.reload();
                        }, "json"
                );
                return false;
            },
            createCollection : function() {
                var box = bootbox.dialog({
                    title: wsfi18n['docnt_assignedCollections.create'],
                    message: '<form id="formCreateCollection" name="createCollection" class="single-submit-form">' +
                                    '<input type="text" class="input-block-level" value="" name="collection"/>' +
                                '</form>',
                    buttons: {
                        danger: {
                            label: wsfi18n['wsf.label.cancel'],
                            className: 'btn-default',
                            callback: function() {}
                        },
                        success: {
                            label: wsfi18n['docnt_assignedCollections.create'],
                            className: 'btn btn-primary',
                            callback: function() {
                                showLoading(wsfi18n['wsf.title.workInProgress']);
                                var str = document.getElementById("formCreateCollection").elements["collection"].value;
                                var uuids = getUuids();
                                var data = {
                                    'jcr:title':str,
                                    'docspaceIdentifier':'${docspaceNode.identifier}',
                                    'action':'addCollection',
                                    'uuids':uuids
                                };
                                $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', data,
                                        function (result) {
                                            var redirectUrl = '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.${renderContext.mainResource.template}.html"/>';
                                            if (result.collection != undefined) {
                                                redirectUrl += "?collection=" + encodeURIComponent(decodeURIComponent(result.collection));
                                            }
                                            location.replace(redirectUrl);
                                        }, "json");
                            }
                        }
                    }
                });
                $(document).on('shown.bs.modal', function() {
                    var elem = document.forms['createCollection'].elements['collection'];
                    if (elem)
                        elem.focus();
                });
                box.modal("show");
                return false;
            },
            manageCollection : function() {
                <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-collections-add')}">
                    var form =  '<div id="manageCollectionForm">' +
                                            <c:if test="${not empty docspaceNode}">
                                            '<form name="manageCollection" class="form-horizontal single-submit-form">' +
                                            <c:forEach items="${collectionResult.nodes}" var="node">
                                            '<div class="control-group">' +
                                            <c:set var="hasCollection" value="true"/>
                                            '<div class="controls">' +
                                            '<label class="checkbox" for="manageCollection-' + '${node.identifier}' + '">' +
                                            '<input id="manageCollection-${node.identifier}" type="checkbox" name="collectionCheckbox" value="${node.identifier}"/>' +
                                            '${functions:escapeJavaScript(node.displayableName)}' +
                                            '</label>' +
                                            '</div>' +
                                            '</div>' +
                                            </c:forEach>
                                            '</form>' +
                                            </c:if>
                                            '</div>';
                    bootbox.dialog({
                        title: wsfi18n['docnt_assignedCollections.addToCollection'],
                        message: form,
                        buttons: {
                            danger: {
                                label: wsfi18n['wsf.label.cancel'],
                                className: 'btn-default',
                                callback: function() {}
                            },
                            success: {
                                label: wsfi18n['wsf.label.yes'],
                                className: 'btn btn-primary',
                                callback: function() {
                                    showLoading(wsfi18n['wsf.title.workInProgress']);
                                    var uuids = getUuids();
                                    var datas = {
                                        'uuids':uuids,
                                        'uuidsAddCollections':getColToEdit(true),
                                        'uuidsRemoveCollections':getColToEdit(false),
                                        'action':'editCollection'
                                    };
                                    $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', datas,
                                            function (result) {
                                                location.reload(true);
                                            })
                                }
                            }
                        }
                    });
                    (function () {
                        var i = 0;
                        while (i < document.forms.manageCollection.elements.collectionCheckbox.length) {
                            document.forms.manageCollection.elements.collectionCheckbox[i].checked = false;
                            i++;
                        }
                        var uuids = getUuids();
                        var datas = {
                            'action':'getCollection',
                            'docspaceIdentifier':'${docspaceNode.identifier}',
                            'uuids':uuids
                        };
                        $.ajax({
                            url: '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>',
                            type: 'POST',
                            dataType: 'json',
                            data: datas,
                            async: false,
                            success: function (result) {
                                i = 0;
                                el = document.forms.manageCollection.elements.collectionCheckbox;
                                while (i < el.length) {
                                    if (result[el[i].value]) {
                                        el[i].checked = true;
                                    }
                                    i++;
                                }
                            }
                        });
                    })();
                </c:if>
                return false;
            },
            managePermissions : function() {
                showLoading(wsfi18n['wsf.title.workInProgress']);
                var permissionComponentUrl = "${url.context}${url.base}/modules/${script.view.module.idWithVersion}";
                permissionComponentUrl += "/templates/base/workspace-document-details/pagecontent/actions/ACTIONSLEFT/ACTIONSLEFT/bootstrap-collapsable-list/permissions/membersmanagement.docspaceObject.html.ajax?mainResource=";
                permissionComponentUrl += encodeURIComponent(getPaths()[0] + ".workspace-document-details.html");
                permissionComponentUrl += "&display_title=true&includeJavascripts=true";
                $.ajax({
                    url: permissionComponentUrl,
                    type: 'GET',
                    async: false,
                    success: function(result) {
                        bootbox.dialog({
                            title: wsfi18n['docnt_docspaceActions.managePermissions'],
                            message: result,
                            buttons: {
                                danger: {
                                    label: wsfi18n['wsf.label.cancel'],
                                    className: 'btn-default',
                                    callback: function() {}
                                },
                                success: {
                                    label: wsfi18n['wsf.label.yes'],
                                    className: 'btn btn-primary',
                                    callback: function() {

                                    }
                                }
                            }
                        });
                        hideLoading();
                    },
                    error : function() {
                        bootbox.dialog({
                            title: wsfi18n['docnt_docspaceActions.managePermissions'],
                            message: wsfi18n['docnt_docspaceActions.error.permissionsOnLoad'],
                            buttons: {
                                success: {
                                    label: wsfi18n['wsf.label.yes'],
                                    className: 'btn btn-primary',
                                    callback: function() {

                                    }
                                }
                            }
                        });
                        hideLoading();
                    }
                });
                return false;
            },
            addPoll : function() {
                <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-poll-add')}">
                    $("#modalAddPoll").modal();
                </c:if>
                return false;
            },
            addNote : function() {
                <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-note-add')}">
                    $("#modalAddNote").modal();
                </c:if>
                return false;
            },
            editNote : function() {
                <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-note-add')}">
                    $("#modalEditNote").modal();
                </c:if>
                return false;
            }
        }//MenuOnClickFunctions

        var collections = {};

        function getUuids() {
            var uuids = new Array();
            i = 0;
            $(".fileCheckbox:checked").each(function (index) {
                uuids[i++] = $(this).attr("name");
            });
            return uuids;
        }

        function getPaths() {
            var paths = new Array();
            i = 0;
            $(".fileCheckbox:checked").each(function (index) {
                paths[i++] = $(this).attr("path");
            });
            return paths;
        }

        function setUpTypeahead() {
            // typeahead
            var ta = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.whitespace(),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                remote: {
                    url: '<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.matchingTags.do'/>' + '?q=___QUERY',
                    filter: function(data) {
                        var arr = [];
                        for (var i = 0; i < data.tags.length; i++)
                            arr.push({name: data.tags[i].name});
                        return arr;
                    },
                    wildcard: '___QUERY',
                    ajax : {
                        type: "GET",
                        dataType: 'json',
                        data: {
                            limit: 5,
                            emptyResultForBadQuery: true
                        }
                    }
                },
                limit: 10
            });

            // Initialize the Bloodhound suggestion engine
            ta.initialize();

            // Instantiate the Typeahead UI
            var el = $('.tagInput_${currentNode.identifier}');
            el.tagsinput("input").typeahead(null, {
                displayKey: 'name',
                source: ta.ttAdapter(),
                highlight: true,
                autocomplete: true
            });
        }

        var Tagging = {
            addTag : function(newTag) {
                if (newTag) {
                    var options = {
                        url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.tagNodes.do"/>",
                        type: "POST",
                        dataType: "json",
                        data: {
                            'uuids':getUuids(),
                            'newTag': newTag
                        },
                        traditional: true
                    };
                    $.ajax(options).done(function (result) {});
                }
            },
            collectAvailableTags : function() {
                var self = this;
                var options = {
                    url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.tagNodes.do"/>",
                    type: "POST",
                    dataType: "json",
                    data: {
                        'uuids':getUuids(),
                        'allTags': 'getAllTags'
                    },
                    traditional: true
                };
                $.ajax(options).done(function (result) {
                    self.populateTags(result);
                });
            },
            removeTag : function(oldTag) {
                var options = {
                    url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.tagNodes.do"/>",
                    type: "POST",
                    dataType: "json",
                    data: {
                        'uuids':getUuids(),
                        'oldTag': oldTag,
                        'removeTag' : 'OK'
                    },
                    traditional: true
                };
                $.ajax(options).done(function (result) {});
            },
            populateTags : function(tags) {
                var t = tags.tags;
                for (var i = 0; i < t.length; i++)
                    $(".tagInput_${currentNode.identifier}").tagsinput('add', t[i]);
                // Set up addition listener
                $(".tagInput_${currentNode.identifier}").on("itemAdded", function(e){
                    Tagging.addTag(e.item);
                });
            }
        }// Tagging

        function parseFileCheckboxes(){
            $('.fileCheckbox').change(function () {
                var checkedLength = $("input:checkbox[class=fileCheckbox]:checked").length;
                var length = $(".fileCheckbox").length;
                if (checkedLength == length) {
                    $('.allFileCheckbox').prop("checked", true);
                } else {
                    $('.allFileCheckbox').prop("checked", false);
                }
                fileCheckBoxChecked();
            });
            $('.allFileCheckbox').click(function() {
                var state = this.checked;
                var fileCheckboxes = $('.fileCheckbox');
                $.each(fileCheckboxes, function(idx, val,f) {
                    this.checked = state;
                    if (idx == fileCheckboxes.length - 1)
                        fileCheckBoxChecked();
                });
            });
            switchClassForActionsGroups();
        }
        function switchClassForActionsGroups() {
            $("#actionButtons").find(" .btn:visible").removeClass("btn-group-last-child");
            if ($("#actionButtons").find(" .btn:visible").length > 1) {
                $("#actionButtons").addClass("btn-group");
                $("#actionButtons").find(" .btn:visible").last().addClass("btn-group-last-child");
            } else {
                $("#actionButtons").removeClass("btn-group");
            }
        }
        $(document).ready(function () {
            setUpTypeahead();
            //Manipulate bootstrap tagging view
            $(document).on('hide.bs.modal', function() {
                if ($(".TaggingActive")[0]) {
                    $("#tagging_${currentNode.identifier}").removeClass("TaggingActive");
                    $("#tagging_${currentNode.identifier}").hide();
                    $("#tagging_${currentNode.identifier}").appendTo('body');
                    $(".tagInput_${currentNode.identifier}").unbind("itemAdded");
                }
            });
            //Tagging listeners
            $(".tagInput_${currentNode.identifier}").on("itemRemoved", function(e) {
                Tagging.removeTag(e.item);
            });

            // Set JQuery to traditional
            $.ajaxSetup({traditional: true, cache:false});

            $('.pasteItemOp, .itemOp,.singleItemOp,.restrictedItemOp,.restrictedSingleItemOp,.nonfolderItemOp,.nonfolderSingleItemOp,.restrictedFolderItemOp,.noSingleItemOp,.lockedItemOp').hide();

            $.post("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.checkclipboard.do'/>", {},
                    function (data) {
                        if (data != null && data.size > 0) {
                            MenuOnClickFunctions.hasItemsToPaste = true;
                            $("#pasteFile").show();
                        }
                        else {
                            MenuOnClickFunctions.hasItemsToPaste = false;
                            $("#pasteFile").hide();
                        }
                    }, "json");

            function getText(node) {
                return node["nodename"];
            }

            function format(result) {
                return getText(result["node"]);
            }

            $("#printNote").click(function(){
                $(this).target = "_blank";
                window.open($(this).prop('href'));
                return false;
            });

            $("form.single-submit-form").submit(function (evt) {
                if (!evt.isDefaultPrevented()) {
                    $(":submit", this).css("display", "none").after("<span><img src='" + "<c:url value='/modules/assets/css/images/indicator.gif'/>" + "' /></span>");
                }
            });
            switchClassForActionsGroups();
        });

        function fileCheckBoxChecked() {
            var n = $(".fileCheckbox:checked").length;
            if (n == 0) {
                if (!MenuOnClickFunctions.hasItemsToPaste){
                    $('.pasteItemOp .itemOp,.singleItemOp,.restrictedItemOp,.restrictedSingleItemOp,.nonfolderItemOp,.nonfolderSingleItemOp,.noSingleItemOp,.lockedItemOp,.restrictedFolderItemOp').hide('fast',switchClassForActionsGroups);
                }
                else {
                    $('.itemOp,.singleItemOp,.restrictedItemOp,.restrictedSingleItemOp,.nonfolderItemOp,.nonfolderSingleItemOp,.noSingleItemOp,.lockedItemOp,.restrictedFolderItemOp').hide('fast',switchClassForActionsGroups);

                }
            } else {
                var restricted = false;
                var allFiles = true;
                var allLocked = true;
                $(".fileCheckbox:checked").each(function (index) {
                    restricted = restricted || $(this).attr("class").indexOf("restricted") != -1;
                    allFiles = allFiles && $(this).attr("class").indexOf("folder") == -1;
                    allLocked = allLocked && $(this).attr("class").indexOf("locked") != -1;
                });

                $('.itemOp' +
                        (n > 1 ? ',.noSingleItemOp' : '') +
                        (n == 1 ? ',.singleItemOp' : '') +
                        (!restricted ? ',.restrictedItemOp' : '') +
                        (!restricted && n == 1 ? ',.restrictedSingleItemOp' : '') +
                        (allFiles ? ',.nonfolderItemOp' : '') +
                        (allFiles && n == 1 ? ',.nonfolderSingleItemOp' : '') +
                        (!(!allFiles && restricted) ? ',.restrictedFolderItemOp' : '') +
                        (allLocked ? ',.lockedItemOp' : '')
                ).show('fast',switchClassForActionsGroups);

                var hideList = '' +
                        (n <= 1 ? ',.noSingleItemOp' : '') +
                        (n > 1 ? ',.singleItemOp,.restrictedSingleItemOp,.nonfolderSingleItemOp' : '') +
                        (restricted ? ',.restrictedItemOp' : '') +
                        (!allFiles ? ',.nonfolderItemOp' : '') +
                        (!allFiles && restricted ? ',.restrictedFolderItemOp' : '') +
                        (!allLocked ? ',.lockedItemOp' : '');

                if (hideList.length > 0) {
                    $(hideList.substring(1)).hide('fast',switchClassForActionsGroups);
                }
            }
        }

        function getColToEdit(bool) {
            Array.prototype.isArray = true;
            var i = 0;
            var res = new Array();
            if (!document.forms.manageCollection.collectionCheckbox.isArray &&
                    document.forms.manageCollection.collectionCheckbox.checked == bool) {
                res.push(document.forms.manageCollection.collectionCheckbox.value);
            } else {
                while (i < document.forms.manageCollection.collectionCheckbox.length) {
                    if (document.forms.manageCollection.collectionCheckbox[i].checked == bool) {
                        res.push(document.forms.manageCollection.collectionCheckbox[i].value);
                    }
                    i++;
                }
            }
            return res;
        }

        function tagSelectedItems($form) {
            var separator = '${separator}';
            var $newTagInput = $form.find('input[name="newTag"]');
            var tagContainer = $("#newTagContainer");
            var options = {
                url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.tagNodes.do"/>",
                type: "POST",
                dataType: "json",
                data: {
                    'uuids':getUuids(),
                    'newTag':$newTagInput.val().split(',')
                },
                traditional: true
            };
            $.ajax(options)
                    .done(function (result) {
                        for (i = 0; i < result.addedTags.length; i++) {
                            var tagDiv = $('<div></div>').attr('style', 'display:inline');
                            var tagDisplay = $('<span class="taggeditem">' + result.addedTags[i] + '</span>');
                            if (separator.length > 0 && tagContainer.is(':parent')) {
                                tagDiv.append(separator);
                            }
                            tagDiv.append(tagDisplay);
                            tagContainer.append(tagDiv);
                        }
                        $newTagInput.val('');
                    });
        }

        <c:if test="${jcr:hasPermission(renderContext.mainResource.node.parent, 'jcr:addChildNodes_default')}">
        function convertSelectedNote() {
            var uuids = getUuids();
            var datas = {
                'uuids':uuids,
                'targetTypes':$('#convertSelectedNoteForm, input:radio[name=noteFormat]:checked').val(),
                'keepNote':$('#convertSelectedNoteForm, input:radio[name=keepNote]:checked').val()
            };
            $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.convertNote.do"/>', datas,
                    function (result) {
                        <%--TODO check actually unique --%>
                        $("<a href='" + result['fileURL'] + "' title='" + wsfi18n['docnt_docspaceActions.convertNoteSuccess'] + "' target='new'>" + wsfi18n['docnt_docspaceActions.convertNoteDownload'] + "</a>").dialog({
                            height:100,
                            modal:true,
                            zindex:9999,
                            close :function() {
                                location.reload(true);
                            }
                        });
                    },"json")
        }
        </c:if>

        var answerCount = 1;

        function removeAnswer(target) {
            $("#" + target).remove();
        }
        function addAnswer() {
            answerCount++;
            var elem = $('<div class="control-group pollAnswerForm" id="pollAnswerForm' + answerCount + '">');
            $('<label class="control-label" for="pollAnswer' + answerCount + '">' + wsfi18n['docnt_docspaceActions.poll.answer'] + '</label>').appendTo(elem);
            $('<div class="controls"><div class="input-append">' +
            '<input type="text" class="field2" id="pollAnswer' + answerCount + '" name="pollAnswer"/>' +
            '<span id="jahia_actions_remove_' + answerCount + '" title ="' + wsfi18n['docnt_docspaceActions.poll.removeAnswer'] + '" class="fa fa-remove add-on btn btn-primary" onclick="removeAnswer(\'pollAnswerForm' + answerCount + '\')"></span>').appendTo(elem);
            $(elem).appendTo("#answers");
            $(elem).find("input").focus();
        }

        function validateAnswers($pollForm) {
            var answers = [];
            var valid = true;
            $pollForm.find('input[name="pollAnswer"]').each(function() {
                var answer = $(this).val();
                if (answer == "") {
                    alert(wsfi18n['docnt_docspaceActions.poll.noAnswer']);
                    valid = false;
                    return false;
                }
                if ($.inArray(answer, answers) > -1) {
                    alert(wsfi18n['docnt_docspaceActions.poll.answerNotUnique']);
                    valid = false;
                    return false;
                } else {
                    answers.push(answer);
                }
            });
            return valid;
        }

        function lockDocument() {
            $.post("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.chain.do'/>", {type:"docspace",chainOfAction:"lock,addActivity",activityType:"docspace-lockeddoc"}, function() {
                location.reload();
            });
        }

        function requestDocumentRelease() {
            $.post("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.requestRelease.do'/>", function() {
                location.reload();
            });
        }

        function releaseDocument() {
            $.post("<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.release.do'/>", function() {
                location.reload();
            });
        }
        var WorkflowBypass = {
            bypassWorkflow : function() {
                bootbox.confirm(wsfi18n['docnt_docspaceActions.workflow.publish'], function(result) {
                    if (result) {
                        $.ajax({
                            url: "<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.bypassWorkflow.do'/>",
                            type: "post",
                            data: "type=publish",
                            success: function(result) {
                                bootbox.alert(wsfi18n['docnt_docspaceActions.workflow.success'], function() {
                                    location.reload();
                                });
                            },
                            error: function() {
                            bootbox.alert(wsfi18n['docnt_docspaceActions.workflow.error']);
                        }
                    });
                    }
                });
            }
        }
    </script>
</template:addResources>

<c:set var="parentFolder" value="${jcr:getParentOfType(renderContext.mainResource.node,'docmix:docspaceObject')}"/>
<div class="row-fluid">
    <div id="actionButtons">
        <c:if test="${not empty parentFolder and jcr:isNodeType(renderContext.mainResource.node, 'jnt:file,jnt:folder')}">
            <fmt:message key="docnt_docspaceActions.backTo" var="backTo">
                <fmt:param value="${parentFolder.displayableName}"/>
            </fmt:message>
            <a id="backToLibrary" class="btn btn-default returnLink fa fa-level-up"
               href="<c:url value="${url.base}${functions:escapePath(parentFolder.path)}.workspace-library.html"/>"
               title="${fn:escapeXml(backTo)}">
            </a>
        </c:if>
        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder')}">
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'jcr:addChildNodes_default')}">
                <fmt:message key="wsf.label.uploadFile" var="uploadFile"/>
                <button class="folderOp btn btn-default fa fa-upload" id="uploadFile"
                        onclick="return MenuOnClickFunctions.fileUpload()" title="${fn:escapeXml(uploadFile)}">
                </button>
            </c:if>
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-createFolder')}">
                <fmt:message key="docnt_docspaceActions.createFolder" var="createFolder"/>
                <a class="folderOp btn btn-default fa fa-folder" id="createFolder" href="#createFolderForm"
                   onclick="return MenuOnClickFunctions.createFolder()"
                   title="${fn:escapeXml(createFolder)}">
                </a>
            </c:if>

            <fmt:message key="wsf.label.delete" var="labelDelete"/>
            <a class="restrictedItemOp btn btn-default fa fa-trash" id="deleteFile" href="#deleteSelectedItems"
               onclick="return MenuOnClickFunctions.deleteFile()" title="${fn:escapeXml(labelDelete)}">
            </a>

            <fmt:message key="wsf.label.cut" var="labelCut"/>
            <a class="restrictedItemOp btn btn-default fa fa-scissors" id="cutFile" href="#cutSelectedItems"
               onclick="return MenuOnClickFunctions.cutItems()" title="${fn:escapeXml(labelCut)}">
            </a>

            <fmt:message key="wsf.label.copy" var="labelCopy"/>
            <a class="btn btn-default restrictedFolderItemOp fa fa-files-o" id="copyFile" href="#copySelectedItems"
               onclick="return MenuOnClickFunctions.copyItems()" title="${fn:escapeXml(labelCopy)}">
            </a>

            <fmt:message key="wsf.label.paste" var="labelPaste"/>
            <a class="btn btn-default fa fa-clipboard pasteItemOp" id="pasteFile" href="#pasteSelectedItems"
               onclick="return MenuOnClickFunctions.pasteItems()" title="${fn:escapeXml(labelPaste)}">
            </a>

            <fmt:message key="wsf.label.rename" var="labelRename"/>
            <a class="btn btn-default restrictedSingleItemOp fa fa-pencil" id="renameFile" href="#renameSelectedItem"
               onclick="return MenuOnClickFunctions.renameItem()" title="${fn:escapeXml(labelRename)}">
            </a>

            <fmt:message key="wsf.label.permissions" var="labelPermissions"/>
            <a class="btn btn-default restrictedSingleItemOp fa fa-ban" id="changePermissions"
               onclick="return MenuOnClickFunctions.managePermissions()" title="${fn:escapeXml(labelPermissions)}">
            </a>

            <fmt:message key="docnt_docspaceActions.rss.feed" var="rssFeed"/>
            <template:addResources type="inline">
                <link rel="alternate" type="application/rss+xml"
                      title="${fn:escapeXml(rssFeed)} - ${!empty docspaceNode.properties["jcr:title"] ? docspaceNode.properties["jcr:title"].string : docspaceNode.name}"
                      href="<c:url value='${url.base}${functions:escapePath(docspaceNode.path)}.rss'/>"/>
            </template:addResources>

            <a class="btn btn-default folderOp fa fa-rss" title="${fn:escapeXml(rssFeed)}"
               href="<c:url value='${url.base}${functions:escapePath(docspaceNode.path)}.rss'/>">
            </a>

            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-manageCategory')}">
                <fmt:message key="docnt_docspaceActions.tags" var="labelTags"/>
                <a class="btn btn-default nonfolderItemOp fa fa-tags tagItems" id="tagFile" href="#tagSelectedItems"
                   onclick="return MenuOnClickFunctions.addTags()" title="${fn:escapeXml(labelTags)}">
                </a>
            </c:if>

            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-force-unlock')}">
                <fmt:message key="wsf.label.unlock" var="labelUnlock"/>
                <a class="btn btn-default lockedItemOp fa fa-unlock unlockItems" href="#unlockSelectedItems"
                   onclick="return MenuOnClickFunctions.unlock()" title="${fn:escapeXml(labelUnlock)}">
                </a>
            </c:if>
        </c:if>

        <c:forEach items="${renderContext.mainResource.node.lockInfos}" var="entry">
            <c:forEach items="${entry.value}" var="lock">
                <c:if test="${fn:substringAfter(lock,':') eq 'docspace'}">
                    <c:set value="${fn:substringBefore(lock,':')}" var="lockOwner"/>
                    <c:if test="${renderContext.user.name eq lockOwner}">
                        <c:set var="isCurrentUserLockOwner" value="true"/>
                    </c:if>
                </c:if>
                <c:if test="${fn:substringAfter(lock,':') ne 'docspace'}">
                    <c:set value="true" var="externalLock"/>
                </c:if>
            </c:forEach>
        </c:forEach>

        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:file')}">
            <a class="btn btn-default fa fa-download" id="download" href="${renderContext.mainResource.node.url}" title='<fmt:message key="docnt_docspaceActions.downloadACopy"/>'></a>
            <c:if test="${doc:isOfficeDocument(renderContext.mainResource.node) && doc:isUserOSWindows(header['User-Agent'])}">
                <fmt:message key="wsf.label.openInOffice" var="openInOffice"/>
                <a title="${fn:escapeXml(openInOffice)}" target="_blank"
                   class="btn btn-default fa fa-windows"
                   href="${doc:getOpenInMSOfficeURL(renderContext.mainResource.node, url, renderContext)}">
                </a>
            </c:if>

            <c:forEach items="${renderContext.mainResource.node.linearVersionInfos}" var="v">
                <c:if test="${fn:startsWith(v.label, 'default_validated')}">
                    <c:set value="${v.label}"  var="latestValidated"/>
                </c:if>
            </c:forEach>
            <c:if test="${not empty latestValidated}">
                <fmt:message key="docnt_docspaceActions.downloadLastValidatedVersion" var="downloadLastValidatedVersion"/>
                <a class="btn btn-default fa fa-arrow-down" id="downloadLatestValidated"
                   href="${renderContext.mainResource.node.url}?l=${latestValidated}"
                   title="${fn:escapeXml(downloadLastValidatedVersion)}"></a>
            </c:if>
            <c:if test="${not empty lockOwner and (isCurrentUserLockOwner eq 'true' or currentUser.root) and jcr:hasPermission(renderContext.mainResource.node, 'jcr:modifyProperties_default') and jcr:hasPermission(renderContext.mainResource.node, 'docspace-document-release')}">
                <fmt:message key="wsf.label.unlockDocument" var="unlockDocument"/>
                <a class="btn btn-default fa fa-unlock" id="release" href="#"
                   onclick="releaseDocument();return false;"
                   title="${fn:escapeXml(unlockDocument)}"></a>
            </c:if>
            <c:if test="${not empty lockOwner and empty isCurrentUserLockOwner and not isReleaseRequestSent}">
                <fmt:message key="docnt_docspaceActions.unlockDocumentRequest" var="unlockDocumentRequest"/>
                <a class="btn btn-default fa fa-unlock" id="requestRelease" href="#"
                   onclick="requestDocumentRelease();return false;"
                   title="${fn:escapeXml(unlockDocumentRequest)}"></a>
            </c:if>

            <fmt:message key="docnt_docspaceActions.workflow.viewWorkflowStatus" var="viewWorkflowStatus"/>
            <a class="btn btn-default fa fa-spinner workflowStatusLink" id="viewWorkflowStatus" href="#"
               onclick="viewWorkflowStatus();return false;"
               title="${fn:escapeXml(viewWorkflowStatus)}"></a>

            <c:if test="${not externalLock and (empty lockOwner or isCurrentUserLockOwner)}">
                <fmt:message key="docnt_docspaceActions.workflow.startWorkflow" var="startWorkflow"/>
                <a class="btn btn-default fa fa-play-circle-o workflowStartLink hidden-phone" id="startWorkflow" href="#"
                   onclick="startCurrentWorkflow();return false;" title="${fn:escapeXml(startWorkflow)}"></a>
                <c:if test="${jcr:hasPermission(currentNode.user, 'publish')}">
                    <fmt:message key="docnt_docspaceActions.workflow.publishDocument" var="publishDocument"/>
                    <a class="btn btn-default fa fa-sign-out" id="bypassWorkflow" href="#"
                       onclick="WorkflowBypass.bypassWorkflow()" title="${fn:escapeXml(publishDocument)}"></a>
                </c:if>
            </c:if>
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'jcr:modifyProperties_default')}">
                <c:if test="${not externalLock and (empty lockOwner or isCurrentUserLockOwner)}">
                    <fmt:message key="docnt_docspaceActions.uploadVersion" var="uploadVersion"/>
                    <a id="uploadVersion" class="btn btn-default fa fa-upload" href="#uploadFileForm"
                       onclick="return MenuOnClickFunctions.fileUpload()"
                       title="${fn:escapeXml(uploadVersion)}">
                    </a>
                </c:if>
                <c:if test="${not externalLock and empty lockOwner and jcr:hasPermission(renderContext.mainResource.node, 'docspace-document-lock')}">
                    <fmt:message key="docnt_docspaceActions.lockDocument" var="lockDocument"/>
                    <a class="btn btn-default fa fa-lock" id="lock" href="#"
                       onclick="lockDocument();return false;"
                       title="${fn:escapeXml(lockDocument)}"></a>
                </c:if>
            </c:if>
            <c:if test="${not empty lockOwner and empty isCurrentUserLockOwner}">
                <jcr:jqom var="result" statement="select * from [jnt:task] where ischildnode('${functions:sqlencode(renderContext.mainResource.node.path)}/tasks') and [type] = 'releaseRequest' and [jcr:createdBy] = '${currentUser.name}'"/>
                <c:set var="isReleaseRequestSent" value="${result.nodes.size > 0}" />
                <fmt:message key="docnt_docspaceActions.documentLockedBy">
                    <fmt:param value="${lockOwner}"/>
                </fmt:message>
                <c:if test="${result.nodes.size > 0}">
                    ${' '}
                    <fmt:message key="docnt_docspaceActions.releaseRequestSent"/>
                </c:if>
            </c:if>
            <c:if test="${isCurrentUserLockOwner eq 'true'}">
                <jcr:jqom var="result" statement="select * from [jnt:task] where ischildnode('${functions:sqlencode(renderContext.mainResource.node.path)}/tasks') and [type] = 'releaseRequest'"/>
                <fmt:message key="docnt_docspaceActions.documentLockedByYou"/>
                <c:if test="${result.nodes.size > 0}">
                    ${' '}<fmt:message key="docnt_docspaceActions.documentReleaseRequested"/>
                </c:if>
            </c:if>
        </c:if>

        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer') and (renderContext.mainResource.template eq 'default' or renderContext.mainResource.template eq 'workspace-notes')}">
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-note-add')}">
                <fmt:message key="docnt_docspaceActions.createNote" var="createNote"/>
                <a class="btn btn-default notesContainerOp fa fa-plus-circle" id="createNote" href="#"
                   onclick="MenuOnClickFunctions.addNote()"
                   title="${fn:escapeXml(createNote)}"></a>
            </c:if>

            <fmt:message key="wsf.label.delete" var="labelDelete"/>
            <a class="btn btn-default restrictedItemOp fa fa-trash" id="deleteNote" href="#deleteSelectedItems"
               onclick="return MenuOnClickFunctions.deleteFile()" title="${fn:escapeXml(labelDelete)}">
            </a>

            <%--<c:if test="${jcr:hasPermission(renderContext.mainResource.node.parent, 'jcr:addChildNodes_default')}">
                <a class="restrictedItemOp " id="convertNote" href="#convertSelectedNote">
                <fmt:message key="wsf.label.convert"/></a>
            </c:if>--%>
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-manageCategory')}">
                <fmt:message key="docnt_docspaceActions.tags" var="labelTags"/>
                <a class="btn btn-default nonfolderItemOp  fa fa-tags tagItems" id="tagNote" href="#tagSelectedItems"
                   onclick="return MenuOnClickFunctions.addTags()" title="${fn:escapeXml(labelTags)}">
                </a>
            </c:if>

            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-force-unlock')}">
                <fmt:message key="wsf.label.unlock" var="labelUnlock"/>
                <a class="btn btn-default lockedItemOp fa fa-unlock" href="#unlockSelectedItems"
                   title="${fn:escapeXml(labelUnlock)}"></a>
            </c:if>
        </c:if>

        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer') and renderContext.mainResource.template eq 'workspace-note-creation'}">
            <fmt:message key="docnt_docspaceActions.backToNotes" var="backToNotes"/>
            <a href="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-notes.html'/>"
               class="returnLink" title="${fn:escapeXml(backToNotes)}">
                    ${backToNotes}
            </a>
        </c:if>

        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:note')}">
            <fmt:message key="docnt_docspaceActions.backToNotes" var="backToNotes"/>
            <a href="<c:url value="${url.base}${functions:escapePath(jcr:getParentOfType(renderContext.mainResource.node,'docnt:notesContainer').path)}.workspace-notes.html"/>"
               class="btn btn-default fa fa-level-up" title="${fn:escapeXml(backToNotes)}"></a>

            <c:if test="${(renderContext.mainResource.template eq 'default' or renderContext.mainResource.template eq 'workspace-note-details') and (empty lockOwner or isCurrentUserLockOwner) and jcr:hasPermission(renderContext.mainResource.node, 'jcr:write_default')}">
                <fmt:message key="docnt_docspaceActions.editNote" var="editNote"/>
                <a class="btn btn-default fa fa-pencil" href="#" onclick="MenuOnClickFunctions.editNote()"
                   title="${fn:escapeXml(editNote)}"></a>
            </c:if>

            <fmt:message key="docnt_docspaceActions.printNote" var="printNote"/>
            <a href="<c:url value="${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-note-print.html"/>"
               class="btn btn-default fa fa-print" id="printNote" title="${fn:escapeXml(printNote)}"></a>
        </c:if>

        <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-collections-add')}">
            <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder') or jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer')}">
                <fmt:message key="docnt_assignedCollections.create" var="createCollection"/>
                <a class="btn btn-default nonfolderItemOp fa fa-bookmark" id="createCollection" href="#createCollectionForm"
                   onclick="return MenuOnClickFunctions.createCollection()"
                   title="${fn:escapeXml(createCollection)}">
                </a>

                <c:if test="${not empty hasCollection}">
                    <fmt:message key="docnt_assignedCollections.addToCollection" var="addToCollection"/>
                    <a class="btn btn-default nonfolderItemOp fa fa-bookmark-o" id="manageCollection"
                       href="#manageCollectionForm" onclick="return MenuOnClickFunctions.manageCollection()"
                       title="${fn:escapeXml(addToCollection)}">
                    </a>
                </c:if>
            </c:if>
        </c:if>

        <c:if test="${jcr:hasPermission(renderContext.mainResource.node.parent, 'docspace-collections-add') and (renderContext.mainResource.template eq 'workspace-note-details' or renderContext.mainResource.template eq 'workspace-document-details')}">
            <fmt:message key="docnt_assignedCollections.create" var="createCollection"/>
            <a class="btn fa fa-bookmark" id="createCollection" href="#createCollectionForm"
               onclick="return CollectionManagerDocspaceAction.createCollection()"
               title="${fn:escapeXml(createCollection)}">
            </a>

            <c:if test="${not empty hasCollection}">
                <fmt:message key="docnt_assignedCollections.addToCollection" var="addToCollection"/>
                <a class="btn fa fa-bookmark-o" id="manageCollection" href="#manageCollectionForm"
                   onclick="return CollectionManagerDocspaceAction.manageCollection()"
                   title="${fn:escapeXml(addToCollection)}">
                </a>
            </c:if>

            <script type="text/javascript">
                var CollectionManagerDocspaceAction = {
                    createCollection : function() {
                        var box = bootbox.dialog({
                            title: wsfi18n['docnt_assignedCollections.create'],
                            message: '<form id="formCreateCollection" name="createCollection" class="single-submit-form">' +
                            '<input type="text" class="input-block-level" value="" name="collection"/>' +
                            '</form>',
                            buttons: {
                                danger: {
                                    label: wsfi18n['wsf.label.cancel'],
                                    className: 'btn-default',
                                    callback: function() {}
                                },
                                success: {
                                    label: wsfi18n['docnt_assignedCollections.create'],
                                    className: 'btn btn-primary',
                                    callback: function() {
                                        showLoading(wsfi18n['wsf.title.workInProgress']);
                                        var str = document.getElementById("formCreateCollection").elements["collection"].value;
                                        var uuids = ['${renderContext.mainResource.node.identifier}'];
                                        var data = {
                                            'jcr:title':str,
                                            'docspaceIdentifier':'${renderContext.mainResource.node.parent.identifier}',
                                            'action':'addCollection',
                                            'uuids':uuids
                                        };
                                        $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', data,
                                                function (result) {
                                                    var redirectUrl = '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.${renderContext.mainResource.template}.html"/>';
                                                    if (result.collection != undefined) {
                                                        redirectUrl += "?collection=" + encodeURIComponent(decodeURIComponent(result.collection));
                                                    }
                                                    location.replace(redirectUrl);
                                                }, "json");
                                    }
                                }
                            }
                        });
                        $(document).on('shown.bs.modal', function() {
                            var elem = document.forms['createCollection'].elements['collection'].focus();
                        });
                        box.modal("show");
                        return false;
                    },
                    manageCollection : function() {
                        var form =  '<div id="manageCollectionForm">' +
                                                <c:if test="${not empty docspaceNode}">
                                                '<form name="manageCollection" class="form-horizontal single-submit-form">' +
                                                <c:forEach items="${collectionResult.nodes}" var="node">
                                                '<div class="control-group">' +
                                                <c:set var="hasCollection" value="true"/>
                                                '<div class="controls">' +
                                                '<label class="checkbox" for="manageCollection-' + '${node.identifier}' + '">' +
                                                '<input id="manageCollection-${node.identifier}" type="checkbox" name="collectionCheckbox" value="${node.identifier}"/>' +
                                                '${functions:escapeJavaScript(node.displayableName)}' +
                                                '</label>' +
                                                '</div>' +
                                                '</div>' +
                                                </c:forEach>
                                                '</form>' +
                                                </c:if>
                                                '</div>';
                        bootbox.dialog({
                            title: wsfi18n['docnt_assignedCollections.addToCollection'],
                            message: form,
                            buttons: {
                                danger: {
                                    label: wsfi18n['wsf.label.cancel'],
                                    className: 'btn-default',
                                    callback: function() {}
                                },
                                success: {
                                    label: wsfi18n['wsf.label.ok'],
                                    className: 'btn btn-primary',
                                    callback: function() {
                                        showLoading(wsfi18n['wsf.title.workInProgress']);
                                        var uuids = ['${renderContext.mainResource.node.identifier}'];
                                        var datas = {
                                            'uuids':uuids,
                                            'uuidsAddCollections':getColToEdit(true),
                                            'uuidsRemoveCollections':getColToEdit(false),
                                            'action':'editCollection'
                                        };
                                        $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', datas,
                                                function (result) {
                                                    location.reload(true);
                                                })
                                    }
                                }
                            }
                        });
                        (function () {
                            var i = 0;
                            while (i < document.forms.manageCollection.elements.collectionCheckbox.length) {
                                document.forms.manageCollection.elements.collectionCheckbox[i].checked = false;
                                i++;
                            }
                            var uuids = ['${renderContext.mainResource.node.identifier}'];
                            var datas = {
                                'action':'getCollection',
                                'docspaceIdentifier':'${docspaceNode.identifier}',
                                'uuids':uuids
                            };
                            $.ajax({
                                url: '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>',
                                type: 'POST',
                                dataType: 'json',
                                data: datas,
                                async: false,
                                success: function (result) {
                                    i = 0;
                                    el = document.forms.manageCollection.elements.collectionCheckbox;
                                    while (i < el.length) {
                                        if (result[el[i].value]) {
                                            el[i].checked = true;
                                        }
                                        i++;
                                    }
                                }
                            });
                        })();
                        return false;
                    }
                }
            </script>
        </c:if>

        <c:if test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:pollsContainer')}">
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-poll-add')}">
                <fmt:message key="docnt_docspaceActions.createPoll" var="createPoll"/>
                <a class="btn btn-default votesContainerOP fa fa-bar-chart-o" id="createPoll"
                   href="#createPollPopup" onclick="return MenuOnClickFunctions.addPoll()"
                   title="${fn:escapeXml(createPoll)}">
                </a>
            </c:if>
            <fmt:message key="wsf.label.delete" var="labelDelete"/>
            <a class="btn btn-default restrictedItemOp fa fa-trash" id="deletePoll" href="#"
               onclick="return MenuOnClickFunctions.deleteFile()" title="${fn:escapeXml(labelDelete)}">
            </a>
        </c:if>
    </div>
</div>
<hr/>
<c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-poll-add')}">
    <%@include file="createPollForm.jspf" %>
</c:if>

<c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-note-add')}">
    <%@include file="createNoteForm.jspf" %>
</c:if>

<c:if test="${(renderContext.mainResource.template eq 'default' or renderContext.mainResource.template eq 'workspace-note-details') and (empty lockOwner or isCurrentUserLockOwner) and jcr:hasPermission(renderContext.mainResource.node, 'jcr:write_default')}">
    <%@include file="editNoteForm.jspf" %>
</c:if>

<div class="hide height-250" id="tagging_${currentNode.identifier}">
    <fmt:message key="jnt_tagging.docspace.addTags" var="addTags"/>
    <input class="tagInput_${currentNode.identifier}" type="text" value="" data-role="tagsinput"
           placeholder="${fn:escapeXml(addTags)}"/>
</div>

<%@include file="uploadModal.jspf" %>
