<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib prefix="bootstrap" uri="http://www.jahia.org/tags/bootstrapLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="loading.css" />
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="loading.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#docspaceFormCreation_${currentNode.identifier}').on('submit', function () {
                if ($('#title_${currentNode.identifier}').val() == '') {
                    $('#errorEmptyTitle_${currentNode.identifier}').show();
                    return false;
                } else {
                    $('#errorEmptyTitle_${currentNode.identifier}').hide();
                    showLoading(wsfi18n['wsf.title.workInProgress']);
                    return true;
                }
            });
        });
    </script>
</template:addResources>

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
    <h3>${fn:escapeXml(currentNode.displayableName)}</h3>
</div>

<template:tokenizedForm>
    <form class="form-horizontal no-margin-bottom <c:if test="${not empty currentNode.properties['class']}">${currentNode.properties['class'].string}</c:if>"
          method="POST" id="docspaceFormCreation_${currentNode.identifier}"
          action="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(currentNode.properties.targetFolder.node.path)}/*'/>">
        <div class="modal-body">
            <input type="hidden" name="jcrNodeType" value="jnt:folder">
            <input type="hidden" name="jcrNewNodeOutputFormat" value="html">
            <input type="hidden" name="jcrNormalizeNodeName" value="true"/>
            <input type="hidden" name="jcrAutoAssignRole" value="docspace-owner"/>
            <input type="hidden" name="jcr:mixinTypes" value="docmix:docspace"/>
            <%--<input type="hidden" name="j:splitConfig" value="date,jcr:created,yyyy-MM-dd"/>--%>
            <%--<input type="hidden" name="j:splitNodeType" value="jnt:folder"/>--%>
            <c:if test="${currentNode.properties.stayOnPage.boolean}">
                <input type="hidden" name="jcrRedirectTo"
                       value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
            </c:if>

            <div class="control-group">
                <label class="control-label" for="title_${currentNode.identifier}">
                    <fmt:message key="wsf.label.title"/>
                </label>
                <div class="controls">
                    <input type="text" name="jcr:title" id="title_${currentNode.identifier}" value=""/>
                    <span id="errorEmptyTitle_${currentNode.identifier}" class="text-error hide">
                        <fmt:message key="wsf.label.noTitle"/>
                    </span>
                </div>
            </div>
            <c:if test="${currentNode.properties['useDescription'].boolean}">
                <div class="control-group">
                    <label class="control-label" for="description_${currentNode.identifier}">
                        <fmt:message key="wsf.label.description"/>
                    </label>
                    <div class="controls">
                        <textarea name="jcr:description" id="description_${currentNode.identifier}" cols="45" rows="3"></textarea>
                    </div>
                </div>
            </c:if>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
                <fmt:message key="wsf.label.close"/>
            </button>
            <button type="submit" class="btn btn-primary">
                <fmt:message key='wsf.label.create'/>
            </button>
        </div>
    </form>
</template:tokenizedForm>