<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}.addMemberToAcl.do"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            refreshMoment();
        });
    </script>
</template:addResources>

<div class="page-header">
    <h1 class="text-info">
        <i class="fa fa-suitcase"></i>&nbsp;${boundComponent.displayableName}
    </h1>

    <p>
        <small>
            <div>
                <span class=""><fmt:message key="docnt_docspaceHeader.workspaceCreatedOn"/>:&nbsp;
            <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                  data-moment-locale="${currentResource.locale}"
                  data-moment="<fmt:formatDate value="${boundComponent.properties['jcr:created'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span></span>&nbsp;&nbsp;&nbsp;
            <span class="muted"><fmt:message
                    key="wsf.label.createdBy"/>:&nbsp;${boundComponent.properties['jcr:createdBy'].string}</span>&nbsp;&nbsp;&nbsp;
                <c:set var="owners" value=""/>
                <c:forEach items="${boundComponent.aclEntries}" var="entry">
                    <c:forEach items="${entry.value}" var="details">
                        <c:if test="${details[0] eq boundComponent.path and details[1] eq 'GRANT' and details[2] eq 'docspace-owner'}">
                            <c:set var="owners"
                                   value="${owners}${not empty owners ? ', ' : ''}${fn:substringAfter(entry.key, ':')}"/>
                        </c:if>
                    </c:forEach>
                </c:forEach>
                <span class="muted"><fmt:message
                        key="docnt_docspaceHeader.owner"/>&nbsp;${fn:escapeXml(owners)}</span>

                <%--<div class="dav-info">--%>
                    <%--<div class="alert alert-info">--%>
                        <%--<h4><fmt:message key="docnt_docspaceHeader.title.davInstructions"/></h4>--%>

                        <%--<p>--%>
                            <%--<fmt:message key="docnt_docspaceHeader.message.davInstructions"/>--%>
                        <%--</p>--%>
                    <%--</div>--%>
                <%--</div>--%>
            </div>

        </small>
    </p>
    <c:if test="${not empty boundComponent.properties['jcr:description'].string}">
        <p class="thumbnail">${boundComponent.properties['jcr:description'].string}</p>
    </c:if>
</div>
<c:forEach items="${boundComponent.aclEntries}" var="entry">
    <c:if test="${fn:substringAfter(entry.key, 'u:') eq renderContext.user.username}">
        <c:forEach items="${entry.value}" var="details">
            <c:if test="${details[0] eq boundComponent.path and details[1] eq 'GRANT'}">
                <c:set var="currentRole" value="${details[2]}"/>
            </c:if>
        </c:forEach>
    </c:if>
</c:forEach>
<c:if test="${not empty currentRole}">
    <template:addResources>
        <script type="text/javascript">
            function doResign(memKey, redirect, outputFormat) {
                bootbox.dialog({
                    title: wsfi18n['docnt_docspaceHeader.resignQuestion'],
                    message: wsfi18n['docnt_docspaceHeader.resignClarification'],
                    buttons: {
                        main: {
                            label: wsfi18n['wsf.label.cancel'],
                            className: 'btn-default',
                            callback: function() {}
                        },
                        danger: {
                            label: wsfi18n['wsf.label.ok'],
                            className: 'btn-danger',
                            callback: function() {
                                showLoading(wsfi18n['wsf.title.workInProgress']);
                                $.ajax({
                                    url: '${postUrl}',
                                    data: "memberKey=" + memKey + "&jcrRedirectTo=" + redirect + "&jcrNewNodeOutputFormat=" + outputFormat,
                                    success: function () {
                                        window.location.assign(redirect + "." + outputFormat);
                                    },
                                    error: function () {
                                        bootbox.alert(wsfi18n['docnt_docspaceHeader.couldNotEvictMessage']);
                                    }
                                });
                            }
                        }
                    }
                });
            }
        </script>
    </template:addResources>

    <jcr:node var="adminSite" path="/sites/wsfaccess"/>
    <div class="alert alert-info">
        <div class="row-fluid">
            <fmt:message key="wsf.role.${currentRole}.short" var="i18nRole"/>
            <fmt:message key="docnt_docspaceHeader.ismember">
                <fmt:param value="${i18nRole}"/>
            </fmt:message>
            <a href="#" onclick="doResign('u:${renderContext.user.username}','<c:url
                    value='${url.baseLive}${functions:escapePath(renderContext.user.localPath)}'/>', 'workspace-user.html?jsite=${adminSite.identifier}')">
                <fmt:message key='docnt_docspaceHeader.docspace.resign'/>
            </a>
        </div>
    </div>
</c:if>
