<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<dl class="dl-horizontal docspace-info">
<jcr:sql var="files" sql="select count AS [rep:count(skipChecks=1;approxCountLimit=1000)] from [jnt:file] where isdescendantnode('${functions:sqlencode(boundComponent.path)}') and [jnt:file].[jcr:language] is null"/>
<c:forEach var="row" items="${files.rows}" end="0">
    <c:choose>
        <c:when test="${row.values[1].boolean}">
            <c:set var="nbOfDocuments">
                <fmt:message key="docnt_docspaceInfo.approximateCount">
                    <fmt:param value="${row.values[0].long}" />
                </fmt:message>
            </c:set>
        </c:when>
        <c:otherwise>
            <c:set var="nbOfDocuments" value="${row.values[0].long}" />
        </c:otherwise>
    </c:choose>
</c:forEach>
    <c:set var="toStringNbOfDocuments">${nbOfDocuments}</c:set>
    <c:set var="marginLeft" value="${fn:length(toStringNbOfDocuments) * 10}px"/>
    <dt onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}.workspace-library.html'/>'" style="cursor: pointer;">${nbOfDocuments}</dt>
    <dd onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}.workspace-library.html'/>'" style="cursor: pointer; margin-left: ${marginLeft}"><fmt:message key="wsf.label.documents"/></dd>

<jcr:sql var="notes" sql="select count AS [rep:count(skipChecks=1;approxCountLimit=1000)] from [docnt:note] where isdescendantnode('${functions:sqlencode(boundComponent.path)}') and [docnt:note].[jcr:language] is null"/>
<c:forEach var="row" items="${notes.rows}" end="0">
    <c:choose>
        <c:when test="${row.values[1].boolean}">
            <c:set var="nbOfNotes">
                <fmt:message key="docnt_docspaceInfo.approximateCount">
                    <fmt:param value="${row.values[0].long}" />
                </fmt:message>
            </c:set>
        </c:when>
        <c:otherwise>
            <c:set var="nbOfNotes" value="${row.values[0].long}" />
        </c:otherwise>
    </c:choose>
</c:forEach>
    <dt onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}/notes.workspace-notes.html'/>'" style="cursor: pointer;">${nbOfNotes}</dt>
    <dd onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}/notes.workspace-notes.html'/>'" style="cursor: pointer; margin-left: ${marginLeft}"><fmt:message key="wsf.label.notes"/></dd>

<jcr:sql var="polls" sql="select count AS [rep:count(skipChecks=1;approxCountLimit=1000)] from [jnt:poll] where isdescendantnode('${functions:sqlencode(boundComponent.path)}') and [jnt:poll].[status] = 'open'"/>
<c:forEach var="row" items="${polls.rows}" end="0">
    <c:choose>
        <c:when test="${row.values[1].boolean}">
            <c:set var="nbOfPolls">
                <fmt:message key="docnt_docspaceInfo.approximateCount">
                    <fmt:param value="${row.values[0].long}" />
                </fmt:message>
            </c:set>
        </c:when>
        <c:otherwise>
            <c:set var="nbOfPolls" value="${row.values[0].long}" />
        </c:otherwise>
    </c:choose>
</c:forEach>

    <dt onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}/polls.workspace-polls.html'/>'" style="cursor: pointer;">${nbOfPolls}</dt>
    <dd onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}/polls.workspace-polls.html'/>'" style="cursor: pointer; margin-left: ${marginLeft}"><fmt:message key="wsf.label.polls"/></dd>

<jsp:useBean id="members" class="java.util.HashSet" type="java.util.Set" />
<c:forEach items="${boundComponent.aclEntries}" var="entry">
    <c:if test="${entry.key != 'g:guest'}">
        <c:forEach items="${entry.value}" var="details">
            <c:if test="${details[0] eq boundComponent.path and details[1] eq 'GRANT'}">
                <c:set var="memberName" value="${entry.key}"/>
                <% members.add(pageContext.findAttribute("memberName")); %>
            </c:if>
        </c:forEach>
    </c:if>
</c:forEach>
    <dt onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}.workspace-members.html'/>'" style="cursor: pointer;">${fn:length(members)}</dt>
    <dd onclick="window.location='<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(boundComponent.path)}.workspace-members.html'/>'" style="cursor: pointer; margin-left: ${marginLeft}"><fmt:message key="wsf.label.members"/></dd>
</dl>