<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.min.css"/>
<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>

<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/locales/bootstrap-datetimepicker.${currentResource.locale}.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>

<c:url value='${url.findUser}' var="findUserURL">
    <c:if test="${not empty currentNode.properties['checkRolesOnMainResource'] and currentNode.properties['checkRolesOnMainResource'].boolean and not empty currentNode.properties['rolesList']}">
        <c:set var="roles" value=""/>
        <jcr:nodeProperty node="${currentNode}" name="rolesList" var="rolesList"/>
        <c:forEach items="${rolesList}" var="roleNode">
            <c:set var="roleName" value="${roleNode.node.name}"/>
            <c:set var="roles" value="${roles} ${roleName}"/>
        </c:forEach>
        <c:param name="node" value="${renderContext.mainResource.node.path}"/>
        <c:param name="roles" value="${roles}"/>
    </c:if>
</c:url>

<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:set var="termFieldsForSearch" value="siteContent,files"/>
<c:set var="searchNodeType" value="docmix:docspaceObject"/>
<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:notesContainer')}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchNotes"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:pollsContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:pollsContainer')}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchPolls"/>
    </c:when>
    <c:when test="${renderContext.mainResource.template eq 'workspace-library' or (not jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace') and (jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder') or jcr:isNodeType(renderContext.mainResource.node, 'jnt:file')))}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchLibrary"/>
        <c:set var="termFieldsForSearch" value="files"/>
        <c:if test="${sessionScope.docListView eq 'gallery'}">
            <c:set var="searchNodeType" value="jmix:image"/>
        </c:if>
    </c:when>
    <c:otherwise>
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchWorkspaces"/>
    </c:otherwise>
</c:choose>

<template:addCacheDependency uuid="${currentNode.properties.result.string}"/>
<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.${renderContext.mainResource.template}.html' var="searchUrl"/>

<div class="span12">
    <div class="row-fluid">
        <script type="text/javascript">
            function advancedSearchRebuilder() {
                var createdBy = '${renderContext.request.parameterMap['src_createdBy'][0]}';
                var editedBy = '${renderContext.request.parameterMap['src_lastModifiedBy'][0]}';
                var fileType = '${renderContext.request.parameterMap['src_fileType'][0]}';
                var createdDate = '${renderContext.request.parameterMap['src_created.type'][0]}';
                var modifiedDate = '${renderContext.request.parameterMap['src_lastModified.type'][0]}';
                var language = '${renderContext.request.parameterMap['src_languages.values'][0]}';
                var createdByFull = '${renderContext.request.parameterMap['src_createdByFull'][0]}';
                var editedByFull = '${renderContext.request.parameterMap['src_lastModifiedByFull'][0]}';

                var selectLanguage = '${renderContext.request.parameterMap['languageSelected'][0]}';
                var selectCreatedOn = '${renderContext.request.parameterMap['createdOnSelected'][0]}';
                var selectModifiedOn = '${renderContext.request.parameterMap['modifiedOnSelected'][0]}';
                var openSearch = false;

                if (createdBy != "" || fileType != "" || editedBy != "") {
                    openSearch = true;
                    if (createdBy != "") {
                        $("#searchCreatedByTH").val(createdByFull).focus().focusout();
                        $("#createdByFullName").val(createdByFull);
                        $("#searchCreatedByValue").val(createdBy);
                    }
                    if (editedBy != "") {
                        $("#searchLastModifiedByTH").val(editedBy).focus().focusout();
                        $("#lastModifiedByFullName").val(editedByFull);
                        $("#searchLastModifiedBy").val(editedBy);
                    }
                    if (fileType != "") {
                        $("#searchFileType").val(fileType).change();
                    }
                }

                if (selectCreatedOn != "" || selectModifiedOn != "" || selectLanguage != "") {
                    openSearch = true;
                    if (selectCreatedOn != "") {
                        $("#searchCreated").val(createdDate).change();
                        if (createdDate == "range") {
                            $("#src_created_from").val('${renderContext.request.parameterMap['src_created.from'][0]}');
                            $("#src_created_to").val('${renderContext.request.parameterMap['src_created.to'][0]}');
                        }
                    }
                    if (selectModifiedOn != "") {
                        $("#searchLastModified").val(modifiedDate).change();
                        if (modifiedDate == "range") {
                            $("#src_lastModified_from").val('${renderContext.request.parameterMap['src_lastModified.from'][0]}');
                            $("#src_lastModified_to").val('${renderContext.request.parameterMap['src_lastModified.to'][0]}');
                        }
                    }
                }

                if (openSearch) {
                    if (language == "en") {
                        $("#searchLanguage").show().prop("selectedIndex", 1).change();
                    }
                    else {
                        $("#searchLanguage").val(language).change();
                    }
                    $("#advancedSearch").click();
                }
            }
            $(document).ready(function(){
                (function setDatePicker() {
                    for (var i = 0; i < 4; i++){
                        $('#datetimepicker_${currentNode.identifier}_' + i).datetimepicker({
                            language: '${currentResource.locale}',
                            pickTime: false
                        }).on('changeDate', function() {
                            if ($('.datepicker-days').css('display') === 'block')
                                $('.bootstrap-datetimepicker-widget').hide();
                        });
                    }
                })();

                // typeahead
                var taskAssigneeTH = new Bloodhound({
                    datumTokenizer: Bloodhound.tokenizers.whitespace(),
                    queryTokenizer: Bloodhound.tokenizers.whitespace,
                    remote: {
                        url: '${findUserURL}' + "?q=___QUERY",
                        wildcard: '___QUERY',
                        ajax : {
                            type: "GET",
                            dataType: 'json',
                            data: {
                                limit: 4
                            }
                        },
                        filter: function(users) {
                            return $.map(users, function(user) {
                                var value = user['j:firstName'] || '';
                                if (value.length != 0) {
                                    value += ' ';
                                }
                                value += user['j:lastName'] || '';
                                var title = value.length > 0 ? value : user['username'];
                                var username = user['username'];
                                return {
                                    userName: username != title ? title + " (" + username + ")" : username,
                                    userKey: user['userKey']
                                };
                            });
                        }
                    },
                    limit: 4
                });

                // Initialize the Bloodhound suggestion engine
                taskAssigneeTH.initialize();

                // Instantiate the Typeahead UI
                $('.ShiftedInput').typeahead(null, {
                    displayKey: 'userName',
                    source: taskAssigneeTH.ttAdapter(),
                    highlight: true,
                    autocomplete: true
                });

                // Event to get selected or autocompleted value
                $('#searchCreatedByTH, #searchLastModifiedByTH').bind('typeahead:selected', function(obj, datum){
                    var field = $(this).parent().parent().parent().find('.ShiftedInputValue');
                    var fieldFull = $(this).parent().parent().parent().find('.ShiftedInputValueFull');
                    field.val(datum['userKey'].split("/").slice(-1)[0]);
                    fieldFull.val(datum['userName']);
                });

                $("#advancedSearch, #advancedSearch2").on("click", function() {
                    if($(this).html().trim() == "Advanced search") {
                        $("#appendage").hide();
                        $(this).hide();
                        $("#lowerSubmit").show();
                        $("#advancedSearch2").show();
                        $("#additionalFields").css("overflow",  "visible");
                    }
                    else {
                        $("#additionalFields").css("overflow",  "hidden");
                        $(".removeInputShifter").each(function() {
                            $(this).click();
                        });
                        $(".removeSelectShifter").each(function() {
                            $(this).click();
                        });
                        $(".SelectorChanged").each(function() {
                            $(this).val("");
                        });
                        $("#appendage").show();
                        $(this).hide();
                        $("#lowerSubmit").hide();
                        $("#advancedSearch").show();
                    }
                });
                $(".selection_${currentNode.identifier}").on("change", function() {
                    if ($(this).attr("id") == "searchCreated") {
                        ($(this).val() == "range") ? $("#range-0").show() : $("#range-0").hide();
                    }
                    if ($(this).attr("id") == "searchLastModified") {
                        ($(this).val() == "range") ? $("#range-1").show() : $("#range-1").hide();
                    }
                });

                $(document).on("click", ".removeInputShifter", function() {
                    var shifterGroup = $(this).parent().parent().parent();
                    shifterGroup.find(".Shifter").hide();
                    shifterGroup.find(".thWrap").show();
                    shifterGroup.find(".ShiftedInputValue").val("");
                    setTimeout(function() {
                        shifterGroup.find(".ShiftedInput").each(function() {$(this).val("");});
                    }, 25);
                });
                $(".ShiftedInput").on("focusout", function() {
                    if ($(this).val().trim() != "") {
                        var shifterGroup = $(this).parent().parent().parent();
                        shifterGroup.find(".thWrap").hide();
                        var shifter = shifterGroup.find(".Shifter");
                        shifter.show();
                        shifter.find(".label").html($(this).attr("placeholder") + " : " + $(this).val() + "<span class='removeInputShifter'>&#10006;</span>");

                        //Set values if have not been set by TH
                        var name = shifterGroup.find(".ShiftedInputValue");
                        var displayName = shifterGroup.find(".ShiftedInputValueFull");
                        if (name.val().trim() == "") {
                            name.val($(this).val().trim());
                            displayName.val($(this).val().trim());
                        }
                    }
                    else {
                        var tweeterTypeahead = $(this).parent();
                        setTimeout(function() {
                            tweeterTypeahead.find(".ShiftedInput").each(function() {$(this).val("");});
                        }, 25);
                    }
                });

                $(document).on("click", ".removeSelectShifter", function() {
                    var shifterGroup = $(this).parent().parent().parent();
                    shifterGroup.find(".SelectorChanged").val("");
                    var range0 = shifterGroup.find("#range-0");
                    var range1 = shifterGroup.find("#range-1");
                    if (range0 != null)
                        range0.hide();
                    if (range1 != null)
                        range1.hide();
                    shifterGroup.find(".Shifter").hide();
                    shifterGroup.find(".ShiftedSelect").show().prop('selectedIndex', 0);
                });
                $(".ShiftedSelect").on("change", function() {
                    $(this).hide();
                    var parent = $(this).parent();
                    parent.find(".SelectorChanged").val("true");
                    var shifter = $(this).parent().find(".Shifter");
                    shifter.show();
                    shifter.find(".label").html(parent.find(".ShiftedName").html() +" : "+ $("#" + $(this).attr("id") + " option:selected").text() + "<span class='removeSelectShifter'>&#10006;</span>");
                });

                //Add event handlers to both buttons
                $("#appendage, #lowerSubmit").on("click", function(){
                    var searchField = $("#searchTermDisplay");
                    if ($(this).attr("id") == "appendage" && searchField.val().trim() == "") {
                        bootbox.alert(wsfi18n['docnt_docspaceSearchForm.enterSearchCriteria']);
                        return false;
                    }
                    if(searchField.val().trim() == "")
                        $("#searchTerm").val("*");
                    else
                        $("#searchTerm").val(searchField.val())
                    return true;
                });

                (function(){
                    $(".tt-dropdown-menu").each(function(){$(this).css("z-index", 2147483647)});
                })();

                (function(){
                    <c:if test="${renderContext.request.parameterMap['src_terms[0].term'][0] ne '*'}">
                        $("#searchTermDisplay").val("${renderContext.request.parameterMap['src_terms[0].term'][0]}");
                        $("#searchTerm").val("${renderContext.request.parameterMap['src_terms[0].term'][0]}");
                    </c:if>
                })();

                advancedSearchRebuilder();
            });
        </script>
        <s:form method="post" class="" action="${searchUrl}">
            <div class="input-append input-block-level" id="searchBar">
                <input class="span11" id="searchTermDisplay" type="text" value="" placeholder="${defaultSearchString}">
                <input id="searchTerm" type="hidden" value="" name="src_terms[0].term">
                <input type="hidden" value="true" name="src_terms[0].applyFilter">
                <input type="hidden" value="all_words" name="src_terms[0].match">
                <input type="hidden" value="true" name="src_terms[0].fields.tags">
                <c:if test="${!jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer')}">
                    <input type="hidden" value="true" name="src_terms[0].fields.files">
                </c:if>
                <button class="btn btn-primary" type="submit" id="appendage">
                    <i class="fa fa-search"></i>
                </button>
            </div>
            <s:filePath value="${renderContext.mainResource.node.path}" display="false" includeChildren="true"/>

            <div class="span12">
                <a type="button" id="advancedSearch" class="pull-right cursor-pointer" data-toggle="collapse" data-target="#additionalFields">
                    <fmt:message key="docnt_docspaceSearchForm.advancedSearch"/>
                </a>
            </div>
            <div class="row-fluid collapse" id="additionalFields">

                <div class="FormShifterGroup">
                    <div class="thWrap">
                        <input class="span12 typeahead ShiftedInput" id="searchCreatedByTH" type="text" value="" placeholder="Author">
                    </div>
                    <input class="ShiftedInputValue" id="searchCreatedByValue" type="hidden" value="" name="src_createdBy">
                    <input class="ShiftedInputValueFull" id="createdByFullName" type="hidden" value="" name="src_createdByFull">

                    <div class="Shifter TopLevelShifter hide">
                        <span class="label label-info"></span>
                    </div>
                </div>

                <div class="FormShifterGroup">
                    <div class="thWrap">
                        <input class="span12 typeahead ShiftedInput" id="searchLastModifiedByTH" type="text" value="" placeholder="Last Editor">
                    </div>
                    <input class="ShiftedInputValue" id="searchLastModifiedBy" type="hidden" value="" name="src_lastModifiedBy">
                    <input class="ShiftedInputValueFull" id="lastModifiedByFullName" type="hidden" value="" name="src_lastModifiedByFull">

                    <div class="Shifter hide">
                        <span class="label label-info"></span>
                    </div>
                </div>

                <c:if test="${renderContext.mainResource.node.name ne 'notes'}">
                    <div class="FormShifterGroup">
                        <label class="hide ShiftedName"><fmt:message key="docnt_docspaceSearchForm.fileType"/></label>
                        <select id="searchFileType" class="span12 ShiftedSelect" name="src_fileType">
                            <option value=""><fmt:message key="docnt_docspaceSearchForm.fileType"/></option>
                            <option value=""><fmt:message key="docnt_docspaceSearchForm.any"/></option>
                            <option value="image"><fmt:message key="docnt_docspaceSearchForm.image"/></option>
                            <option value="pdf"><fmt:message key="docnt_docspaceSearchForm.pdf"/></option>
                            <option value="word"><fmt:message key="docnt_docspaceSearchForm.word"/></option>
                            <option value="rtf"><fmt:message key="docnt_docspaceSearchForm.rtf"/></option>
                            <option value="excel"><fmt:message key="docnt_docspaceSearchForm.excel"/></option>
                            <option value="powerpoint"><fmt:message key="docnt_docspaceSearchForm.powerpoint"/></option>
                            <option value="openoffice"><fmt:message key="docnt_docspaceSearchForm.openoffice"/></option>
                            <option value="archive"><fmt:message key="docnt_docspaceSearchForm.archive"/></option>
                            <option value="video"><fmt:message key="docnt_docspaceSearchForm.video"/></option>
                        </select>
                        <input class="SelectorChanged" type="hidden" name="fileTypeSelected" value=""/>
                        <div class="Shifter hide">
                            <span class="label label-info"></span>
                        </div>
                    </div>
                </c:if>

                <div class="FormShifterGroup">
                    <label class="hide ShiftedName"><fmt:message key="wsf.label.created"/></label>
                    <select class="span12 ShiftedSelect selection_${currentNode.identifier}" id="searchCreated"
                            name="src_created.type">
                        <option value="anytime"><fmt:message key="wsf.label.created"/></option>
                        <option value="anytime"><fmt:message key="docnt_docspaceSearchForm.anytime"/></option>
                        <option value="today"><fmt:message key="wsf.label.today"/></option>
                        <option value="last_week"><fmt:message key="docnt_docspaceSearchForm.lastweek"/></option>
                        <option value="last_month"><fmt:message key="docnt_docspaceSearchForm.lastmonth"/></option>
                        <option value="last_three_months"><fmt:message key="docnt_docspaceSearchForm.last3months"/></option>
                        <option value="last_six_months"><fmt:message key="docnt_docspaceSearchForm.last6months"/></option>
                        <option value="range"><fmt:message key="docnt_docspaceSearchForm.range"/></option>
                    </select>

                    <input class="SelectorChanged" type="hidden" name="createdOnSelected" value=""/>

                    <div class="Shifter hide">
                        <span class="label label-info"></span>
                    </div>

                    <div id="range-0" class="hide">
                        <label><fmt:message key="wsf.label.from"/></label>
                        <div id="datetimepicker_${currentNode.identifier}_0" class="input-append">
                            <input data-format="dd.MM.yyyy" class="span12"
                                   type="text" name="src_created.from" id="src_created_from"
                                   value="" readonly="readonly"/>
                                <span class="add-on">
                                    <i data-time-icon="fa fa-clock-o" data-date-icon="fa fa-calendar"></i>
                                </span>
                        </div>

                        <label><fmt:message key="docnt_docspaceSearchForm.to"/></label>
                        <div id="datetimepicker_${currentNode.identifier}_1" class="input-append">
                            <input data-format="dd.MM.yyyy" class="span12"
                                   type="text" name="src_created.to" id="src_created_to"
                                   value="" readonly="readonly"/>
                                <span class="add-on">
                                    <i data-time-icon="fa fa-clock-o" data-date-icon="fa fa-calendar"></i>
                                </span>
                        </div>
                    </div>
                </div>

                <div class="FormShifterGroup">
                    <label class="hide ShiftedName"><fmt:message key="wsf.label.modified"/></label>
                    <select class="span12 ShiftedSelect selection_${currentNode.identifier}" id="searchLastModified"
                            name="src_lastModified.type">
                        <option value="anytime"><fmt:message key="wsf.label.modified"/></option>
                        <option value="anytime"><fmt:message key="docnt_docspaceSearchForm.anytime"/></option>
                        <option value="today"><fmt:message key="wsf.label.today"/></option>
                        <option value="last_week"><fmt:message key="docnt_docspaceSearchForm.lastweek"/></option>
                        <option value="last_month"><fmt:message key="docnt_docspaceSearchForm.lastmonth"/></option>
                        <option value="last_three_months"><fmt:message key="docnt_docspaceSearchForm.last3months"/></option>
                        <option value="last_six_months"><fmt:message key="docnt_docspaceSearchForm.last6months"/></option>
                        <option value="range">date range...</option>
                    </select>

                    <input class="SelectorChanged" type="hidden" name="modifiedOnSelected" value=""/>

                    <div class="Shifter hide">
                        <span class="label label-info"></span>
                    </div>

                    <div id="range-1" class="hide">
                        <label><fmt:message key="wsf.label.from"/></label>

                        <div id="datetimepicker_${currentNode.identifier}_2" class="input-append">
                            <input data-format="dd.MM.yyyy" class="span12"
                                   type="text" name="src_lastModified.from" id="src_lastModified_from"
                                   value="" readonly="readonly"/>
                        <span class="add-on">
                            <i data-time-icon="fa fa-clock-o" data-date-icon="fa fa-calendar"></i>
                        </span>
                        </div>

                        <label><fmt:message key="docnt_docspaceSearchForm.to"/></label>

                        <div id="datetimepicker_${currentNode.identifier}_3" class="input-append">
                            <input data-format="dd.MM.yyyy" class="span12"
                                   type="text" name="src_lastModified.to" id="src_lastModified_to"
                                   value="" readonly="readonly"/>
                        <span class="add-on">
                            <i data-time-icon="fa fa-clock-o" data-date-icon="fa fa-calendar"></i>
                        </span>
                        </div>
                    </div>
                </div>

                <div class="FormShifterGroup">
                    <label class="hide ShiftedName"><fmt:message key="wsf.label.language"/></label>
                    <select class="span12 ShiftedSelect" id="searchLanguage" name="src_languages.values">
                        <option value="en"><fmt:message key="wsf.label.language"/></option>
                        <c:forEach items="${renderContext.site.activeLanguagesAsLocales}"  var="availableLocale">
                            <option value="${availableLocale}">${functions:displayLocaleNameWith(availableLocale, currentResource.locale)}</option>
                        </c:forEach>
                    </select>

                    <input class="SelectorChanged" type="hidden" name="languageSelected" value=""/>

                    <div class="Shifter hide">
                        <span class="label label-info"></span>
                    </div>
                </div>

                <button class="btn btn-primary pull-right hide" type="submit" id="lowerSubmit">
                    <i class="fa fa-search"></i>
                </button>

                <div class="span12">
                    <a type="button" id="advancedSearch2" class="pull-right hide cursor-pointer" data-toggle="collapse" data-target="#additionalFields">
                        <fmt:message key="docnt_docspaceSearchForm.basicSearch"/>
                    </a>
                </div>
            </div>
        </s:form>
    </div>
</div>