<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:set var="termFieldsForSearch" value="siteContent,files"/>
<c:set var="searchNodeType" value="docmix:docspaceObject"/>
<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:notesContainer')}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchNotes"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:pollsContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:pollsContainer')}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchPolls"/>
    </c:when>
    <c:when test="${renderContext.mainResource.template eq 'workspace-library' or (not jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace') and (jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder') or jcr:isNodeType(renderContext.mainResource.node, 'jnt:file')))}">
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchLibrary"/>
        <c:set var="termFieldsForSearch" value="files"/>
        <c:if test="${sessionScope.docListView eq 'gallery'}">
            <c:set var="searchNodeType" value="jmix:image"/>
        </c:if>
    </c:when>
    <c:otherwise>
        <fmt:message var="defaultSearchString" key="docnt_docspaceSearchForm.searchWorkspaces"/>
    </c:otherwise>
</c:choose>

<template:addCacheDependency uuid="${currentNode.properties.result.string}"/>
<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.${renderContext.mainResource.template}.html' var="searchUrl"/>

<s:form method="post" class="" action="${searchUrl}">
    <div class="input-append input-block-level">
        <s:term match="all_words" id="searchTerm" value="${fn:escapeXml(defaultSearchString)}" searchIn="${termFieldsForSearch}" onfocus="if(this.value=='${functions:escapeJavaScript(defaultSearchString)}')this.value='';" onblur="if(this.value=='')this.value='${functions:escapeJavaScript(defaultSearchString)}';" class="span11"/>
        <button class="btn btn-primary" type="submit">
            <i class="fa fa-search"></i>
        </button>
    </div>
    <s:filePath value="${renderContext.mainResource.node.path}" display="false" includeChildren="true"/>
    <s:nodeType value="${searchNodeType}" display="false"/>

</s:form>

