<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:set var="filesToIgnore" value="*.ds_store,__macosx,.thumbdb,thumbs.db,*.ini"/>
<jcr:node var="rootCategory" path="/sites/systemsite/categories"/>
<jcr:nodeProperty node="${renderContext.mainResource.node}" name="categoryRoot" var="categoryRoot"/>

<c:if test="${not empty categoryRoot}">
    <c:set var="categoryPath" value="${categoryRoot.node.path}"/>
</c:if>

<template:addResources type="css" resources="jquery.fileupload.css"/>
<template:addResources type="css" resources="contentinfo.css"/>
<template:addResources type="css" resources="proton/style.min.css"/>
<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.fileupload-with-ui.min.js"/>
<template:addResources type="javascript" resources="jstree.min.js"/>
<template:addResources type="javascript" resources="bootstrap-tab.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            // Handle help
            $(".control-group").hover(function () {
                if (this.id != null && this.id != "") {
                    var groupID = '#help_' + this.id;
                    $("#setting_help").html("<h4>" + $(groupID).data('help-title') + "</h4>" + $(groupID).html());
                } else {
                    $("#setting_help").html("");
                }
            }, function() {
                $("#setting_help").html("");
            });

            getCurrentTabAndAccordionCookie();
        });//document ready

        function setCurrentTabAndAccordionCookie(tabID, accordionID) {
            var d = new Date();
            d.setTime(d.getTime() + (60 * 1000));
            document.cookie = 'displayTab=' + tabID + '; expires=' + d.toUTCString();
            document.cookie = encodeURIComponent('displayAccordion') + '=' + encodeURIComponent(accordionID) + '; expires=' + d.toUTCString();
        }

        function getCurrentTabAndAccordionCookie() {
            var cookies = document.cookie.split(';');
            for (var i = 0 ; i < cookies.length ; i ++) {
                var cookie = cookies[i];
                while (cookie.charAt(0) === ' ') cookie = cookie.substring(1, cookie.length);
                if (cookie.indexOf('displayTab') === 0) {
                    var tabID = decodeURIComponent(cookie.substring('displayTab'.length + 1, cookie.length));
                }
                if (cookie.indexOf('displayAccordion') === 0) {
                    var accordionID = decodeURIComponent(cookie.substring('displayAccordion'.length + 1, cookie.length));
                }
            }
            if (tabID !== undefined && tabID !== '') {
                $('a[href=#' + tabID + ']').click();
            }
            if (accordionID !== undefined && accordionID !== '') {
                $('a[href=#' + accordionID + ']').click();
            }
            setCurrentTabAndAccordionCookie('', '');
        }
    </script>
</template:addResources>

<ul class="nav nav-tabs">
    <c:if test="${jcr:hasPermission(docspaceNode, 'docspace-settings-main')}" var="hasAccessToMainSettings">
        <li class="dropdown active">
            <fmt:message key="docnt_docspaceSettings.mainSettings" var="mainSettings"/>
            <a href="#mainSettingsTab" data-toggle="tab" title="${fn:escapeXml(mainSettings)}">
                ${mainSettings}
            </a>
        </li>
    </c:if>
    <c:if test="${jcr:hasPermission(docspaceNode, 'docspace-settings-massImport')}" var="hasAccessToMassImport">
        <fmt:message key="docnt_docspaceSettings.massImport" var="massImport"/>
        <li <c:if test="${not hasAccessToMainSettings}">class="active"</c:if>>
            <a href="#massImportTab" data-toggle="tab" title="${fn:escapeXml(massImport)}">
                ${massImport}
            </a>
        </li>
    </c:if>
    <c:if test="${jcr:hasPermission(docspaceNode, 'docspace-settings-main')}" var="hasAccessToMainSettings">
        <fmt:message key="docnt_docspaceSettings.advancedFeatures" var="advancedFeatures"/>
        <li>
            <a href="#advancedSettingsTab" data-toggle="tab" title="${fn:escapeXml(advancedFeatures)}">
                ${advancedFeatures}
            </a>
        </li>
    </c:if>
</ul>

<div class="tab-content">
    <c:if test="${hasAccessToMainSettings}">
        <fmt:message key="docnt_docspaceSettings.main.subtitle" var="settings"/>
        <fmt:message key="docnt_docspaceSettings.taxonomy.subtitle" var="taxonomy"/>
        <div class="tab-pane active" id="mainSettingsTab">
            <div class="accordion" id="mainSettingsAccordion">
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#mainSettingsAccordion" href="#collapseMainSettings1"
                           title="${fn:escapeXml(settings)}">
                            ${fn:toUpperCase(settings)}
                        </a>
                    </div>
                    <div id="collapseMainSettings1" class="accordion-body collapse in">
                        <div class="accordion-inner">
                            <%@ include file="mainSettings.jspf" %>
                        </div>
                    </div>
                </div>
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#mainSettingsAccordion" href="#collapseMainSettings2"
                           title="${fn:escapeXml(taxonomy)}">
                            ${fn:toUpperCase(taxonomy)}
                        </a>
                    </div>
                    <div id="collapseMainSettings2" class="accordion-body collapse">
                        <div class="accordion-inner">
                            <%@ include file="taxonomySettings.jspf" %>
                        </div>
                    </div>
                </div>
            </div>
            <div class="clearfix"></div>
        </div>

        <div class="modal hide fade" id="uploadDictionaryForm">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h3><fmt:message key="docnt_docspaceSettings.autoTagging"/></h3>
            </div>
            <div class="modal-body">
                <template:tokenizedForm allowsMultipleSubmits="true">
                    <form class="dictionary_upload" id="dictionary_upload"
                          action="<c:url value='${url.base}${functions:escapePath(docspaceNode.path)}.uploadDictionary.do'/>"
                          method="POST" enctype="multipart/form-data" accept="application/json">
                        <div id="dictionary_upload_container">
                            <input type="file" name="file" accept="text/plain"/>
                            <button><fmt:message key="wsf.label.upload"/></button>
                            <div id="drop-box-dictionary-upload">
                                <fmt:message key="wsf.label.dropHere"/>
                            </div>
                        </div>
                        <table id="dictionary_files" class="table"></table>
                    </form>
                </template:tokenizedForm>
            </div>
            <div class="modal-footer">
                <button class="btn" data-dismiss="modal" aria-hidden="true">
                    <fmt:message key="wsf.label.close"/>
                </button>
            </div>
        </div>
    </c:if>

    <c:if test="${hasAccessToMassImport}">
        <fmt:message key="docnt_docspaceSettings.zipfilemassimport" var="massimport"/>
        <fmt:message key="docnt_docspaceSettings.mountedrepmassimport" var="mountedMassimport"/>
        <div class="tab-pane <c:if test="${not hasAccessToMainSettings}">active</c:if>" id="massImportTab">
            <div class="accordion" id="massImportAccordion">
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#massImportAccordion" href="#collapseMassImport1"
                           title="${fn:escapeXml(massimport)}">
                                ${fn:toUpperCase(massimport)}
                        </a>
                    </div>
                    <div id="collapseMassImport1" class="accordion-body collapse in">
                        <div class="accordion-inner">
                            <%@ include file="fileMassImport.jspf" %>
                        </div>
                    </div>
                </div>
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#massImportAccordion" href="#collapseMassImport2"
                           title="${fn:escapeXml(mountedMassimport)}">
                                ${fn:toUpperCase(mountedMassimport)}
                        </a>
                    </div>
                    <div id="collapseMassImport2" class="accordion-body collapse">
                        <div class="accordion-inner">
                            <%@ include file="mountImport.jspf" %>
                        </div>
                    </div>
                </div>
            </div>
            <div class="clearfix"></div>
        </div>
    </c:if>

    <c:if test="${hasAccessToMainSettings}">
        <fmt:message key="docnt_docspaceSettings.advanced.community" var="community"/>
        <fmt:message key="docnt_docspaceSettings.advanced.workflow" var="workflow"/>
        <fmt:message key="docnt_docspaceSettings.advanced.emailGateway" var="emailGateway"/>
        <fmt:message key="wsf.label.administration" var="labelAdministration"/>
        <div class="tab-pane" id="advancedSettingsTab">
            <div class="accordion" id="advancedSettingsAccordion">
                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#advancedSettingsAccordion" href="#collapseAdvancedSettings1"
                           title="${fn:escapeXml(community)}">
                                ${fn:toUpperCase(community)}
                        </a>
                    </div>
                    <div id="collapseAdvancedSettings1" class="accordion-body collapse in">
                        <div class="accordion-inner">
                            <%@ include file="communitySettings.jspf" %>
                        </div>
                    </div>
                </div>

                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#advancedSettingsAccordion" href="#collapseAdvancedSettings2"
                           title="${fn:escapeXml(workflow)}">
                                ${fn:toUpperCase(workflow)}
                        </a>
                    </div>
                    <div id="collapseAdvancedSettings2" class="accordion-body collapse">
                        <div class="accordion-inner">
                            <%@ include file="workflowSettings.jspf" %>
                        </div>
                    </div>
                </div>

                <jcr:node var="startPoint" path="/gateway/startPoints/jahia-spaces-inbox"/>
                <c:if test="${not empty startPoint and jcr:hasPermission(docspaceNode, 'docspace-settings-emailGateway')}">
                    <div class="accordion-group">
                        <div class="accordion-heading">
                            <a class="accordion-toggle" data-toggle="collapse"
                               data-parent="#advancedSettingsAccordion" href="#collapseAdvancedSettings3"
                               title="${fn:escapeXml(emailGateway)}">
                                ${fn:toUpperCase(emailGateway)}
                            </a>
                        </div>
                        <div id="collapseAdvancedSettings3" class="accordion-body collapse">
                            <div class="accordion-inner">
                                <%@ include file="mailGateway.jspf" %>
                            </div>
                        </div>
                    </div>
                </c:if>

                <div class="accordion-group">
                    <div class="accordion-heading">
                        <a class="accordion-toggle" data-toggle="collapse"
                           data-parent="#advancedSettingsAccordion" href="#collapseAdvancedSettings4"
                           title="${fn:escapeXml(labelAdministration)}">
                            <i class="fa fa-warning text-error"></i>
                                ${fn:toUpperCase(labelAdministration)}
                        </a>
                    </div>
                    <div id="collapseAdvancedSettings4" class="accordion-body collapse">
                        <div class="accordion-inner">
                            <%@ include file="deleteDocspace.jspf" %>
                        </div>
                    </div>
                </div>
            </div>
            <div class="clearfix"></div>
        </div>
    </c:if>
</div>