<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
            refreshMomentEvery(60000);
        });

        function switchDocspaceDescriptionDisplay(identifier, path) {
            $('#iconChevron_' + identifier).toggleClass('fa-chevron-up fa-chevron-down', 200);
            if ($('#iconChevron_' + identifier).attr('title') == wsfi18n['wsf.label.hide']) {
                $('#iconChevron_' + identifier).attr('title', wsfi18n['wsf.label.show']);
            } else {
                $('#iconChevron_' + identifier).attr('title', wsfi18n['wsf.label.hide']);
            }
            $('.docspaceIconChevron').each(function () {
                if (!$(this).is($('#iconChevron_' + identifier)) && $(this).hasClass('fa-chevron-up'))
                    $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
                if (!$(this).is($('#iconChevron_' + identifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                    $(this).attr('title', wsfi18n['wsf.label.show']);
            });
            $('.docspaceList').each(function () {
                if (!$(this).is($('#description_' + identifier)) && $(this).hasClass('in'))
                    $(this).collapse('hide');
            });
            if ($("#fileCount_" + identifier).html().length < 1)  {
                $("#fileCount_" + identifier).html("<img width='10' height='10' src='<c:url value='${url.currentModule}/css/img/ajax-loader.gif'/>''/>");
                $("#fileCount_" + identifier).load('<c:url value="${url.base}${functions:escapePath(currentNode.path)}.countFiles.html.ajax?path="/>' + path);
            }
        }
    </script>
</template:addResources>

<template:include view="hidden.header"/>
<table width="100%" id="docspaceListTable_${currentNode.identifier}" summary="Docspace List Table" class="table table-striped table-hover">
    <caption class="hide"></caption>
    <colgroup>
        <col width="70%">
        <col width="30%">
    </colgroup>
    <thead>
    <tr>
        <th scope="col" id="Title_${currentNode.identifier}">
            <fmt:message key="wsf.label.title"/>
        </th>
        <th scope="col" id="LastModif_${currentNode.identifier}">
            <fmt:message key="wsf.label.modified"/>
        </th>
    </tr>
    </thead>

    <tbody>
        <c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}" end="${moduleMap.end}">
            <c:url var="docspaceURL" value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(subchild.path)}.workspace-library.html"/>
            <tr>
                <td headers="Title_${currentNode.identifier}">
                    <i id="iconChevron_${subchild.identifier}"
                       class="fa fa-chevron-down fa-fw docspaceIconChevron cursor-pointer"
                       title="<fmt:message key="wsf.label.show"/>"
                       data-toggle="collapse" data-target="#description_${subchild.identifier}"
                       onclick="switchDocspaceDescriptionDisplay('${subchild.identifier}', '${functions:escapeJavaScript(subchild.path)}')"></i>
                    <a href="${docspaceURL}"><i class="fa fa-fw fa-suitcase"></i>${fn:escapeXml(subchild.displayableName)}</a>
                    <div id="description_${subchild.identifier}" class="collapse margin-left-22 docspaceList">
                        <ul class="unstyled">
                            <li>${fn:escapeXml(subchild.properties['jcr:description'].string)}</li>
                            <li><span id="fileCount_${subchild.identifier}"></span>&nbsp;<fmt:message key="wsf.label.documents"/></li>
                        </ul>
                    </div>
                </td>
                <td class="hidden-phone-portrait" headers="LastModif_${currentNode.identifier}">
                    <span class="momentToFormat" data-moment-display-type="fromNow" data-moment-locale="${currentResource.locale}"
                          data-moment="<fmt:formatDate value="${subchild.properties['jcr:lastModified'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                </td>
            </tr>
        </c:forEach>
    </tbody>
</table>
<template:include view="hidden.footer"/>