<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<jcr:node var="currentUser" path="${renderContext.user.localPath}"/>
<jcr:nodeProperty node="${currentUser}" name="notificationsSubscribed" var="notificationsSubscribed"/>

<c:if test="${not empty notificationsSubscribed}">
    <c:forEach items="${notificationsSubscribed}" var="nodePathSubscrideb">
        <c:if test="${nodePathSubscrideb.string eq boundComponent.path}">
            <c:set value="true" var="hasSubscribed"/>
        </c:if>
    </c:forEach>
</c:if>
<h3 class="documentTitle">
    <c:if test="${not empty param.collection}">
        <jcr:node var="collectionNode" uuid="${param.collection}"/>
        ${collectionNode.displayableName}
        <fmt:message key="wsf.label.in"/>
    </c:if>
    ${fn:escapeXml(boundComponent.displayableName)}
    <c:if test="${hasSubscribed}">
        <fmt:message key="docnt_documentTitle.notificationsActivatedDocument" var="notificationsActivatedDocument"/>
        <i class="fa fa-bell fa-fw text-warning" title="${fn:escapeXml(notificationsActivatedDocument)}"></i>
    </c:if>
    <c:if test="${boundComponent.locked}">
        <i class="fa fa-lock fa-fw" title="<fmt:message key="wsf.uploadFileAction.thisDocumentIsLocked"/>"></i>
    </c:if>
</h3>
<c:set var="pageNodes" value="${jcr:getParentsOfType(renderContext.mainResource.node,'docmix:docspaceObject')}"/>
<c:if test="${functions:length(pageNodes) gt 0}">
    <ul class="breadcrumb">
        <c:forEach items="${functions:reverse(pageNodes)}" var="pageNode" varStatus="status">
            <li>
                <c:url value='${url.base}${functions:escapePath(pageNode.path)}.workspace-library.html'
                       var="folderURL"/>
                <a href="${folderURL}">${fn:escapeXml(pageNode.displayableName)}</a> <span class="divider">/</span>
            </li>
        </c:forEach>
        <li class="active">${fn:escapeXml(boundComponent.name)}</li>
    </ul>
</c:if>