<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="proton/style.min.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jstree.min.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>
<c:set var="docspaceRoot" value="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace') ? renderContext.mainResource.node : jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>

<template:addResources>
    <script type="text/javascript">
        var folderTreeCurrentIdentifier = '${renderContext.mainResource.node.identifier}';
        $(document).ready(function () {
            //Display folders
            $('#folderTree_${currentNode.identifier}').jstree({
                'core': {
                    'themes': {
                        'name': 'proton',
                        'responsive': true
                    },
                    'data': {
                        'cache': false,
                        'url': function (node) {
                            if (node.id == "#") {
                                return '<c:url value="/cms/wsfactory/${renderContext.workspace}/${renderContext.mainResourceLocale}${functions:escapePath(fn:substringBefore(currentResource.path, '.default.html'))}.currentFolderTreeItem.json?docspaceRootNode=${docspaceRoot.identifier}&currentFolderIdentifier="/>'
                                        + folderTreeCurrentIdentifier;
                            }
                            else if (node.id != '${docspaceRoot.identifier}') {
                                return '<c:url value="/cms/wsfactory/${renderContext.workspace}/${renderContext.mainResourceLocale}${functions:escapePath(fn:substringBefore(currentResource.path, '.default.html'))}.currentFolderItem.json?selectedFolderIdentifier="/>'
                                        + node.id;
                            }
                        }
                    }
                },
                'plugins': ["wholerow", "sort"]
            });

            $('#folderTree_${currentNode.identifier}').on('select_node.jstree', function (e, data) {
                if (data.node.id != folderTreeCurrentIdentifier) {
                    var nodePath = data.node.original.path;
                    data.instance.deselect_node(data.node);
                    window.location.assign('<c:url value="/cms/wsfactory/default/${currentResource.locale}"/>' + nodePath + '.workspace-library.html');
                }
            }).on('ready.jstree', function (e,data){
                var top = $('.jstree-wholerow-clicked').position().top;
                $(".jstree").animate({
                    scrollTop:( top>100?top-100:0)
                });
            });


        });
    </script>
</template:addResources>

<div class="overflow-hidden">
    <div id="folderTree_${currentNode.identifier}" class="folder-tree-div">
    </div>
</div>