package docnt_folderTree.json

import groovy.json.JsonBuilder
import org.apache.taglibs.standard.functions.Functions
import org.jahia.services.content.JCRContentUtils
import org.jahia.services.content.JCRNodeWrapper
import org.jahia.utils.WebUtils

JCRNodeWrapper selectedFolder = renderContext.mainResource.getNode().getSession().getNodeByIdentifier(renderContext.request.getParameter("selectedFolderIdentifier"));

def folderItem = new JsonBuilder()
def childrenList = []
def childrens = JCRContentUtils.getChildrenOfType(selectedFolder, "docmix:docspaceFolder")
childrens.each { child ->
    def hasChild = (JCRContentUtils.getChildrenOfType(child, "docmix:docspaceFolder").size().equals(0))?false:true
    def childObj = new Folder (
            id: child.identifier,
            text: Functions.escapeXml(child.displayableName),
            path: WebUtils.escapePath(child.path),
            children: hasChild,
            state: {
                opened false
                selected false
            }
    )
    childrenList.add(childObj)
}

folderItem {
    id selectedFolder.identifier
    text Functions.escapeXml(selectedFolder.displayableName)
    path WebUtils.escapePath(selectedFolder.path)
    children childrenList
    state {
        opened true
        selected false
    }
}

println(folderItem)