<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>

<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:set var="docspaceNode" value="${jcr:getParentOfType(boundComponent, 'docmix:docspace')}"/>
<c:url var="formAction" value="${url.base}${functions:escapePath(docspaceNode.path)}/links/*"/>

<script>
    function getFormattedResult(node) {
        var nodename = node['nodename'];
        var tp = node['jcr:primaryType'];
        var title = node['jcr:title'];
        if (typeof title == 'undefined') {
            title = nodename;
        } else if (tp == 'jnt:file') {
        	title = nodename + " (" + title + ")";
        }
        return nodeTypeLabel(tp,nodename)+"&nbsp;"+title;
    }
    function parseData(data) {
        return $.map(data, function (row) {
            var node = row.node;
            if (node == undefined) {
                node = row;
            }
            return {
                data:node,
                value:node["nodename"],
                result:node["nodename"]
            }
        });
    }

    <jcr:sql var="result"
     sql="select * from [docnt:link] as link where isdescendantnode('${functions:sqlencode(docspaceNode.path)}/links') and (link.source = '${boundComponent.identifier}' or link.target = '${boundComponent.identifier}')"/>
    var linkedIDs = ['${functions:escapeJavaScript(boundComponent.path)}'];
    <c:forEach items="${result.nodes}" var="linkedNode" varStatus="status">
        linkedIDs.push('${functions:escapeJavaScript(linkedNode.properties.target.node.path)}');
        linkedIDs.push('${functions:escapeJavaScript(linkedNode.properties.source.node.path)}');
    </c:forEach>

    function setUpTypeahead() {
        $("#linkTarget_${currentNode.identifier}").typeahead("destroy");
        var typeahead = new Bloodhound({
            datumTokenizer: Bloodhound.tokenizers.whitespace(),
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            remote: {
                url: '<c:url value='/modules/api/jcr/v1/default/${currentResource.locale}/query?noLinks'/>',
                filter: function(data) {
                    var arr = [];
                    _.each(data, function(node){
                            arr.push({name: node.name, id: node.id});
                            });
                    return _.sortBy(arr,'name');
                },
                wildcard: '___QUERY',
                replace: function(url, query) {
                    var nodeType = $("input[name=resourceNodeType]:checked", "#linkResourceForm_${currentNode.identifier}").val();
                    if (nodeType == null) {
                        nodeType = "docmix:docspaceObject";
                    }
                    this.ajax.data = JSON.stringify({
                        limit: 10,
                        queryName : 'workspaceFactorySearchElementToLink',
                        parameters : [
                            nodeType,
                            '${functions:sqlencode(docspaceNode.path)}',
                            '%' + query.toLowerCase() + '%',
                            '%' + query.toLowerCase() + '%',
                            _.uniq(linkedIDs)
                        ]
                    });
                    return url + "#" + query.toLowerCase() ;
                },
                ajax : {
                    type: "POST",
                    contentType: 'application/json',
                    dataType: 'json',
                    processData:false
                }
            },
            limit: 10
        });

        typeahead.initialize();

        // Instantiate the Typeahead UI
        var t = $("#linkTarget_${currentNode.identifier}").typeahead(null, {
            displayKey: 'name',
            source: typeahead.ttAdapter(),
            highlight: true,
            autocomplete: true
        });
    }//setUpTypeahead
    
    $(document).ready(function(){
        var linkFound = false;

        <c:url value='/cms/findHistory/${currentResource.node.session.workspace.name}/${currentResource.locale}' var="dispHistURL">
            <c:param name="trackerName" value="docspaceHistory"/>
        </c:url>

        function displayHistory() {
            $.get('${dispHistURL}', null, function(result) {
                var $historyResults = $('#historyResults_${currentNode.identifier}');
                $historyResults.empty();
                $historyResults.append('<div class="control-group"><div class="controls">');
                _.each(result, function(el, index) {
                    if (_.indexOf(linkedIDs, el['path']) === -1) {
                        $historyResults.append('<label class="radio"><input type="radio" name="histolink" value="' + el['identifier'] + '" id="histolink_' + index + '"/>' + getFormattedResult(el)+"</label>");
                        $("#histolink_"+index).click(function() {
                            $("#linkTargetId_${currentNode.identifier}").val($(this).val());
                            linkFound = true;
                        });
                    }
                });
                $historyResults.append('</div></div>');
            },"json");
        }

        $("#linkedResourceSubmit_${currentNode.identifier}").click(function () {
            $("#linkResourceForm_${currentNode.identifier}").submit();
            linkFound = false;
        });

        $("#linkResourceForm_${currentNode.identifier}").submit(function () {
            return linkFound;
        });

        $("input[name=resourceNodeType]", "#linkResourceForm_${currentNode.identifier}").change(function() {
            setUpTypeahead();
        });

        setTimeout(displayHistory, 210);

        //Typeahead integration
        setUpTypeahead();

        function addResource(item) {
            linkFound = true;
            $("#linkTargetId_${currentNode.identifier}").val(item["id"]);
        }
        // Event to get selected or autocompleted value
        $("#linkTarget_${currentNode.identifier}").bind('typeahead:selected', function(obj, datum) {
            addResource(datum);
        });
        $("#linkTarget_${currentNode.identifier}").bind('typeahead:autocompleted', function(obj, datum) {
            addResource(datum);
        });
    });
</script>


<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
    <h3><fmt:message key="docnt_linkResourceForm.linkToAnotherResource"/></h3>
</div>

<form class="form-horizontal no-margin-bottom" id="linkResourceForm_${currentNode.identifier}" action="${formAction}" method="post">
    <input type="hidden" name="jcrNodeType" value="docnt:link"/>
    <input type="hidden" name="jcrAutoAssignRole" value="owner"/>
    <c:url value="${url.base}${functions:escapePath(renderContext.mainResource.node.path)}" var="redirectUrl"/>
    <input type="hidden" name="jcrRedirectTo" value="${redirectUrl}"/>
    <input type="hidden" name="jcrNewNodeOutputFormat" value="${renderContext.mainResource.template}.html"/>
    <input type="hidden" name="source" value="${boundComponent.identifier}"/>
    <div class="modal-body">
        <fieldset>
            <legend><fmt:message key="docnt_linkResourceForm.searchResourceToLink"/></legend>
            <div class="control-group">
                <label class="control-label">
                    <fmt:message key="wsf.label.from"/>
                </label>
                <div class="controls">
                    <label class="radio inline">
                        <input id="resourceNodeTypeDocument" name="resourceNodeType" type="radio"
                               value="docmix:docspaceDocument" checked="checked"/>
                        <fmt:message key="wsf.label.documents"/>
                    </label>
                    <label class="radio inline">
                        <input id="resourceNodeTypeNote" name="resourceNodeType" type="radio"
                               value="docnt:note"/>
                        <fmt:message key="wsf.label.notes"/>
                    </label>
                    <label class="radio inline">
                        <input id="resourceNodeTypePoll" name="resourceNodeType" type="radio"
                               value="jnt:poll"/>
                        <fmt:message key="wsf.label.polls"/>
                    </label>
                    <jcr:node var="forum" path="${docspaceNode.path}/forum"/>
                    <c:if test="${not empty forum}">
                        <label class="radio inline">
                            <input id="resourceNodeTypeTopic" name="resourceNodeType" type="radio"
                                   value="jnt:topic"/>
                            <fmt:message key="docnt_linkResourceForm.discussionThread"/>
                        </label>
                    </c:if>
                    <jcr:node var="wiki" path="${docspaceNode.path}/wiki"/>
                    <c:if test="${not empty wiki}">
                        <label class="radio inline">
                            <input id="resourceNodeTypeWiki" name="resourceNodeType" type="radio"
                                   value="jnt:wikiPage"/>
                            <fmt:message key="docnt_linkResourceForm.wikiEntry"/>
                        </label>
                    </c:if>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label">
                    <fmt:message key="wsf.label.search"/>
                </label>
                <div class="controls">
                    <input type="text" class="typeahead" id="linkTarget_${currentNode.identifier}"/>
                </div>
            </div>
            <input type="hidden" id="linkTargetId_${currentNode.identifier}" name="target"/>
        </fieldset>
        <fieldset>
            <legend><fmt:message key="docnt_linkResourceForm.pickFromHistory"/></legend>
            <div id="historyResults_${currentNode.identifier}"></div>
        </fieldset>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
            <fmt:message key="wsf.label.cancel"/>
        </button>
        <button type="button" class="btn btn-primary" id="linkedResourceSubmit_${currentNode.identifier}">
            <fmt:message key="wsf.label.ok"/>
        </button>
    </div>
</form>