<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css"/>
<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js"/>
<template:addResources type="javascript" resources="ajaxreplace.js"/>
<template:addResources type="javascript" resources="ckeditor/ckeditor.js"/>
<template:addResources type="javascript" resources="ckeditor/adapters/jquery.js"/>
<c:forEach items="${renderContext.mainResource.node.lockInfos}" var="entry">
    <c:forEach items="${entry.value}" var="lock">
        <c:if test="${fn:substringAfter(lock,':') eq 'docspace'}">
            <c:set value="${fn:substringBefore(lock,':')}" var="lockOwner"/>
            <c:if test="${renderContext.user.name eq lockOwner}">
                <c:set var="isCurrentUserLockOwner" value="true"/>
            </c:if>
        </c:if>
    </c:forEach>
</c:forEach>
<c:set var="formid" value="noteForm${currentNode.identifier}"/>
<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            $(".newContentCkeditorContribute${currentNode.identifier}docnt_note").each(function () {
                $(this).ckeditor(function () {
                }, {
                    toolbar_Note : [
                        ['Source'],
                        ['Bold','Italic','Underline','Strike'],
                        ['NumberedList','BulletedList','-','Blockquote'],
                        ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
                        ['Link','Unlink'],
                        ['Table'],
                        ['Format'],
                        ['TextColor','BGColor']
                    ],
                    toolbar : 'Note', filebrowserBrowseUrl: null, filebrowserFlashBrowseUrl: null, filebrowserImageBrowseUrl: null, filebrowserLinkBrowseUrl: null
                });
                $(this).data('ckeditorInstance').checkWCAGCompliance = (typeof wcagCompliant) === 'function' ? wcagCompliant : null;
            });


            $("#${formid}").validate({
                rules: {
                    'jcr:title': 'required'
                },
                'messages':{
                    'jcr:title': wsfi18n['wsf.label.noTitle']
                },
                errorClass: 'text-error',
                submitHandler: function(form) {
                    $.post($(form).attr('action'), $(form).serialize(), function() {
                        location.replace("<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-note-details.html'/>");
                    });
                }
            });

            $("#cancel${currentNode.name}").click(function(){
                location.replace("<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-note-details.html'/>");
            });

            <c:if test="${empty lockOwner or isCurrentUserLockOwner}">
            $.post("<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.chain.do'/>", {type:"docspace",chainOfAction:"lock,addActivity",activityType:"docspace-lockeddoc"});

            $(window).unload(function() {
                $.ajax({
                    url:"<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.chain.do'/>",
                    data:{type:"docspace",chainOfAction:"unlock,addActivity",activityType:"docspace-releasedoc"},
                    type:"POST",
                    async:false
                });
            });
            </c:if>
        });
    </script>
</template:addResources>

<c:choose>
    <c:when test="${empty lockOwner or isCurrentUserLockOwner}">
        <template:tokenizedForm>
            <form method="post" class="form-horizontal"
                  action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>"
                  id="${formid}">
                <input type="hidden" name="jcrNodeType" value="docnt:note">
                <input type="hidden" name="jcrMethodToCall" value="put"/>
                <input type="hidden" name="jcrRedirectTo" value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <input type="hidden" name="jcrNewNodeOutputFormat" value="workspace-note-details.html"/>

                <div class="control-group">
                    <label class="control-label" for="title"><fmt:message key="wsf.label.title"/></label>

                    <div class="controls">
                        <input type="text" name="jcr:title" id="title" class="span12"
                               value="${currentNode.properties['jcr:title'].string}" tabindex="20"/>
                    </div>
                </div>

                <div class="control-groupl">
                    <label class="control-label" for="editContent_${currentNode.identifier}"><fmt:message key="docnt_note.body"/></label>

                    <div class="controls">
                    <textarea name="body" id="editContent_${currentNode.identifier}"
                              class="newContentCkeditorContribute${currentNode.identifier}docnt_note" cols="45" rows="3"
                              tabindex="22">${currentNode.properties['body'].string}</textarea>
                    </div>
                </div>
                <br/>
                <div class="control-group">
                    <div class="controls">
                        <button type="submit" class="btn btn-primary">
                            <fmt:message key="wsf.label.ok"/>
                        </button>
                        <button type="button" class="btn" id="cancel${currentNode.name}">
                            <fmt:message key="wsf.label.cancel"/>
                        </button>
                    </div>
                </div>
            </form>
        </template:tokenizedForm>
    </c:when>
    <c:otherwise>
        <fmt:message key="docnt_note.locked" />
    </c:otherwise>
</c:choose>