package jnt_folder.json

import groovy.json.JsonBuilder
import groovy.json.StringEscapeUtils
import org.apache.taglibs.standard.functions.Functions
import org.jahia.services.content.JCRContentUtils
import org.jahia.services.search.Hit
import org.jahia.utils.WebUtils

def searchParamSet = false;
def childrens;

def params = ["src_terms[0].term", "src_createdBy", "src_lastModifiedBy", "src_fileType", "createdOnSelected",
              "src_created.from", "src_lastModified.from", "languageSelected"];

params.eachWithIndex { item, index ->
    if (renderContext.request.parameterMap[item] != null && renderContext.request.parameterMap[item][0] != "") {
        searchParamSet = true
    }
}

if(moduleMap.resultsHits != null && searchParamSet){
    childrens =  moduleMap.resultsHits;
} else if(moduleMap.currentList != null){
    childrens = moduleMap.currentList;
} else {
    childrens = JCRContentUtils.getChildrenOfType(renderContext.mainResource.node, "jnt:note")
}

def jsonBuilder = new JsonBuilder()
def list = []
childrens.eachWithIndex { child, idx ->
    if(child instanceof Hit) {
        child = child.rawHit;
    }
    def fileCheckboxClass="fileCheckbox"
    if(child.hasPermission("jcr:modifyProperties_default") && child.isLocked()){
        fileCheckboxClass += " restricted"
    }
    if(child.isLocked()){
        fileCheckboxClass += " locked"
    }
    def name = child.getProperty("jcr:title").getString();

    def element = []

    element.add([
            identifier: child.identifier,
            path: WebUtils.escapePath(child.path),
            fullName: Functions.escapeXml(name),
            css: fileCheckboxClass
    ])
    element.add([
            locked: child.isLocked(),
            identifier: child.identifier,
            path: WebUtils.escapePath(child.path),
            fullName: Functions.escapeXml(name),
            css: fileCheckboxClass
    ])
    element.add(child.getProperty("jcr:created").string)
    element.add(child.getProperty("jcr:lastModified").string )
    element.add(child.getProperty("jcr:createdBy").string)
    list.add(element)
}
jsonBuilder(data: list)
println(jsonBuilder.toPrettyString())