<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="vendor/bootstrap-switch/bootstrap-switch.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-switch/bootstrap-switch.min.js"/>
<template:addResources type="javascript" resources="notificationsUtils.js"/>

<c:set value="false" var="hasSubscribed"/>

<c:choose>
    <c:when test="${not empty param['bindedComponent']}">
        <c:set var="bindedComponent" value="${param['bindedComponent']}"/>
    </c:when>
    <c:otherwise>
        <c:set var="bindedComponent" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
    </c:otherwise>
</c:choose>

<jcr:node var="currentUser" path="${renderContext.user.localPath}"/>
<jcr:nodeProperty node="${currentUser}" name="notificationsSubscribed" var="notificationsSubscribed"/>

<c:if test="${not empty notificationsSubscribed}">
    <c:forEach items="${notificationsSubscribed}" var="nodePathSubscrideb">
        <c:if test="${nodePathSubscrideb.string eq bindedComponent.path}">
            <c:set value="true" var="hasSubscribed"/>
        </c:if>
    </c:forEach>
</c:if>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#notificationsSubscriber_${currentNode.identifier}').bootstrapSwitch().on('switchChange.bootstrapSwitch', function(event, state) {
                var action;
                if (state) {
                    action = 'subscribe';
                } else {
                    action = 'unsubscribe';
                }
                toggleNotifications('<c:url value="${url.baseLive}/sites/wsfaccess/home.manageNotifications.do"/>',
                                        action, '${bindedComponent.identifier}', window.location.reload());
            });
        });
    </script>
</template:addResources>

<form class="form-horizontal">
    <div class="control-group">
        <label class="control-label">
            <fmt:message key="docnt_notificationsSubcriber.subscribeToNotifications"/>
        </label>
        <div class="controls">
            <input id="notificationsSubscriber_${currentNode.identifier}" type="checkbox" <c:if test="${hasSubscribed}">checked</c:if>>
        </div>
    </div>
</form>
