<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="facet" uri="http://www.jahia.org/tags/facetLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="loading.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="loading.js"/>

<fmt:message key="wsf.label.hide" var="labelHide"/>
<fmt:message key="wsf.label.show" var="labelShow"/>

<jsp:useBean id="sitesIntancesWithNonMemberSpaces" class="java.util.HashMap"/>
<jcr:sql var="allspaces" sql="select * from [docmix:docspace] order by [jcr:created] desc" useRootUser="true" />
<c:forEach items="${allspaces.nodes}" var="space" varStatus="status">
    <c:remove var="userSpace"/>
    <jcr:node var="userSpace" uuid="${space.identifier}"/>
    <c:if test="${empty userSpace or not jcr:hasPermission(userSpace, 'docspace-note')}">
        <c:set target="${sitesIntancesWithNonMemberSpaces}" property="${space.resolveSite.siteKey}" value="${space.resolveSite}"/>
    </c:if>
</c:forEach>
<c:forEach items="${sitesIntancesWithNonMemberSpaces}" var="site" varStatus="status">
    <c:choose>
        <c:when test="${empty uuidSql}">
            <c:set var="uuidSql" value="[jcr:uuid] = '${site.value.identifier}'"/>
        </c:when>
        <c:otherwise>
            <c:set var="uuidSql" value="${uuidSql} or [jcr:uuid] = '${site.value.identifier}'"/>
        </c:otherwise>
    </c:choose>
</c:forEach>

<script type="text/javascript">
    $(document).ready(function() {
        $('.spaceCheckbox_${currentNode.identifier}').change(function () {
            var n = $(".spaceCheckbox_${currentNode.identifier}:checked").length;
            if (n == 0) {
                $('#available-workspace_${currentNode.identifier} button').attr("disabled","disabled");
            } else {
                $('#available-workspace_${currentNode.identifier} button').removeAttr("disabled");
            }
        });
    });

    function switchWorkspaceRequestListDisplay(identifier) {
        $('#iconChevron_' + identifier).toggleClass('fa-chevron-down fa-chevron-up', 200);
        if ($('#linkCollapse_' + identifier).attr('title') == wsfi18n['wsf.label.hide']) {
            $('#linkCollapse_' + identifier).attr('title', wsfi18n['wsf.label.show']);
        } else {
            $('#linkCollapse_' + identifier).attr('title', wsfi18n['wsf.label.hide']);
        }
        $('.workspaceRequestIconChevron').each(function () {
            if (!$(this).is($('#iconChevron_' + identifier)) && $(this).hasClass('fa-chevron-up'))
                $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
        });
        $('.workspaceRequestLink').each(function () {
            if (!$(this).is($('#linkCollapse_' + identifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                $(this).attr('title', wsfi18n['wsf.label.show']);
        });
        $('.workspaceRequestList').each(function () {
            if (!$(this).is($('#collapse_' + identifier)) && $(this).hasClass('in'))
                $(this).collapse('hide');
        });
    }
</script>
<c:if test="${fn:length(sitesIntancesWithNonMemberSpaces) > 0}">
    <h3>
        ${currentNode.displayableName}
        <a href="#" class="fa fa-eye fa-fw text-info no-decoration"
           title="${fn:escapeXml(labelShow)}/${fn:escapeXml(labelHide)}"
           data-toggle="collapse" data-target="#available-workspace_${currentNode.identifier}"></a>
    </h3>
    <template:tokenizedForm>
        <form id="available-workspace_${currentNode.identifier}" class="collapse in" method="post"
              action="<c:url value='${url.baseLive}${functions:escapePath(renderContext.user.localPath)}.requestSpaceMembership.do'/>">
            <input type="hidden" name="redirectToUser"
                   value="<c:url value='${url.baseLive}${functions:escapePath(renderContext.user.localPath)}.workspace-user.html?jsite=${renderContext.site.identifier}'/>"/>
            <ul class="unstyled">
                <jcr:sql var="workspaceFactoryInstances"
                         sql="select * from [jnt:virtualsite] as site where ${uuidSql} order by site.[jcr:created] desc"
                         useRootUser="true"/>
                <c:forEach items="${workspaceFactoryInstances.nodes}" var="worskspaceFactory"
                           varStatus="workspaceFactoryIndex">
                    <li>
                        <a href="#collapse_${currentNode.identifier}_${worskspaceFactory.identifier}" data-toggle="collapse"
                           onclick="switchWorkspaceRequestListDisplay('${currentNode.identifier}_${worskspaceFactory.identifier}')"
                           title="${functions:escapeJavaScript(labelShow)}"
                           id="linkCollapse_${currentNode.identifier}_${worskspaceFactory.identifier}"
                           class="workspaceRequestLink no-decoration">
                            <i id="iconChevron_${currentNode.identifier}_${worskspaceFactory.identifier}"
                               class="fa fa-chevron-down fa-fw workspaceRequestIconChevron"></i>
                            ${worskspaceFactory.displayableName}
                        </a>
                        <c:if test="${not empty worskspaceFactory.properties['j:description'].string}">
                            &nbsp;-&nbsp;
                            <abbr title="${fn:escapeXml(worskspaceFactory.properties['j:description'].string)}"
                                  class="muted">${functions:abbreviate(worskspaceFactory.properties['j:description'].string, 70, 90, '...')}</abbr>
                        </c:if>
                        <ul id="collapse_${currentNode.identifier}_${worskspaceFactory.identifier}" class="unstyled collapse workspaceRequestList">
                        <jcr:sql var="workspaces"
                                 sql="select * from [docmix:docspace] where isdescendantnode('${functions:sqlencode(worskspaceFactory.path)}') order by [jcr:created] desc"
                                 useRootUser="true"/>
                        <c:forEach items="${workspaces.nodes}" var="workspace" varStatus="status">
                            <c:remove var="userSpace"/>
                            <jcr:node var="userSpace" uuid="${workspace.identifier}"/>
                            <c:if test="${empty userSpace or not jcr:hasPermission(userSpace, 'docspace-note')}">
                                <li>
                                    &nbsp;
                                    &nbsp;
                                    &nbsp;
                                    &nbsp;
                                    <input type="checkbox" name="requestedSpaces" value="${workspace.identifier}"
                                           class="checkbox spaceCheckbox_${currentNode.identifier}"/>
                                    <i class="fa fa-suitcase fa-fw"></i>
                                    ${fn:escapeXml(workspace.displayableName)}
                                    <c:if test="${not empty workspace.properties['jcr:description']}">
                                        &nbsp;-&nbsp;
                                        <abbr title="${fn:escapeXml(workspace.properties['jcr:description'].string)}"
                                              class="muted">${functions:abbreviate(workspace.properties['jcr:description'].string, 100, 120, '...')}</abbr>
                                    </c:if>
                                </li>
                            </c:if>
                        </c:forEach>
                            <c:if test="${not workspaceFactoryIndex.last}">
                                <li class="divider"></li>
                            </c:if>
                        </ul>
                    </li>
                </c:forEach>
            </ul>
            <button type="submit" class="btn btn-primary" disabled="disabled">
                <fmt:message key='docnt_requestSpaceMembership.requestMembership'/>
            </button>
        </form>
    </template:tokenizedForm>
</c:if>
