<%@ page contentType="text/html; UTF-8" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:choose>
    <c:when test="${empty param['bindedComponent']}">
        <c:set var="bindedComponentPath"
               value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent').path}"/>
    </c:when>
    <c:otherwise>
        <c:set var="bindedComponentPath" value="${param['bindedComponent']}"/>
    </c:otherwise>
</c:choose>
<c:if test="${currentResource.workspace eq 'live'}">
    <div id="currentUserTasks${currentNode.identifier}">
        <script type="text/javascript">
            <c:url var="componentURL" value="${url.basePreview}${functions:escapePath(currentNode.path)}.html.ajax">
                <c:param name="bindedComponent" value="${functions:escapePath(bindedComponentPath)}"/>
            </c:url>
            $('#currentUserTasks${currentNode.identifier}').load('${functions:escapeJavaScript(componentURL)}');
        </script>
    </div>
</c:if>

<c:if test="${currentResource.workspace ne 'live'}">
    <c:set value="" var="todayDisplayed" scope="request"/>

    <c:choose>
        <c:when test="${not empty currentNode.properties['filterTaskOnTypes']}">
            <c:choose>
                <c:when test="${currentNode.properties['displayTasks'].string eq 'activeOnly'}">
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) AND task.type='${currentNode.properties['filterTaskOnTypes'].string}' AND NOT(task.state='finished') ORDER BY [jcr:created] DESC"/>
                </c:when>
                <c:when test="${currentNode.properties['displayTasks'].string eq 'finishedOnly'}">
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) AND task.type='${currentNode.properties['filterTaskOnTypes'].string}' AND task.state='finished' ORDER BY [jcr:created] DESC"/>
                </c:when>
                <c:otherwise>
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) AND task.type='${currentNode.properties['filterTaskOnTypes'].string}' ORDER BY [jcr:created] DESC"/>
                </c:otherwise>
            </c:choose>
        </c:when>
        <c:otherwise>
            <c:choose>
                <c:when test="${currentNode.properties['displayTasks'].string eq 'activeOnly'}">
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) AND NOT(task.state='finished') ORDER BY [jcr:created] DESC"/>
                </c:when>
                <c:when test="${currentNode.properties['displayTasks'].string eq 'finishedOnly'}">
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) AND task.state='finished' ORDER BY [jcr:created] DESC"/>
                </c:when>
                <c:otherwise>
                    <query:definition var="listQuery"
                                      statement="SELECT * FROM [jnt:task] AS task WHERE isdescendantnode(task,['${functions:sqlencode(bindedComponentPath)}']) ORDER BY [jcr:created] DESC"/>
                </c:otherwise>
            </c:choose>
        </c:otherwise>
    </c:choose>
    <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
    <c:set target="${moduleMap}" property="subNodesView" value="taskList.docspace"/>
</c:if>
