<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<jcr:node var="user" path="${renderContext.mainResource.node.path}"/>

<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.js,jquery.jeditable.custom.js"/>

<template:addCacheDependency flushOnPathMatchingRegexp="${user.path}.*"/>

<fmt:message key="docnt_skill.remove" var="removeSkillLabel"/>

<c:set var="levelsJs" value="'':'${removeSkillLabel}'"/>
<jcr:nodeType name="docnt:skill" var="skillNodeType"/>
<c:forEach items="${skillNodeType.declaredPropertyDefinitionsAsMap['level'].valueConstraints}" var="level"
           varStatus="status">
	<fmt:message var="translatedLevel" key="docnt_skill.level.${level}"/>
	<c:set var="levelsJs" value="${levelsJs},'${level}':'${translatedLevel}'"/>
</c:forEach>

<c:url var="postUrl" value="${url.basePreview}${functions:escapePath(user.path)}.manageSkill.do"/>

<c:if test="${jcr:hasPermission(user,'jcr:write') and currentNode.properties['canEdit'].boolean}">
	<script>
		function addSkill() {
			var skillName = $('#searchSkills_${currentNode.identifier}').typeahead('val');
			if (skillName === undefined || skillName == '') {
				return false;
			}
			$.post("${postUrl}", {"action": "add", "skillName": skillName}, function () {
				location.reload();
			});
		}

		$(document).ready(function () {
			// typeahead
			var searchSkillsTH = new Bloodhound({
				datumTokenizer: Bloodhound.tokenizers.whitespace(),
				queryTokenizer: Bloodhound.tokenizers.whitespace,
				remote        : {
					url     : '<c:url value='/modules/api/jcr/v1/default/${currentResource.locale}/query?noLinks'/>',
					wildcard: '___QUERY',
					replace : function (url, query) {
						this.ajax.data = JSON.stringify({
							limit     : 10,
							queryName : 'workspaceFactorySearchSkill',
							parameters: [query.toLowerCase() + '%', '%' + query.toLowerCase() + '%']
						});
						return url + "#" + query.toLowerCase();
					},
					filter  : function (data) {
						var arr = [];
						_.each(data, function (node) {
							arr.push({skill: node.properties.jcr__title.value});
						});
						return _.chain(arr).sortBy('name').uniq(true, function (skill) {
							return skill.skill
						}).value();
					},
					ajax    : {
						type       : 'POST',
						contentType: 'application/json',
						dataType   : 'json',
						processData: false
					}
				},
				limit         : 10
			});

			// Initialize the Bloodhound suggestion engine
			searchSkillsTH.initialize();
			// Instantiate the Typeahead UI
			$('#searchSkills_${currentNode.identifier}').typeahead(null, {
				source      : searchSkillsTH.ttAdapter(),
				highlight   : true,
				autocomplete: true,
				displayKey  : 'skill'
			});

			$(".editSkillLevel_${currentNode.identifier}").editable(function (value, settings) {
						var data = {skillName: $(this).data('skillname')};
						if (value == '') {
							data.action = "remove";
						} else {
							data.action = "edit";
							data.level  = value;
						}
						$.post("${postUrl}", data, function () {
							location.reload();
						});
					},
					{
						type      : 'custom-select',
						cssclass  : 'form-horizontal',
						inputClass: 'span12',
						data      : "{${functions:escapeJavaScript(levelsJs)}}",
						submit    : '<button class="btn btn-primary btn-mini pull-right" type="submit" >OK</button>'
					});
		});
	</script>
</c:if>

<div>
	<jcr:sql var="result"
	         sql="select * from [docnt:skill] where ischildnode('${functions:sqlencode(user.path)}/j:skills') order by [jcr:title]"/>
	<c:set var="canEdit" value="${jcr:hasPermission(user,'jcr:write') and currentNode.properties['canEdit'].boolean}"/>
	<c:if test="${functions:length(result.nodes) > 0 or canEdit}">
		<table class="table">
			<c:forEach items="${result.nodes}" var="skillnode">
				<tr>
					<td class="span2">
							${skillnode.displayableName}
					</td>
					<td class="span10">
                        <span class="pull-right text-info editSkillLevel_${currentNode.identifier}"
                              data-skillname="${skillnode.name}">
                            <fmt:message key="docnt_skill.level.${skillnode.properties.level.string}"/>
                        </span>
					</td>
				</tr>
			</c:forEach>
		</table>
		<c:if test="${canEdit}">
			<div class="scrollable-dropdown-menu thWrap">
				<input id="searchSkills_${currentNode.identifier}" class="typeahead span12" type="text"
				       placeholder="<fmt:message key='docnt_skill.enter'/>">
			</div>
			<button class="btn btn-primary pull-right" type="button" onclick="addSkill();">
				<fmt:message key="docnt_skill.add"/>
			</button>
		</c:if>
	</c:if>
</div>