<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="dm" uri="http://www.jahia.org/tags/document-management" %>
<template:addResources type="css" resources="tasks.css"/>

<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<ul class="unstyled">
<c:forEach items="${functions:reverse(boundComponent.linearVersionInfos)}" var="v">
    <li>
    <c:set value="${fn:substringBefore(v.label, '_at_')}" var="s"/>
    <c:set value="${fn:substringAfter(v.label, '_at_')}" var="date"/>
    <fmt:parseDate value="${date}" pattern="yyyy_MM_dd_HH_mm_ss" var="date"/>

    <c:choose>
        <c:when test="${fn:contains(s, 'published')}">
            <fmt:message key="docnt_versionsViewer.published"/>&nbsp;
            <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                  data-moment-locale="${currentResource.locale}"
                  data-moment="<fmt:formatDate value="${date}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
        </c:when>
        <c:when test="${fn:contains(s, 'uploaded')}">
            <fmt:message key="docnt_versionsViewer.uploaded"/>&nbsp;
            <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                  data-moment-locale="${currentResource.locale}"
                  data-moment="<fmt:formatDate value="${date}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
        </c:when>
        <c:when test="${fn:contains(s, 'validated')}">
            <fmt:message key="docnt_versionsViewer.validated"/>&nbsp;
            <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                  data-moment-locale="${currentResource.locale}"
                  data-moment="<fmt:formatDate value="${date}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
        </c:when>
        <c:otherwise>
            ${s}
        </c:otherwise>
    </c:choose>
        <c:set var="thumb" value="true"/>

        <c:if test="${dm:isViewable(boundComponent)}">
            <jcr:nodeVersion var="versionnode" node="${boundComponent}" versionName="${v.version.name}"/>
            <jcr:node var="thumbnode" path="${versionnode.path}/jcr:frozenNode/swfView"/>
            <c:if test="${empty thumbnode}">
                <c:set var="thumb" value="false"/>
            </c:if>
        </c:if>

        <c:if test="${thumb eq 'true'}">
            &nbsp;<a href="#" id="previewlink" onclick="docViewerUpdate('${v.label}'); return false"><fmt:message key="wsf.label.preview"/></a>
        </c:if>

        &nbsp;<a href="${boundComponent.url}?l=${v.label}" class="fa fa-download no-decoration"></a>
    </li>
</c:forEach>
</ul>
