var notificationsPopoverOpen = false;
var notificationsRefreshInterval = 60000;
var notificationsSeenTime = "";
var notificationsPage = 0;
var maxNotifications = 5;

function displayNotifications(url, page, targetId, displayId) {
    $.ajax({
        url: url,
        type: 'post',
        dataType: 'json',
        data: {
            action: 'notificationsList',
            page: page
        },
        success: function(result) {
            var element = $(targetId);

            if (!notificationsPopoverOpen)
                element.empty();

            _.each(result.notifications, function(notification) {
                element.append(notificationsTemplate(notification));
            });
            element.trigger("rowadded");

            if (result.notifications.length < maxNotifications) {
                $("#notificationsLoadMoreButton").css("display", "none");
                element.append("<br/><div class='row-fluid text-center' id='loadMoreMessage'>"
                    + wsfi18n['jnt_socialActivitiesDisplay.notification.message.noMoreNotification'] + "</div>");
            }
            notificationsPage = result.page;
            $(displayId).empty();
            notificationsSeenTime = moment().toISOString();
        },
        error : function() {

        }
    });
}

function loadMoreResults(url, page, targetId, displayId) {
    displayNotifications(url, page, targetId, displayId);
}

function updateRefreshTime(url) {
    $.ajax({
        url: url,
        type: 'post',
        dataType: 'json',
        data: {
            action: 'updateRefreshTime',
            time: notificationsSeenTime
        },
        success: function() {
            notificationsPopoverOpen = false;
        }
    });
}

function updateNotificationsCount(url, id, redirectUrl) {
    if (!notificationsPopoverOpen) {
        $.ajax({
            url: url,
            type: 'post',
            dataType: 'json',
            data: {
                action: 'newNotificationsCount'
            },
            success: function (result) {
                if (result.newNotificationsCount > 0 && result.newNotificationsCount < 11)
                    $("#notificationsCount_" + id).html(result.newNotificationsCount);
                else if (result.newNotificationsCount >= 11) {
                    $("#notificationsCount_" + id).html("10+");
                }
            },
            error: function (result) {
                if (result.status == 401)
                    window.location.assign(redirectUrl);
            }
        });
    }
};

function initNotificationsCount(url, id, redirectUrl) {
    updateNotificationsCount(url, id, redirectUrl);
    setInterval(function(){updateNotificationsCount(url, id, redirectUrl)}, notificationsRefreshInterval);
}

function getSubscriptionList(url, callback) {
    $.ajax({
        url: url,
        method: 'POST',
        dataType: 'json',
        data: {
            action: 'subscriptionList'
        },
        success: function(response, resultStatus, jqXHR) {
            if (jqXHR.status === 200) {
                callback(response);
            }
            if (jqXHR.status === 204) {
                callback();
            }
        }
    });
}

function toggleNotifications(url, action, nodeIdentifier, callback) {
    $.ajax({
        url: url,
        method: 'POST',
        dataType: 'json',
        data: {
            action: action,
            nodeIdentifier: nodeIdentifier
        },
        success: function(response, resultStatus, jqXHR) {
            if (callback !== undefined) {
                callback()
            }
        }
    });
}
