<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:set var="resourceReadOnly" value="${currentResource.moduleParams.readOnly}"/>
<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>
<template:include view="hidden.header"/>

<c:choose>
    <c:when test="${renderContext.editModeConfigName eq 'studiomode' and inWrapper eq false}">
        <ul>
            <li class="dropdown">
                <a href="#">
                    ${currentNode.displayableName}
                    <b class="caret"></b>
                </a>
                <ul>
                    <c:set var="isEmpty" value="true"/>
                    <c:forEach items="${moduleMap.currentList}" var="subchild">
                        <li>
                            <template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable && !resourceReadOnly}"/>
                        </li>
                        <c:set var="isEmpty" value="false"/>
                    </c:forEach>
                    <c:if test="${not empty moduleMap.emptyListMessage and isEmpty or moduleMap.forceEmptyListMessageDisplay}">
                        <li>${moduleMap.emptyListMessage}</li>
                    </c:if>
                    <c:if test="${moduleMap.editable and !resourceReadOnly}">
                        <li><template:module path="*"/></li>
                    </c:if>
                </ul>
            </li>
        </ul>
    </c:when>
    <c:when test="${renderContext.editModeConfigName eq 'studiovisualmode'}">
        <li class="dropdown">
            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                <i class="fa fa-wrench"></i>
                ${currentNode.displayableName}
                <b class="caret"></b>
            </a>
            <ul class="dropdown-menu">
                <c:set var="isEmpty" value="true"/>
                <c:forEach items="${moduleMap.currentList}" var="subchild">
                    <li>
                        <template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable && !resourceReadOnly}"/>
                    </li>
                    <c:set var="isEmpty" value="false"/>
                </c:forEach>
                <c:if test="${not empty moduleMap.emptyListMessage and isEmpty and moduleMap.forceEmptyListMessageDisplay}">
                    <li>${moduleMap.emptyListMessage}</li>
                </c:if>
            </ul>
        </li>
    </c:when>
    <c:otherwise>
        <li class="dropdown">
            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                <i class="fa fa-wrench"></i>
                ${currentNode.displayableName}
                <b class="caret"></b>
            </a>
            <ul class="dropdown-menu">
                <c:forEach items="${moduleMap.currentList}" var="subchild">
                    <li>
                        <template:module node="${subchild}" view="${moduleMap.subNodesView}" editable="${moduleMap.editable && !resourceReadOnly}"/>
                    </li>
                </c:forEach>
            </ul>
        </li>
    </c:otherwise>
</c:choose>

<template:include view="hidden.footer"/>