<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>

<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="social-activities-display.css"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<jcr:node var="fromUser" path="${renderContext.user.localPath}"/>
<div class="row-fluid">
    <div class="span12 well">
        <div class="row-fluid">
            <div class="span2">
                <jcr:nodeProperty var="picture" node="${fromUser}" name="j:picture"/>
                <c:choose>
                    <c:when test="${not empty picture}">
                        <a href="<c:url value='${url.base}${functions:escapePath(fromUser.path)}.html'/>">
                            <img class="img-polaroid img-circle pull-left"
                                 src="${picture.node.thumbnailUrls['avatar_120']}"
                                 alt="${fromUser.properties.title.string} ${fromUser.properties.firstname.string} ${fromUser.properties.lastname.string}"/>
                        </a>
                    </c:when>
                    <c:otherwise>
                        <a href="<c:url value='${url.base}${functions:escapePath(fromUser.path)}.html'/>">
                            <img class="img-polaroid img-circle pull-left" src="<c:url value='${url.templatesPath}/social/images/userBig.png'/>"
                                 alt="user"/>
                        </a>
                    </c:otherwise>
                </c:choose>
            </div>
            <div class="span10">
                <form action="<c:url value='${url.base}${functions:escapePath(boundComponent.path)}.addActivity.do'/>" method="post">
                    <input type="hidden" name="jcrRedirectTo"
                           value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                    <input type="hidden" name="activityType" value="text"/>
                    <textarea class="span12" type="text" name="activityParameters"
                              onFocus="if(this.value==this.defaultValue)value=''"
                              onBlur="if(this.value=='')value=this.defaultValue;"><fmt:message
                            key="jnt_addActivityForm.typeYourMessage"/></textarea>
                    <fmt:message key="jnt_addActivityForm.share" var="labelShare"/>
                    <div><input class="btn btn-primary" type="submit" value="${fn:escapeXml(labelShare)}"></div>
                </form>
            </div>
        </div>
    </div>
    <div class="clearfix"></div>
</div>