<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<jsp:useBean id="datas" class="java.util.LinkedHashMap"/>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="underscore.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<c:set var="linked" value="${ui:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<template:addCacheDependency node="${linked}"/>
<template:addCacheDependency flushOnPathMatchingRegexp="${linked.path}/.*"/>
<c:forEach items="${linked.nodes}" var="linkedChild" varStatus="status">
    <fmt:formatDate pattern="yyyy-MM"
                    value="${linkedChild.properties[currentNode.properties.startDateProperty.string].date.time}"
                    var="startDate"/>
    <c:choose>
        <c:when test="${empty datas[startDate]}">
            <c:set target="${datas}" property="${startDate}" value="1"/>
        </c:when>
        <c:otherwise>
            <c:set target="${datas}" property="${startDate}" value="${datas[startDate]+1}"/>
        </c:otherwise>
    </c:choose>
</c:forEach>
<script type="text/javascript">
    $(document).ready(function () {
        // page is now ready, initialize the calendar...
        var events        = [
            <c:forEach items="${datas}" var="data" varStatus="status">
            <c:url value="${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.html" var="eventUrl">
            <c:param name="filter" value="{name:'${currentNode.properties.startDateProperty.string}',value:'${data.key}',op:'eq',uuid:'${linked.identifier}',format:'yyyy-MM',type:'date'}"/>
            <c:param name="calStartDate" value="${data.key}"/>
            </c:url>
            <c:if test="${not status.first}">,
            </c:if>
            {
                value: '${data.value}',
                start: '${data.key}',
                url  : "${eventUrl}"
            }
            </c:forEach>
        ];
        by_year           = {};

        _.each(events, function (event, index, list) {

            var year  = event.start.substring(0, 4);
            var month = event.start.substring(5, 7);
            if (by_year[year] === undefined)
                by_year[year] = {key: year};
            if (by_year[year][month] === undefined)
                by_year[year][month] = event;
            _.extend(by_year[year][month], {key: month});
        });
        var years         = _.chain(by_year).sortBy('key').map('key').value().reverse();
        moment.locale('${renderContext.mainResourceLocale}');
        <c:choose>
        <c:when test="${not empty param.calStartDate}">
        var selectedMonth = ${fn:substring(param.calStartDate,5,7)};
        var selectedYear  = ${fn:substring(param.calStartDate,0,4)};
        </c:when>
        <c:otherwise>
        var selectedMonth = 0;
        var selectedYear  = 0;
        </c:otherwise>
        </c:choose>

        _.each(years, function (yearIter) {
            var year = by_year[yearIter];
            var list = "<h4 class='text-center'>" + year.key + "</h4><dl class=\"dl-horizontal\">";
            var keys = _.chain(year).sortBy('key').map('key').value();
            keys.reverse();
            _.each(keys, function (key) {
                if (_.isObject(year[key])) {
                    var month             = year[key];
                    var month_name        = moment().month(month.key - 1).format("MMMM");
                    var selectedMonthSpan = "";
                    if (year.key == selectedYear && month.key == selectedMonth) {
                        selectedMonthSpan = " class='label label-success'";
                    }
                    list += "<dt><a href=\"" + month.url + "\"><span" + selectedMonthSpan + ">" + month_name + "</span></a></dt><dd><span class=\"label label-info text-right\" style=\"width:20px\">" + month.value + "</span></dd>";
                }
            });
            list += "</dl></li>";
            $("#blogCalendar").append(list);
        })
    });
</script>
<div id="blogCalendar"></div>
