<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="acl" type="java.lang.String"--%>
<template:addResources type="css" resources="jstree.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jstree.js"/>

<c:set var="boundComponent" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<c:choose>
    <c:when test="${not empty boundComponent and not jcr:isLockedAndCannotBeEdited(boundComponent)}">
        <c:set var="separator" value="${functions:default(currentResource.moduleParams.separator, ' ,')}"/>
        <template:addResources type="javascript" resources="jquery.min.js"/>

        <jcr:nodeProperty node="${boundComponent}" name="j:defaultCategory" var="assignedCategories"/>
        <c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}"/>
        <jcr:nodeProperty node="${jcr:getParentOfType(boundComponent,'docmix:docspace')}" name="categoryRoot" var="categoryRoot"/>
        <c:choose>
            <c:when test="${not empty categoryRoot}">
                <c:set var="categoryPath" value="${categoryRoot.node.path}"/>
            </c:when>
            <c:otherwise>
                <c:set var="categoryPath" value="/sites/systemsite/categories"/>
            </c:otherwise>
        </c:choose>
        <c:if test="${not empty categoryRoot}">
            <c:set var="categoryPath" value="${categoryRoot.node.path}"/>
        </c:if>
        <script type="text/javascript">
            $(document).ready(function () {
                var pageLoaded = false;
                // Display categories
                $('#categoriesTree_${currentNode.identifier}').jstree({
                    'core': {
                        'data': {
                            'cache': false,
                            'url': function(node){
                                if(node.id=="#"){
                                    return '<c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(categoryPath)}.treeRootItem.json"><c:param name="nodeTypes">jnt:category</c:param></c:url>'
                                }
                                else {
                                    return '<c:url value="/cms/wsfactory/default/${currentResource.locale}"/>' + node.original.path + '.treeRootItem.json?nodeTypes='+encodeURIComponent('jnt:category');
                                }
                            },
                            'dataType': 'JSON',
                            'dataFilter': function (data, type) {
                                var node = JSON.parse(data)[0];
                                var childrens = [];
                                var i = 0;
                                $.each(node.children, function (idx, elt) {
                                    childrens[i++] = {
                                        id: elt.id,
                                        text: elt.text,
                                        children: elt.hasChildren,
                                        state: {opened: false, "undetermined": true},
                                        path:elt.path
                                    };
                                });
                                pageLoaded = true;
                                return JSON.stringify({
                                    id: node.id,
                                    text: node.text,
                                    children: childrens,
                                    state: {opened: true, "undetermined": true},
                                    path:node.path
                                });
                            }
                        }
                    },
                    'plugins': ["wholerow","search","sort"]
                });

                $('#categoriesTree_${currentNode.identifier}').jstree(true).refresh();

                // Handle category tree events - set hidden categoryRoot field to selected category
                $('#categoriesTree_${currentNode.identifier}').on('select_node.jstree', function(e, data) {
                    $("#categoriesTreeModal_${currentNode.identifier}").modal('hide');
                    $("#selectedCategoryName_${currentNode.identifier}").val(data.node.text);
                    $("#selectedCategoryToAdd_${currentNode.identifier}").val(data.node.id);
                        addCategory('${boundComponent.identifier}', '${separator}');
                });

                var to = false;
                $('#categoryTreeSearch').keyup(function () {
                    if (to) {
                        clearTimeout(to);
                    }
                    to = setTimeout(function () {
                        var v = $('#categoryTreeSearch').val();
                        $('#categoriesTree_${currentNode.identifier}').jstree(true).search(v);
                    }, 250);
                });
            });

            function addCategory(uuid, separator) {
                var catToAddUuid = $("#selectedCategoryToAdd_${currentNode.identifier}").val();
                $("#errorCategoryExist_${currentNode.identifier}").hide();
                if (catToAddUuid == "") {
                    $("#selectedCategoryName_${currentNode.identifier}").val("");
                    $("#selectedCategoryToAdd_${currentNode.identifier}").val("");
                    return false;
                }
                for (var i in uuids) {
                    if (catToAddUuid == uuids[i]) {
                        $("#errorCategoryExist_${currentNode.identifier}").show();
                        $("#selectedCategoryName_${currentNode.identifier}").val("");
                        $("#selectedCategoryToAdd_${currentNode.identifier}").val("");
                        return false;
                    }
                }

                $.ajaxSetup({ traditional: true, cache:false });
                uuids.push(catToAddUuid);
                $.post("${postUrl}", { "j:defaultCategory": uuids, "jcrMethodToCall" :"put", "jcr:mixinTypes": "jmix:categorized" },
                function(result) {
                    var catContainer = $('#categoryHolder');

                    var catDiv = $('<div></div>').attr('id', 'addedCategory_' + catToAddUuid).attr({style : 'padding: 2px;', class: 'row-fluid categoryView_' + uuid});
                    var catDisplay = $('<span class="categorizeditem">' + $("#selectedCategoryName_${currentNode.identifier}").val() + '</span>');
                    var catLinkDelete = $('<a></a>').attr('onclick','deleteCategory(\''+ catToAddUuid +'\')').attr('class','fa fa-remove pull-right').attr('href','#');

                    catContainer.append(catDiv);
                    catDiv.append(catDisplay);
                    catDiv.append(catLinkDelete);
                    $("#selectedCategoryName_${currentNode.identifier}").val("");
                    $("#selectedCategoryToAdd_${currentNode.identifier}").val("");
                }, "json");
            }
        </script>
        <c:if test="${renderContext.user.name != 'guest'}">
            <form onsubmit="return false;">
                <input type="hidden" id="selectedCategoryName_${currentNode.identifier}" disabled="true"/>
                <input type="hidden" id="selectedCategoryToAdd_${currentNode.identifier}" disabled="true"/>
                    <a href="#" class="btn btn-default" data-toggle="modal"
                       data-target="#categoriesTreeModal_${currentNode.identifier}" title="<fmt:message key="jnt_categorizing.selectCategory"/>">
                        <i class="fa fa-plus"></i>
                    </a>
                <div id="errorCategoryExist_${currentNode.identifier}" class="text-error hide">
                    <fmt:message key="jnt_categorizing.alreadyAdded"/>
                </div>
            </form>
        </c:if>
        <div id="categoriesTreeModal_${currentNode.identifier}" class="modal hide fade" tabindex="-1" role="dialog" aria-hidden="true">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h3><fmt:message key="jnt_categorizing.addCategoryToDocument"/></h3>
                <input id="categoryTreeSearch" class="input-medium search-query" type="search" placeholder="<fmt:message key="wsf.label.search"/>">
            </div>
            <div class="modal-categories-tree">
                <div id="categoriesTree_${currentNode.identifier}" class="pull-left"></div>
            </div>
            <div class="modal-footer">
                <button class="btn btn-default" data-dismiss="modal" aria-hidden="true">
                    <fmt:message key="wsf.label.close"/>
                </button>
            </div>
        </div>
    </c:when>
    <c:otherwise>
        <fmt:message key="nt_base.workflowMonitor.docspace.documentLocked"/>
    </c:otherwise>
</c:choose>
