<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="files.css"/>
<template:addResources type="css" resources="workspace.css"/>

<jcr:node var="rootCategory" path="/sites/systemsite/categories"/>

<c:if test="${jcr:hasPermission(rootCategory, 'jcr:addChildNodes_default')}">

    <template:addResources type="css" resources="jstree.min.css"/>

    <template:addResources type="javascript" resources="jquery.min.js"/>
    <template:addResources type="javascript" resources="underscore-min.js"/>
    <template:addResources type="javascript" resources="jstree.min.js"/>
    <template:addResources type="javascript" resources="bootstrap-modal.js"/>
    <template:addResources type="javascript" resources="bootstrap-transition.js"/>
    <template:addResources type="javascript" resources="bootbox.min.js"/>
    <template:addResources type="javascript" resources="jcrestapi.js"/>

    <script type="text/javascript">
        var API_URL_START = '<c:url value="/modules/api/jcr/v1"/>';
        $.jstree.defaults.search.show_only_matches=true;
        var jsTree;

        function loadTree() {
            jsTree = $('#modal-tree_${currentNode.identifier}').jstree({
                'core' : {
                    'check_callback' : true,
                    'data': {
                        'cache': false,
                        'url': function(node){
                            if(node.id=="#"){
                                return '<c:url value="/cms/wsfactory/default/${currentResource.locale}/sites/systemsite/categories.treeRootItem.json"><c:param name="nodeTypes">jnt:category</c:param></c:url>'
                            }
                            else {
                                return '<c:url value="/cms/wsfactory/default/${currentResource.locale}"/>'+node.original.path+'.treeRootItem.json?nodeTypes='+encodeURIComponent('jnt:category');
                            }
                        },
                        'dataType': 'JSON',
                        'dataFilter': function (data, type) {
                            var node = JSON.parse(data)[0];
                            var childrens = [];
                            var i = 0;
                            $.each(node.children, function (idx, elt) {
                                    childrens[i++] = {id: elt.id,
                                        text: elt.text,
                                        children: elt.hasChildren,
                                        state: {opened: false, "undetermined": true},
                                        path:elt.path
                                    };
                            });
                            return JSON.stringify({id: node.id,
                                text: node.text,
                                children: childrens,
                                state: {opened: true, "undetermined": true},
                                path:node.path});
                        }
                    }
                },
                "plugins" : [ "wholerow", "search", "sort" ]
            });
            var to = false;
            $('#tree-query_${currentNode.identifier}').keyup(function () {
                if(to) { clearTimeout(to); }
                to = setTimeout(function () {
                    var v = $('#tree-query_${currentNode.identifier}').val();
                    jsTree.jstree(true).search(v);
                }, 250);
            });
        }

        function createCategory() {
            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
            var ref = jsTree.jstree(true),
                    parent = ref.get_selected();
            if(!parent.length) {
                return false;
            }
            parent = parent[0];
            var newNode = ref.create_node(parent, {"type":"folder"});
            if(newNode) {
                ref.edit(newNode);
                $('.jstree-rename-input').on('blur', function() {
                    jahiaAPIStandardCall('default', '${currentResource.locale}', 'nodes',
                        ref.get_node(parent).id + '/children/' + ref.get_node(newNode).text,
                        'PUT', JSON.stringify({"name": _.escape(ref.get_node(newNode).text), "type": "jnt:category"}),
                        function() {
                            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
                            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
                            jsTree.jstree("refresh");
                        }, function(result) {
                            $('#errorCategoriesOperation_${currentNode.identifier}').html(result.message);
                            $('#errorCategoriesOperation_${currentNode.identifier}').show();
                        }
                    );
                    $('.jstree-rename-input').unbind('blur');
                });
            }
        }

        function renameCategory() {
            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
            var ref = jsTree.jstree(true),
                    sel = ref.get_selected();
            if(!sel.length) {
                return false;
            }
            if(ref.get_parent(sel) == '#') {
                $('#errorCategoriesOperation_${currentNode.identifier}').html(wsfi18n['jnt_categoryManagement.error.rename']);
                $('#errorCategoriesOperation_${currentNode.identifier}').show();
                return false;
            }
            sel = sel[0];
            ref.edit(sel);
            $('.jstree-rename-input').on('blur', function() {
                if (ref.get_node(sel).original.text != ref.get_node(sel).text) {
                    jahiaAPIStandardCall('default', '${currentResource.locale}', 'nodes',
                        ref.get_node(sel).id + '/moveto/' + _.escape(ref.get_node(sel).text),
                        'POST', '',
                        function() {
                            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
                            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
                            jsTree.jstree("refresh");
                        }, function(result) {
                            $('#errorCategoriesOperation_${currentNode.identifier}').html(result.message);
                            $('#errorCategoriesOperation_${currentNode.identifier}').show();
                        }
                    );
                }
                $('.jstree-rename-input').unbind('blur');
            });
        }

        function deleteCategory() {
            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
            var ref = jsTree.jstree(true),
                sel = ref.get_selected();
            if(!sel.length) {
                return false;
            }
            if(ref.get_parent(sel) == '#') {
                $('#errorCategoriesOperation_${currentNode.identifier}').html(wsfi18n['jnt_categoryManagement.error.delete']);
                $('#errorCategoriesOperation_${currentNode.identifier}').show();
                return false;
            }
            var listCategories = '';
            for (var node in sel) {
                listCategories += "<li>" + ref.get_node(sel[node]).text + "</li>";
            }
            $('#treeArea_${currentNode.identifier}').hide();
            $('#confirmDeleteCategoriesDiv_${currentNode.identifier}').show();
            $('#confirmDeleteCategoriesList_${currentNode.identifier}').html(listCategories);
            $('#confirmDeleteCategoriesButton_${currentNode.identifier}').click(function(e) {
                for (var node in sel) {
                    jahiaAPIStandardCall('default', '${currentResource.locale}', 'nodes', ref.get_node(sel[node]).id, 'DELETE', '',
                        function() {
                            $('#confirmDeleteCategoriesDiv_${currentNode.identifier}').hide();
                            $('#confirmDeleteCategoriesList_${currentNode.identifier}').html('');
                            $('#errorCategoriesOperation_${currentNode.identifier}').hide();
                            $('#errorCategoriesOperation_${currentNode.identifier}').html('');
                            $('#treeArea_${currentNode.identifier}').show();
                            jsTree.jstree("refresh");
                        }, function(result) {
                            $('#confirmDeleteCategoriesDiv_${currentNode.identifier}').hide();
                            $('#confirmDeleteCategoriesList_${currentNode.identifier}').html('');
                            $('#treeArea_${currentNode.identifier}').show();
                            $('#errorCategoriesOperation_${currentNode.identifier}').html(result.message);
                            $('#errorCategoriesOperation_${currentNode.identifier}').show();
                        }
                    );
                }
                $('#confirmDeleteCategoriesButton_${currentNode.identifier}').unbind('click');
                $('#cancelDeleteCategoriesButton_${currentNode.identifier}').unbind('click');
            });
            $('#cancelDeleteCategoriesButton_${currentNode.identifier}').click(function(e) {
                $('#confirmDeleteCategoriesDiv_${currentNode.identifier}').hide();
                $('#confirmDeleteCategoriesList_${currentNode.identifier}').html('');
                $('#treeArea_${currentNode.identifier}').show();
                $('#confirmDeleteCategoriesButton_${currentNode.identifier}').unbind('click');
                $('#cancelDeleteCategoriesButton_${currentNode.identifier}').unbind('click');
                jsTree.jstree("refresh");
            });
        }

        $(document).ready(function () {
            $('#modal-${currentNode.identifier}').appendTo(document.body);

            if (jsTree != undefined) {
                jsTree.jstree(true).refresh();
            }
        });
    </script>

    <div id="modal-${currentNode.identifier}" class="modal fade hide" tabindex="-1" role="dialog">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h3>
                <fmt:message key="wsf.label.categories"/>
                <input id="tree-query_${currentNode.identifier}" class="input-medium search-query" type="search" placeholder="<fmt:message key="wsf.label.search"/>">
            </h3>
        </div>
        <div id="treeArea_${currentNode.identifier}">
            <div class="modal-body">
                <div class="modal-categories-tree">
                    <div id="modal-tree_${currentNode.identifier}"></div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
                    <fmt:message key="wsf.label.close"/>
                </button>
                <button type="button" class="btn btn" onclick="renameCategory()">
                    <i class="glyphicon glyphicon-pencil"></i>
                    <fmt:message key="jnt_categoryManagement.rename"/>
                </button>
                <button type="button" class="btn btn-danger" onclick="deleteCategory()">
                    <i class="glyphicon glyphicon-remove"></i>
                    <fmt:message key="jnt_categoryManagement.delete"/>
                </button>
                <button type="button" class="btn btn-primary" onclick="createCategory()">
                    <i class="glyphicon glyphicon-asterisk"></i>
                    <fmt:message key="jnt_categoryManagement.create"/>
                </button>
                <span id="errorCategoriesOperation_${currentNode.identifier}" class="hide text-error"></span>
            </div>
        </div>
        <div id="confirmDeleteCategoriesDiv_${currentNode.identifier}" class="hide">
            <div class="modal-body text-error">
                <fmt:message key="jnt_categoryManagement.confirmDeleteCategory"/>
                <br />
                <ul id="confirmDeleteCategoriesList_${currentNode.identifier}"></ul>
            </div>
            <div class="modal-footer">
                <button id="cancelDeleteCategoriesButton_${currentNode.identifier}" type="button" class="btn btn-default">
                    <fmt:message key="wsf.label.cancel"/>
                </button>
                <button id="confirmDeleteCategoriesButton_${currentNode.identifier}" type="button" class="btn btn-danger">
                    <fmt:message key="wsf.label.delete"/>
                </button>
            </div>
        </div>
    </div>

    <a href="#" data-toggle="modal" data-target="#modal-${currentNode.identifier}" onclick="loadTree()">
        <fmt:message key="jnt_categoryManagement.manage"/>
    </a>
</c:if>