<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.min.css"/>
<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.validate.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="moment-with-locale.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/locales/bootstrap-datetimepicker.${currentResource.locale}.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>

<c:set var="taskType" value="${currentNode.properties['taskType'].string}"/>

<c:set var="bindedComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<script type="text/javascript">
    $(document).ready(function() {
        <c:url value='${url.findUser}' var="findUserURL">
            <c:if test="${not empty currentNode.properties['checkRolesOnMainResource'] and currentNode.properties['checkRolesOnMainResource'].boolean and not empty currentNode.properties['rolesList']}">
                <c:set var="roles" value=""/>
                <jcr:nodeProperty node="${currentNode}" name="rolesList" var="rolesList"/>
                <c:forEach items="${rolesList}" var="roleNode">
                    <c:set var="roleName" value="${roleNode.node.name}"/>
                    <c:set var="roles" value="${roles} ${roleName}"/>
                </c:forEach>
                <c:param name="node" value="${renderContext.mainResource.node.path}"/>
                <c:param name="roles" value="${roles}"/>
            </c:if>
        </c:url>

        // typeahead
        var taskAssigneeTH = new Bloodhound({
            datumTokenizer: Bloodhound.tokenizers.whitespace(),
            queryTokenizer: Bloodhound.tokenizers.whitespace,
            remote: {
                url: '${findUserURL}' + "?q=___QUERY",
                wildcard: '___QUERY',
                ajax : {
                    type: "GET",
                    dataType: 'json',
                    data: {
                        limit: 10
                    }
                },
                filter: function(users) {
                    return $.map(users, function(user) {
                        var value = user['j:firstName'] || '';
                        if (value.length != 0) {
                            value += ' ';
                        }
                        value += user['j:lastName'] || '';
                        var title = value.length > 0 ? value : user['username'];
                        var username = user['username'];
                        return {
                            userName: username != title ? title + " (" + username + ")" : username,
                            userKey: user['userKey']
                        };
                    });
                }
            },
            limit: 10
        });

        // Initialize the Bloodhound suggestion engine
        taskAssigneeTH.initialize();

        // Instantiate the Typeahead UI
        $('#task-assignee_${currentNode.identifier}').typeahead(null, {
            displayKey: 'userName',
            source: taskAssigneeTH.ttAdapter(),
            highlight: true,
            autocomplete: true
        });

        // Event to get selected or autocompleted value
        $('#task-assignee_${currentNode.identifier}').bind('typeahead:selected', function(obj, datum) {
            $('#assignee_hidden_${currentNode.identifier}').val(datum['userKey']);
        });
        $('#task-assignee_${currentNode.identifier}').bind('typeahead:autocompleted', function(obj, datum) {
            $('#assignee_hidden_${currentNode.identifier}').val(datum['userKey']);
        });
        $('#task-assignee_${currentNode.identifier}').on("focusout", function() {
            if ($(this).val().trim() == "")
                $('#assignee_hidden_${currentNode.identifier}').val("");
        });

        $("#createTaskForm_${currentNode.identifier}").on('submit', function() {
            $('#noTitleError_${currentNode.identifier}').hide();
            if ($('#jcr-title_${currentNode.identifier}').val() === '') {
                $('#noTitleError_${currentNode.identifier}').show();
                return false;
            }
            var dateToUse;
            var datePicked = $('#task_dueDate_${currentNode.identifier}').val();
            if (datePicked === '') {
                dateToUse = moment().locale('${currentResource.locale}').endOf('day').toISOString();
            } else {
                var timePicked = $('#task_dueTime_${currentNode.identifier}').val();
                var dateFormat = moment().locale('${currentResource.locale}')._locale._longDateFormat.L;
                if (timePicked === '') {
                    dateToUse = moment(datePicked, dateFormat)
                            .locale('${currentResource.locale}').endOf('day').toISOString();
                } else {
                    dateToUse = moment(datePicked + " " + timePicked, dateFormat + " HH:mm").toISOString();
                    if (moment().isAfter(dateToUse)) {
                        dateToUse = moment().add(1, 'hour').toISOString();
                    }
                }
            }
            $("#dueDate_hidden_${currentNode.identifier}").val(dateToUse);
            $("#submit_task_${currentNode.identifier}").attr('disabled', 'disabled');
        });

        $('#datePicker_${currentNode.identifier}').datetimepicker({
            language: '${currentResource.locale}',
            format: moment().locale('${currentResource.locale}')._locale._longDateFormat.L,
            startDate: new Date(),
            toggleActive: true,
            pickTime: false
        }).on('changeDate', function() {
            if ($('.datepicker-days').css('display') === 'block')
                $('.bootstrap-datetimepicker-widget').hide();
        });

        $('#timePicker_${currentNode.identifier}').datetimepicker({
            language: '${currentResource.locale}',
            format: 'hh:mm',
            startDate: new Date(),
            toggleActive: true,
            pickDate: false,
            pickSeconds: false
        });

        (function() {
            $(".bootstrap-datetimepicker-widget").each(function(){$(this).css("z-index", 2147483647)});
        })();
    });
</script>
<c:set var="title">${currentNode.properties['jcr:title'].string}</c:set>
<c:if test="${empty title}">
    <fmt:message var="title" key="jnt_createTaskForm.createNewTask"/>
</c:if>

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
    <h3>${fn:escapeXml(title)}</h3>
</div>

<jcr:propertyInitializers nodeType="jnt:task" name="priority" var="priorities"/>
<form class="form-horizontal no-margin-bottom" id="createTaskForm_${currentNode.identifier}" method="post"
      action="<c:url value='${url.basePreview}${functions:escapePath(bindedComponent.path)}/tasks/*'/>">
    <div class="modal-body">
        <input type="hidden" name="jcrNodeType" value="jnt:task">
        <input type="hidden" name="jcrParentType" value="jnt:tasks">
        <input type="hidden" name="type" value="${taskType}"/>
        <input type="hidden" name="jcrRedirectTo"
               value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.${renderContext.mainResource.template}'/>">

        <div class="control-group">
            <label class="control-label">
                <fmt:message key="wsf.label.title"/>
            </label>
            <div class="controls">
                <input id="jcr-title_${currentNode.identifier}" type="text" name="jcr:title" value=""/>
                <span id="noTitleError_${currentNode.identifier}" class="help-inline hide"><p class="text-error"><fmt:message key="jnt_createTaskForm.requiredField"/></p></span>
            </div>
        </div>

        <c:if test="${currentNode.properties['useDescription'].boolean}">
            <div class="control-group">
                <label class="control-label">
                    <fmt:message key="wsf.label.description"/>
                </label>
                <div class="controls">
                    <textarea name="description"></textarea>
                </div>
            </div>
        </c:if>

        <c:if test="${currentNode.properties['usePriority'].boolean}">
            <div class="control-group">
                <label class="control-label" for="task_priority_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.priority"/>
                </label>
                <div class="controls">
                    <select name="priority" id="task_priority_${currentNode.identifier}">
                        <c:forEach items="${priorities}" var="priority">
                            <option value="${priority.value.string}"
                                    <c:if test="${priority.value.string eq 'normal'}"> selected</c:if>>
                                ${priority.displayName}
                            </option>
                        </c:forEach>
                    </select>
                </div>
            </div>
        </c:if>
        <c:if test="${currentNode.properties['useAssignee'].boolean}">
            <div class="control-group">
                <label class="control-label" for="task_assignee_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.assignee"/>
                </label>

                <div class="controls">
                    <div class="scrollable-dropdown-menu">
                        <input id="task-assignee_${currentNode.identifier}" class="typeahead" type="text"
                               placeholder="${startSearching}">
                    </div>
                    <input type="text" id="assignee_hidden_${currentNode.identifier}" name="assigneeUserKey" class="hide"/>
                </div>
            </div>
        </c:if>
        <c:if test="${currentNode.properties['useDueDate'].boolean}">
            <div class="control-group">
                <label class="control-label" for="task_dueDate_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.dueDate"/>
                </label>

                <div class="controls">
                    <input  type="text" id="dueDate_hidden_${currentNode.identifier}" value="" name="dueDate" class="hide"/>
                    <div id="datePicker_${currentNode.identifier}" class="input-append">
                        <input id="task_dueDate_${currentNode.identifier}" name="dueDate-picker" type="text" disabled/>
                        <span class="add-on">
                            <i data-date-icon="fa fa-calendar"></i>
                        </span>
                    </div>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="task_dueTime_${currentNode.identifier}">
                    <fmt:message key="wsf.label.at"/>
                </label>

                <div class="controls">
                    <div id="timePicker_${currentNode.identifier}" class="input-append">
                        <input id="task_dueTime_${currentNode.identifier}" name="dueTime-picker" type="text" disabled/>
                        <span class="add-on">
                            <i data-time-icon="fa fa-clock-o"></i>
                        </span>
                    </div>
                </div>
            </div>
        </c:if>
        <input type="hidden" name="state" value="active"/>
    </div>
    <div class="modal-footer">
        <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
            <fmt:message key="wsf.label.cancel"/>
        </button>
        <button type="submit" id="submit_task_${currentNode.identifier}" class="btn btn-primary SubmitButton">
            <fmt:message key='wsf.label.submit'/>
        </button>
    </div>
</form>
