<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="boootsrap" uri="http://www.jahia.org/tags/bootstrapLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="task" type="org.jahia.services.workflow.WorkflowTask"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<c:url var="urlBase" value="/cms/wsfactory/default/${currentResource.locale}"/>
<jcr:node var="mainNode" uuid="${currentNode.parent.parent.identifier}"/>
<c:set var="mainNodeHtmlId" value="${fn:replace(mainNode.primaryNodeType, ':', '_')}-${mainNode.identifier}"/>

<fmt:message key="wsf.label.hide" var="labelHide"/>
<fmt:message key="wsf.label.show" var="labelShow"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            refreshMoment();
        });
    </script>
</template:addResources>

<div id="currentUserTasks_${currentNode.identifier}">

    <c:if test="${currentResource.workspace ne 'live'}">
        <c:set var="user" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

        <c:if test="${empty user or not jcr:isNodeType(user, 'jnt:user')}">
            <jcr:node var="user" path="${renderContext.user.localPath}"/>
        </c:if>

        <script type="text/javascript">
            var ready = true;
            <c:url  var="reloadurl" value="${url.base}${functions:escapePath(mainNode.path)}.html.ajax">
                <c:forEach items="${param}" var="p">
                    <c:param name="${p.key}" value="${p.value}"/>
                </c:forEach>
            </c:url>

            function sendNewStatus(currentNodeIdentifier, taskIdentifier, task, state, finalOutcome) {
                if (ready) {
                    ready = false;
                    $('.taskaction-complete').addClass('taskaction-disabled');
                    $('.taskaction').addClass('taskaction-disabled');
                    $.post('${urlBase}' + task,
                        {"jcrMethodToCall": "put", "state": state, "finalOutcome": finalOutcome,
                            "form-token": document.forms['tokenForm_' + currentNodeIdentifier + '_' + taskIdentifier].elements['form-token'].value},
                        function () {
                            $('#' + '${mainNodeHtmlId}').load('${reloadurl}', null, function () {
                                $('#' + currentNodeIdentifier).show();
                                $('#taskdetail_' + currentNodeIdentifier + '_' + taskIdentifier).collapse('show');
                            });
                        }, 'json');
                }
            }

            function sendNewAssignee(currentNodeIdentifier, taskIdentifier, task, key) {
                if (ready) {
                    ready = false;
                    $('.taskaction-complete').addClass('taskaction-disabled');
                    $('.taskaction').addClass('taskaction-disabled');
                    $.post('${urlBase}' + task,
                        {"jcrMethodToCall": "put", "state": "active", "assigneeUserKey": key,
                            "form-token": document.forms['tokenForm_' + currentNodeIdentifier + '_' + taskIdentifier].elements['form-token'].value},
                        function () {
                            $('#' + '${mainNodeHtmlId}').load('${reloadurl}', null, function () {
                                $('#' + currentNodeIdentifier).show();
                                $('#taskdetail_' + currentNodeIdentifier + '_' + taskIdentifier).collapse('show');
                            });
                        }, 'json');
                }
            }

            function switchTaskDisplay(currentNodeIdentifier, taskIdentifier) {
                $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).toggleClass('fa-chevron-down fa-chevron-up', 200);
                if ($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title') == wsfi18n['wsf.label.show']) {
                    $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title', wsfi18n['wsf.label.hide']);
                } else {
                    $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title', wsfi18n['wsf.label.show']);
                }
                $('.iconTaskDisplay_' + currentNodeIdentifier).each(function () {
                    if (!$(this).is($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier)) && $(this).hasClass('fa-chevron-up'))
                        $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
                    if (!$(this).is($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                        $(this).attr('title', wsfi18n['wsf.label.show']);
                });
                $(".taskdetail_" + currentNodeIdentifier).each(function () {
                    if(!$(this).is($('#taskdetail_' + currentNodeIdentifier + "_" + taskIdentifier)) && $(this).hasClass('in'))
                        $(this).collapse('hide');
                });
            }
        </script>

        <template:include view="hidden.header"/>

        <div id="tasklist_${currentNode.identifier}">
            <div id="${user.UUID}">
                <c:set value="${currentNode.properties['displayState'].boolean}" var="dispState"/>
                <c:set value="${currentNode.properties['displayDueDate'].boolean}" var="dispDueDate"/>
                <c:set value="${currentNode.properties['displayLastModifiedDate'].boolean}" var="dispLastModifiedDate"/>
                <c:set value="${currentNode.properties['displayAssignee'].boolean}" var="dispAssignee"/>
                <c:set value="${currentNode.properties['displayCreator'].boolean}" var="dispCreator"/>
                <fieldset>
                    <table class="table table-hover table-bordered" id="userTasks_table_${currentNode.identifier}">
                        <thead>
                            <tr>
                                <th class="span6">
                                    <i class="fa fa-tasks"></i>
                                    <fmt:message key="wsf.label.title"/>
                                </th>
                                <c:if test="${dispAssignee}">
                                    <th class="span2">
                                        <i class="fa fa-user"></i>
                                        <fmt:message key="wsf.label.owner"/>
                                    </th>
                                </c:if>
                                <c:if test="${dispCreator}">
                                    <th class="span2">
                                        <i class="fa fa-user"></i>
                                        <fmt:message key="wsf.label.createdBy"/>
                                    </th>
                                </c:if>
                                <c:if test="${dispState}">
                                    <th class="span2">
                                        <i class="fa fa-info"></i>
                                        <fmt:message key="jnt_task.docspace.state"/>
                                    </th>
                                </c:if>
                                <c:choose>
                                    <c:when test="${dispDueDate}">
                                        <th class="span2">
                                            <i class="fa fa-calendar"></i>
                                            <fmt:message key="jnt_task.docspace.dueDate"/>
                                        </th>
                                    </c:when>
                                    <c:when test="${dispLastModifiedDate}">
                                        <th class="span4">
                                            <i class="fa fa-calendar"></i>
                                            <fmt:message key="wsf.label.lastModified"/>
                                        </th>
                                    </c:when>
                                </c:choose>
                            </tr>
                        </thead>
                        <tbody>
                            <%@ include file="docspaceUserTasksTableRow.jspf" %>
                        </tbody>
                    </table>
                </fieldset>
            </div>
            <div class="clearfix"></div>
        </div>
        <template:include view="hidden.footer"/>
    </c:if>
</div>
