<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="boootsrap" uri="http://www.jahia.org/tags/bootstrapLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="task" type="org.jahia.services.workflow.WorkflowTask"--%>
<template:addResources type="css" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.min.css"/>
<template:addResources type="css" resources="workspace.css"/>
<template:addResources type="css" resources="loading.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="loading.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/locales/bootstrap-datetimepicker.${currentResource.locale}.js"/>

<c:url var="urlBase" value="/cms/wsfactory/default/${currentResource.locale}"/>
<jcr:node var="mainNode" uuid="${currentNode.parent.parent.identifier}"/>
<c:set var="mainNodeHtmlId" value="${fn:replace(mainNode.primaryNodeType, ':', '_')}-${mainNode.identifier}"/>

<fmt:message key="wsf.label.hide" var="labelHide"/>
<fmt:message key="wsf.label.show" var="labelShow"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            refreshMoment();
        });
    </script>
</template:addResources>

<div id="currentUserTasks_${currentNode.identifier}">

    <c:if test="${currentResource.workspace ne 'live'}">
        <c:set var="user" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

        <c:if test="${empty user or not jcr:isNodeType(user, 'jnt:user')}">
            <jcr:node var="user" path="${renderContext.user.localPath}"/>
        </c:if>

        <script type="text/javascript">
            var ready = true;
            <c:url  var="reloadurl" value="${url.base}${functions:escapePath(mainNode.path)}.html.ajax">
                <c:forEach items="${param}" var="p">
                    <c:param name="${p.key}" value="${p.value}"/>
                </c:forEach>
            </c:url>

            function sendNewStatus(currentNodeIdentifier, taskIdentifier, task, state, finalOutcome) {
                if (ready) {
                    ready = false;
                    $('.taskaction-complete').addClass('taskaction-disabled');
                    $('.taskaction').addClass('taskaction-disabled');
                    $.post('${urlBase}' + task,
                        {"jcrMethodToCall": "put", "state": state, "finalOutcome": finalOutcome,
                            "form-token": document.forms['tokenForm_' + currentNodeIdentifier + '_' + taskIdentifier].elements['form-token'].value},
                        function () {
                            $('#' + '${mainNodeHtmlId}').load('${reloadurl}', null, function () {
                                $('#' + currentNodeIdentifier).show();
                                $('#taskdetail_' + currentNodeIdentifier + '_' + taskIdentifier).collapse('show');
                            });
                        }, 'json');
                }
            }

            function sendNewAssignee(currentNodeIdentifier, taskIdentifier, task, key) {
                if (ready) {
                    ready = false;
                    $('.taskaction-complete').addClass('taskaction-disabled');
                    $('.taskaction').addClass('taskaction-disabled');
                    $.post('${urlBase}' + task,
                        {"jcrMethodToCall": "put", "state": "active", "assigneeUserKey": key,
                            "form-token": document.forms['tokenForm_' + currentNodeIdentifier + '_' + taskIdentifier].elements['form-token'].value},
                        function () {
                            $('#' + '${mainNodeHtmlId}').load('${reloadurl}', null, function () {
                                $('#' + currentNodeIdentifier).show();
                                $('#taskdetail_' + currentNodeIdentifier + '_' + taskIdentifier).collapse('show');
                            });
                        }, 'json');
                }
            }

            function switchTaskDisplay(currentNodeIdentifier, taskIdentifier) {
                $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).toggleClass('fa-chevron-down fa-chevron-up', 200);
                if ($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title') == wsfi18n['wsf.label.show']) {
                    $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title', wsfi18n['wsf.label.hide']);
                } else {
                    $('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier).attr('title', wsfi18n['wsf.label.show']);
                }
                $('.iconTaskDisplay_' + currentNodeIdentifier).each(function () {
                    if (!$(this).is($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier)) && $(this).hasClass('fa-chevron-up'))
                        $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
                    if (!$(this).is($('#iconTaskDisplay_' + currentNodeIdentifier + '_' + taskIdentifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                        $(this).attr('title', wsfi18n['wsf.label.show']);
                });
                $(".taskdetail_" + currentNodeIdentifier).each(function () {
                    if(!$(this).is($('#taskdetail_' + currentNodeIdentifier + "_" + taskIdentifier)) && $(this).hasClass('in'))
                        $(this).collapse('hide');
                });
            }

            function removeTask(taskId) {
                bootbox.confirm(wsfi18n['jnt_currentUserTasks.docspace.deleteTaskAlert'], function(result) {
                    if (result) {
                        $.ajax({
                            url : '<c:url value="${url.base}${functions:escapePath(currentNode.path)}.manageTasks.do"/>',
                            type : "post",
                            data : "actionType=deleteTask&taskId=" + taskId,
                            success : function() {
                                hideLoading();
                                bootbox.alert(wsfi18n['jnt_currentUserTasks.docspace.deleteSuccessfulAlert'], function() {
                                    window.location.reload();
                                });
                            },
                            error : function() {
                                hideLoading();
                                bootbox.alert(wsfi18n['jnt_currentUserTasks.docspace.deleteFailedAlert'], function() {
                                    window.location.reload();
                                });
                            }
                        });
                    }
                });
            }

            function editTask(event, taskId, currentNodeId) {
                //Collect task data
                var element = $(event.currentTarget);
                var td = element.parent().parent();
                var date = moment(element.data("taskduedate")).locale('${currentResource.locale}');
                var title = element.data("tasktitle");
                var assignee = element.data("assignee");
                var priority = td.find(".taskPriority").html();
                var description = td.find(".taskDescription").html();

                //Clear fields
                $("#taskDescription_" + currentNodeId).val("");

                //Set task properties
                setTimeout(function() {
                    $("#jcr-title_" + currentNodeId).val(title);
                    if (description != undefined)
                        $("#taskDescription_" + currentNodeId).val(description);

                    if (assignee != undefined) {
                        $("#assignee_hidden_" + currentNodeId).val(assignee);
                        $("#task-assignee_" + currentNodeId).val(assignee.split("/").slice(-1));
                    }

                    $("#task_priority_" + currentNodeId + " option:contains(" + priority + ")").prop({selected : true});

                    $("#task_dueDate_" + currentNodeId).val(date.format('L'));
                    $("#task_dueTime_" + currentNodeId).val(date.format('HH:mm'));
                    $("#taskId_" + currentNodeId).val(taskId);
                }, 200);
            }

            $(document).ready(function() {
                $('#datePicker_${currentNode.identifier}').datetimepicker({
                    language: '${currentResource.locale}',
                    format: moment().locale('${currentResource.locale}')._locale._longDateFormat.L,
                    startDate: new Date(),
                    toggleActive: true,
                    pickTime: false
                }).on('changeDate', function() {
                    if ($('.datepicker-days').css('display') === 'block')
                        $('.bootstrap-datetimepicker-widget').hide();
                });

                $('#timePicker_${currentNode.identifier}').datetimepicker({
                    language: '${currentResource.locale}',
                    format: 'hh:mm',
                    startDate: new Date(),
                    toggleActive: true,
                    pickDate: false,
                    pickSeconds: false
                });

                $(".bootstrap-datetimepicker-widget").each(function(){$(this).css("z-index", 1060)});

                $("#updateTaskForm_${currentNode.identifier}").on("submit", function(e) {
                    e.preventDefault();

                    var dateToUse;
                    var datePicked = $('#task_dueDate_${currentNode.identifier}').val();
                    if (datePicked === '') {
                        dateToUse = moment().locale('${currentResource.locale}').endOf('day').toISOString();
                    } else {
                        var timePicked = $('#task_dueTime_${currentNode.identifier}').val();
                        var dateFormat = moment().locale('${currentResource.locale}')._locale._longDateFormat.L;
                        if (timePicked === '') {
                            dateToUse = moment(datePicked, dateFormat)
                                    .locale('${currentResource.locale}').endOf('day').toISOString();
                        } else {
                            dateToUse = moment(datePicked + " " + timePicked, dateFormat + " HH:mm").toISOString();
                            if (moment().isAfter(dateToUse)) {
                                dateToUse = moment().add(1, 'hour').toISOString();
                            }
                        }
                    }

                    $("#dueDate_hidden_${currentNode.identifier}").val(dateToUse);

                    var formData = $(this).serialize();

                    showLoading(wsfi18n['wsf.title.workInProgress']);
                    $.ajax({
                        url : '<c:url value="${url.base}${functions:escapePath(currentNode.path)}.manageTasks.do"/>',
                        type : "post",
                        data : formData + "&actionType=updateTask",
                        success : function() {
                                window.location.reload();
                        },
                        error : function() {
                            hideLoading();
                            bootbox.alert(wsfi18n['jnt_currentUserTasks.docspace.updateFailedAlert'], function() {
                                window.location.reload();
                            });
                        }
                    });
                });

                //Add assignee initialization
                var taskAssigneeTH = new Bloodhound({
                    datumTokenizer: Bloodhound.tokenizers.whitespace(),
                    queryTokenizer: Bloodhound.tokenizers.whitespace,
                    remote: {
                        url: '${url.findUser}' + "?q=___QUERY",
                        wildcard: '___QUERY',
                        ajax : {
                            type: "GET",
                            dataType: 'json',
                            data: {
                                limit: 10
                            }
                        },
                        filter: function(users) {
                            return $.map(users, function(user) {
                                var value = user['j:firstName'] || '';
                                if (value.length != 0) {
                                    value += ' ';
                                }
                                value += user['j:lastName'] || '';
                                var title = value.length > 0 ? value : user['username'];
                                var username = user['username'];
                                return {
                                    userName: username != title ? title + " (" + username + ")" : username,
                                    userKey: user['userKey']
                                };
                            });
                        }
                    },
                    limit: 10
                });
                taskAssigneeTH.initialize();

                // Instantiate the Typeahead UI
                $('#task-assignee_${currentNode.identifier}').typeahead(null, {
                    displayKey: 'userName',
                    source: taskAssigneeTH.ttAdapter(),
                    highlight: true,
                    autocomplete: true
                });

                $('#task-assignee_${currentNode.identifier}').bind('typeahead:selected', function(obj, datum) {
                    $('#assignee_hidden_${currentNode.identifier}').val(datum['userKey']);
                });
                $('#task-assignee_${currentNode.identifier}').bind('typeahead:autocompleted', function(obj, datum) {
                    $('#assignee_hidden_${currentNode.identifier}').val(datum['userKey']);
                });
                $('#task-assignee_${currentNode.identifier}').on("focusout", function() {
                    if ($(this).val().trim() == "")
                        $('#assignee_hidden_${currentNode.identifier}').val("");
                })
            });
        </script>

        <template:include view="hidden.header"/>

        <div id="tasklist_${currentNode.identifier}">
            <div id="${user.UUID}">
                <c:set value="${currentNode.properties['displayState'].boolean}" var="dispState"/>
                <c:set value="${currentNode.properties['displayDueDate'].boolean}" var="dispDueDate"/>
                <c:set value="${currentNode.properties['displayLastModifiedDate'].boolean}" var="dispLastModifiedDate"/>
                <c:set value="${currentNode.properties['displayAssignee'].boolean}" var="dispAssignee"/>
                <c:set value="${currentNode.properties['displayCreator'].boolean}" var="dispCreator"/>
                <fieldset>
                    <table class="table table-hover table-bordered" id="userTasks_table_${currentNode.identifier}">
                        <thead>
                            <tr>
                                <th class="span6">
                                    <i class="fa fa-tasks"></i>
                                    <fmt:message key="wsf.label.title"/>
                                </th>
                                <c:if test="${dispAssignee}">
                                    <th class="span2">
                                        <i class="fa fa-user"></i>
                                        <fmt:message key="wsf.label.owner"/>
                                    </th>
                                </c:if>
                                <c:if test="${dispCreator}">
                                    <th class="span2">
                                        <i class="fa fa-user"></i>
                                        <fmt:message key="wsf.label.createdBy"/>
                                    </th>
                                </c:if>
                                <c:if test="${dispState}">
                                    <th class="span2">
                                        <i class="fa fa-info"></i>
                                        <fmt:message key="jnt_task.docspace.state"/>
                                    </th>
                                </c:if>
                                <c:choose>
                                    <c:when test="${dispDueDate}">
                                        <th class="span2">
                                            <i class="fa fa-calendar"></i>
                                            <fmt:message key="jnt_task.docspace.dueDate"/>
                                        </th>
                                    </c:when>
                                    <c:when test="${dispLastModifiedDate}">
                                        <th class="span4">
                                            <i class="fa fa-calendar"></i>
                                            <fmt:message key="wsf.label.lastModified"/>
                                        </th>
                                    </c:when>
                                </c:choose>
                            </tr>
                        </thead>
                        <tbody>
                            <%@ include file="docspaceUserTasksTableRow.jspf" %>
                        </tbody>
                    </table>
                </fieldset>
            </div>
            <div class="clearfix"></div>
        </div>
        <template:include view="hidden.footer"/>
    </c:if>
</div>

<jcr:propertyInitializers nodeType="jnt:task" name="priority" var="priorities"/>

<div class="modal hide fade" id="editTaskModal_${currentNode.identifier}">
    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h3><fmt:message key="jnt_currentUserTasks.docspace.editTask" /></h3>
    </div>
    <form class="form-horizontal no-margin-bottom" id="updateTaskForm_${currentNode.identifier}" method="post"
          action="#">
        <input type="hidden" name="taskId" value="" id="taskId_${currentNode.identifier}" />
        <input type="hidden" name="originalDueDate" id="originalDueDate_${currentNode.identifier}" />
        <div class="modal-body">
            <div class="control-group">
                <label class="control-label">
                    <fmt:message key="wsf.label.title"/>
                </label>

                <div class="controls">
                    <input id="jcr-title_${currentNode.identifier}" type="text" name="jcr:title" value=""/>
                    <span id="noTitleError_${currentNode.identifier}" class="help-inline hide"><p class="text-error">
                        <fmt:message key="jnt_createTaskForm.requiredField"/></p></span>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label">
                    <fmt:message key="wsf.label.description"/>
                </label>
                <div class="controls">
                    <textarea name="description" id="taskDescription_${currentNode.identifier}"></textarea>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="task_priority_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.priority"/>
                </label>
                <div class="controls">
                    <select name="priority" id="task_priority_${currentNode.identifier}">
                        <c:forEach items="${priorities}" var="priority">
                            <option value="${priority.value.string}">
                                    ${priority.displayName}
                            </option>
                        </c:forEach>
                    </select>
                </div>
            </div>

            <div class="control-group" id="assignee_control_${currentNode.identifier}">
                <label class="control-label" for="task_assignee_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.assignee"/>
                </label>

                <div class="controls">
                    <div class="scrollable-dropdown-menu">
                        <input id="task-assignee_${currentNode.identifier}" class="typeahead" type="text"
                               placeholder="${startSearching}">
                    </div>
                    <input type="text" id="assignee_hidden_${currentNode.identifier}" name="assigneeUserKey" class="hide"/>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="task_dueDate_${currentNode.identifier}">
                    <fmt:message key="jnt_task.docspace.dueDate"/>
                </label>

                <div class="controls">
                    <input  type="text" id="dueDate_hidden_${currentNode.identifier}" name="dueDate" class="hide"/>
                    <div id="datePicker_${currentNode.identifier}" class="input-append">
                        <input id="task_dueDate_${currentNode.identifier}" name="dueDate-picker" type="text" disabled/>
                            <span class="add-on">
                                <i data-date-icon="fa fa-calendar"></i>
                            </span>
                    </div>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="task_dueTime_${currentNode.identifier}">
                    <fmt:message key="wsf.label.at"/>
                </label>

                <div class="controls">
                    <div id="timePicker_${currentNode.identifier}" class="input-append">
                        <input id="task_dueTime_${currentNode.identifier}" name="dueTime-picker" type="text" disabled/>
                            <span class="add-on">
                                <i data-time-icon="fa fa-clock-o"></i>
                            </span>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
                <fmt:message key="wsf.label.cancel"/>
            </button>
            <button type="submit" id="submit_task_${currentNode.identifier}" class="btn btn-primary SubmitButton">
                <fmt:message key='wsf.label.submit'/>
            </button>
        </div>
    </form>
</div>
