<%@ page import="org.apache.commons.lang.StringUtils" %>
<%@ page import="org.jahia.services.content.JCRNodeWrapper" %>
<%@ page import="javax.jcr.RepositoryException" %>
<%@ page import="javax.jcr.Value" %>
<%@ page import="java.util.HashSet" %>
<%@ page import="javax.servlet.jsp.PageContext" %>
<%@ page import="org.jahia.services.content.JCRPropertyWrapper" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%!
    final String PUBLICPROPERTIES_PROPERTY = "j:publicProperties";

    HashSet<String> getPublicProperties(PageContext pageContext) throws RepositoryException {
        HashSet<String> publicProperties = (HashSet<String>) pageContext.getAttribute("editUserDetailsPublicProperties");
        if (publicProperties != null) {
            return new HashSet<String>(publicProperties);
        } else {
            publicProperties = new HashSet<String>();
            JCRNodeWrapper user = (JCRNodeWrapper) pageContext.getAttribute("user");
            Value[] values = null;
            if (user.hasProperty(PUBLICPROPERTIES_PROPERTY)) {
                values = user.getProperty(PUBLICPROPERTIES_PROPERTY).getValues();
            }
            if (values != null) {
                for (Value value : values) {
                    publicProperties.add("&quot;" + value.getString() + "&quot;");
                }
            }
            pageContext.setAttribute("editUserDetailsPublicProperties", publicProperties);
            return publicProperties;
        }
    }

    String getPublicPropertiesData(PageContext pageContext, String propertyName) throws RepositoryException {
        HashSet<String> publicProperties = getPublicProperties(pageContext);
        publicProperties.add("&quot;" + propertyName + "&quot;");
        return "{&quot;" + PUBLICPROPERTIES_PROPERTY + "&quot;:[" + StringUtils.join(publicProperties, ",") + "]}";
    }
%>

<c:set var="user" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:if test="${!empty param.userUuid}">
    <jcr:node var="user" uuid="${param.userUuid}"/>
</c:if>
<c:if test="${empty user or not jcr:isNodeType(user, 'jnt:user')}">
    <jcr:node var="user" path="${renderContext.user.localPath}"/>
</c:if>

<template:addResources type="css" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.min.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.ajaxfileupload.js"/>
<template:addResources type="javascript" resources="bootstrap-tooltip.js"/>
<template:addResources type="javascript" resources="bootstrap-popover.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>
<template:addResources type="javascript" resources="ckeditor.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/locales/bootstrap-datetimepicker.${currentResource.locale}.js"/>
<template:addResources type="javascript" resources="jcrestapi.js"/>

<template:addCacheDependency node="${user}"/>

<c:set var="fields" value="${user.propertiesAsString}"/>
<jcr:nodePropertyRenderer node="${user}" name="j:title" renderer="resourceBundle" var="title"/>
<c:if test="${not empty title and not empty fields['j:firstName'] and not empty fields['j:lastName']}">
    <c:set var="person" value="${title.displayName} ${fields['j:firstName']} ${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and not empty fields['j:firstName'] and not empty fields['j:lastName']}">
    <c:set var="person" value="${fields['j:firstName']} ${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and empty fields['j:firstName'] and not empty fields['j:lastName']}">
    <c:set var="person" value="${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and not empty fields['j:firstName'] and empty fields['j:lastName']}">
    <c:set var="person" value="${fields['j:firstName']}"/>
</c:if>
<c:if test="${empty title and empty fields['j:firstName'] and empty fields['j:lastName']}">
    <c:set var="person" value=""/>
</c:if>

<jcr:propertyInitializers node="${user}" name="j:gender" var="genderInit"/>
<jcr:propertyInitializers node="${user}" name="j:title" var="titleInit"/>

<template:addResources>
    <script type="text/javascript">

        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };

        var API_URL_START = '<c:url value="/modules/api/jcr/v1"/>';
        var URL_FILES = '<c:url value="${url.files}${functions:escapePath(user.path)}"/>';

        $(document).ready(function() {
            // Tooltip to display message click to edit
            $('.popoverTooltip').tooltip({
                placement: 'top',
                title: '<fmt:message key="wsf.label.clickToEdit"/>',
                container: 'body'
            });

            // Birthdate process
            if ('${fields['j:birthDate']}' != '') {
                var currentDate = moment();
                var birthdate = moment('${fields['j:birthDate']}');
                birthdate.locale('${currentResource.locale}');
                $('#popoverBirthdate${currentNode.identifier}').html(birthdate.format('LL'));
                $('#popoverBirthdate${currentNode.identifier}').attr('data-property-value', birthdate.format('YYYY-MM-DD'));
                $('#datepicker_popoverBirthdate${currentNode.identifier}').val(birthdate.format('YYYY-MM-DD'));
                $('#currentAge${currentNode.identifier}').html(currentDate.diff(birthdate, 'years') + ' <fmt:message key="jnt_user.profile.years"/>');
            }

            // Toggle one popover at a time
            $('.popoverTooltip').on('click', function() {
                $("#datePickerDiv_popoverBirthdate${currentNode.identifier}").appendTo($("#originDatePickerDiv_popoverBirthdate${currentNode.identifier}"));
                !$('.popoverTooltip').is(this).popover('hide');

            });

            // Popover template
            $('.popoverEdit${currentNode.identifier}').popover({
                html : true,
                placement: 'top',
                content: function() {
                    var popoverData = {
                        elementType: $(this).data('element-type'),
                        popoverButtonID:  $(this).attr('id'),
                        elementID: $(this).data('element-type') + '_' + $(this).attr('id'),
                        propertyJcrID: $(this).data("property-jcrid"),
                        currentValue: $(this).data("property-value"),
                        labelOK: '<fmt:message key="wsf.label.ok"/>',
                        labelCancel: wsfi18n['wsf.label.cancel'],
                        optionsMap: $(this).data('property-options')
                    };

                    var popoverTemplate = _.template('<form <@ if (elementType != "fileUpload") { @> onsubmit="return false;" <@ } @>>' +
                            '<@ if (elementType == "input") { @>' +
                                '<input id="<@= elementID @>" type="text" value="<@= currentValue @>">' +
                            '<@ } else if (elementType == "select") { @>' +
                                '<select id="<@= elementID @>">' +
                                    '<@ _.each(optionsMap, function(v, k){ @>' +
                                        '<option value="<@= k @>" <@ if (k == currentValue) { @> selected <@ }@> ><@= v @></option>' +
                                    '<@ }); @>' +
                                '</select>' +
                            '<@ } else if (elementType == "ckeditor") { @>' +
                                '<textarea id="<@= elementID @>"><@= currentValue @></textarea>' +
                                '<@ $(document).on("shown.bs.popover", function() { ' +
                                    '$("#" + elementID).parent().parent().parent().css("max-width", "500px");' +
                                    '$("#" + elementID).ckeditor({toolbar:"Mini"});' +
                                '}); @>' +
                            '<@ } else if (elementType == "datepicker") { @>' +
                                '<div id="divToAppend_<@= popoverButtonID @>"></div>' +
                            '<@ } else if (elementType == "fileUpload") { @>' +
                                '<input id="<@= elementID @>" type="file" name="file" value="<@= currentValue @>" accept="image/*">' +
                            '<@ } @>' +
                            '<button class="btn btn-primary margin-right-10" type="button" onclick="updateProperty(\'<@= popoverButtonID @>\', \'<@= elementID @>\', \'<@= propertyJcrID @>\')" autofocus><@= labelOK @></button>' +
                            '<button class="btn btn-danger" type="button" onclick="closePopover(\'<@= popoverButtonID @>\')"><@= labelCancel @></button>' +
                            '<div id="errorMessage<@= popoverButtonID @>" class="text-error hide"></div>' +
                        '</form>');

                    return popoverTemplate(popoverData);
                }
            });
            $('.popoverEdit${currentNode.identifier}').on("shown.bs.popover", function () {
                if($(this).attr("id")=="popoverBirthdate${currentNode.identifier}") {
                    $("#datePickerDiv_popoverBirthdate${currentNode.identifier}").appendTo($("#divToAppend_popoverBirthdate${currentNode.identifier}"));
                    $(".bootstrap-datetimepicker-widget").css("z-index", "10000");
                }
            });
        });

        function updateProperty(popoverButtonID, propertyValueID, propertyJcrID) {
            if ($('#' + propertyValueID).val() == $('#' + popoverButtonID).data('property-value')) {
                closePopover(popoverButtonID);
            } else {
                var phoneRegex = /^[0-9]{1,45}$/;
                var emailRegex = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;

                if ($('#' + popoverButtonID).data('property-jcrid') == 'j:email' && !emailRegex.test($('#' + propertyValueID).val())) {
                    $('#errorMessage' + popoverButtonID).html('<fmt:message key="failure.invalid.emailAddress"/>');
                    $('#errorMessage' + popoverButtonID).show();
                    return false;
                }
                if (($('#' + popoverButtonID).data('property-jcrid') == 'j:phoneNumber' || $('#' + popoverButtonID).data('property-jcrid') == 'j:mobileNumber') && !phoneRegex.test($('#' + propertyValueID).val())) {
                    $('#errorMessage' + popoverButtonID).html('<fmt:message key="mySettings.errors.phone.format"/>');
                    $('#errorMessage' + popoverButtonID).show();
                    return false;
                }

                if ($('#' + popoverButtonID).data('property-jcrid') == 'j:picture') {
                    updatePhoto(propertyValueID, '${currentResource.locale}', '${user.path}', '${user.identifier}', ajaxReloadCallback, formError);
                } else {
                    var json;
                    if ($('#' + popoverButtonID).data('property-jcrid') == 'j:birthDate') {
                        json = JSON.stringify({value: moment($('#' + propertyValueID).val())});
                    } else {
                        json = JSON.stringify({value: $('#' + propertyValueID).val()});
                    }
                    jahiaAPIStandardCall('default', '${currentResource.locale}', 'nodes', '${user.identifier}/properties/' + propertyJcrID.replace(':', '__'), 'PUT', json, ajaxReloadCallback);
                }
            }
        }

        var ajaxReloadCallback = function (jcrId) {
            window.location.reload();
            if (jcrId == 'preferredLanguage') {
                window.location.reload();
            } else {
                $('#user-profile').parent().load('<c:url value="${url.baseLive}${functions:escapePath(currentNode.path)}.docspace.html.ajax?includeJavascripts=true&userUuid=${user.identifier}"/>');
            }
        };

        function closePopover(popoverButtonID) {
            $('#' + popoverButtonID).popover('hide');
        }
    </script>
</template:addResources>

<div class="row-fluid">
    <div class="span3 text-center">
        <c:if test="${currentNode.properties['j:picture'].boolean}">
            <jcr:nodeProperty var="picture" node="${user}" name="j:picture"/>
            <c:choose>
                <c:when test="${not empty picture}">
                    <img class="img-circle img-polaroid" src="${picture.node.thumbnailUrls['avatar_120']}" alt="${fn:escapeXml(person)}"/>
                </c:when>
                <c:otherwise>
                    <img class="img-circle img-polaroid" src="<c:url value='${url.currentModule}/img/userbig.png'/>" alt="" border="0"/>
                </c:otherwise>
            </c:choose>
            <c:if test="${user:isPropertyEditable(user,'j:picture')}">
                <br />
                <br />
                <button id="popoverPicture${currentNode.identifier}" class="btn btn-link popoverTooltip popoverEdit${currentNode.identifier}"
                        data-element-type="fileUpload"
                        data-title="<fmt:message key='importfile.label'/>"
                        data-property-jcrid="j:picture">
                    <fmt:message key='importfile.label'/>
                </button>
            </c:if>
        </c:if>
        <ul class="unstyled">
            <c:if test="${currentNode.properties['j:skypeID'].boolean}">
                <li>
                    <dl>
                        <dt>
                            <c:choose>
                                <c:when test="${not empty fields['j:skypeID']}">
                                    <script type="text/javascript" src="http://www.skypeassets.com/i/scom/js/skype-uri.js"></script>
                                    <div id="SkypeButton_Call_${fields['j:skypeID']}_1">
                                        <script type="text/javascript">
                                            Skype.ui({
                                                "name": "dropdown",
                                                "element": "SkypeButton_Call_${fields['j:skypeID']}_1",
                                                "participants": ["${fields['j:skypeID']}"],
                                                "imageSize": 24
                                            });
                                            $('#SkypeButton_Call_' + '${fields['j:skypeID']}' + '_1_paraElement').css('height', '35px');
                                        </script>
                                    </div>
                                </c:when>
                                <c:otherwise>
                                    <fmt:message key='jnt_user.j_skypeID'/>
                                </c:otherwise>
                            </c:choose>
                        </dt>
                        <dd>
                            <button id="popoverSkype${currentNode.identifier}" class="btn btn-link popoverTooltip popoverEdit${currentNode.identifier}"
                                    data-element-type="input"
                                    data-title="<fmt:message key='jnt_user.j_skypeID'/>"
                                    data-property-value="${fn:escapeXml(fields['j:skypeID'])}"
                                    data-property-jcrid="j:skypeID">
                                <fmt:message key="wsf.label.clickToEdit"/>
                            </button>
                        </dd>
                    </dl>
                </li>
            </c:if>
            <c:if test="${currentNode.properties['j:twitterID'].boolean}">
                <li>
                    <dl>
                        <dt>
                            <c:choose>
                                <c:when test="${not empty fields['j:twitterID']}">
                                    <a href="https://twitter.com/${fields['j:twitterID']}" class="twitter-follow-button" data-show-count="false">
                                        Follow @${fields['j:twitterID']}
                                    </a>
                                    <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
                                </c:when>
                                <c:otherwise>
                                    <fmt:message key='jnt_user.j_twitterID'/>
                                </c:otherwise>
                            </c:choose>
                        </dt>
                        <dd>
                            <button id="popoverTwitter${currentNode.identifier}" class="btn btn-link popoverTooltip popoverEdit${currentNode.identifier}"
                                    data-element-type="input"
                                    data-title="<fmt:message key='jnt_user.j_twitterID'/>"
                                    data-property-value="${fn:escapeXml(fields['j:twitterID'])}"
                                    data-property-jcrid="j:twitterID">
                                <fmt:message key="wsf.label.clickToEdit"/>
                            </button>
                        </dd>
                    </dl>
                </li>
            </c:if>
            <c:if test="${currentNode.properties['j:facebookID'].boolean}">
                <li>
                    <dl>
                        <dt>
                            <c:choose>
                                <c:when test="${not empty fields['j:facebookID']}">
                                    <a href="http://www.facebook.com/${fields['j:facebookID']}" target="_blank" title="${fields['j:facebookID']}">
                                        <i class="fa fa-facebook"></i>
                                        ${fields['j:facebookID']}
                                    </a>
                                </c:when>
                                <c:otherwise>
                                    <fmt:message key='jnt_user.j_facebookID'/>
                                </c:otherwise>
                            </c:choose>
                        </dt>
                        <dd>
                            <button id="popoverFacebook${currentNode.identifier}" class="btn btn-link popoverTooltip popoverEdit${currentNode.identifier}"
                                    data-element-type="input"
                                    data-title="<fmt:message key='jnt_user.j_facebookID'/>"
                                    data-property-value="${fn:escapeXml(fields['j:facebookID'])}"
                                    data-property-jcrid="j:facebookID">
                                <fmt:message key="wsf.label.clickToEdit"/>
                            </button>
                        </dd>
                    </dl>
                </li>
            </c:if>
            <c:if test="${currentNode.properties['j:linkedinID'].boolean}">
                <li>
                    <dl>
                        <dt>
                            <c:choose>
                                <c:when test="${not empty fields['j:linkedinID']}">
                                    <a href="http://www.linkedin.com/in/${fields['j:linkedinID']}" target="_blank" title="${fields['j:linkedinID']}">
                                        <i class="fa fa-linkedin"></i>
                                        ${fields['j:linkedinID']}
                                    </a>
                                </c:when>
                                <c:otherwise>
                                    <fmt:message key='jnt_user.j_linkedinID'/>
                                </c:otherwise>
                            </c:choose>
                        </dt>
                        <dd>
                            <button id="popoverLinkedin${currentNode.identifier}" class="btn btn-link popoverTooltip popoverEdit${currentNode.identifier}"
                                    data-element-type="input"
                                    data-title="<fmt:message key='jnt_user.j_linkedinID'/>"
                                    data-property-value="${fn:escapeXml(fields['j:linkedinID'])}"
                                    data-property-jcrid="j:linkedinID">
                                <fmt:message key="wsf.label.clickToEdit"/>
                            </button>
                        </dd>
                    </dl>
                </li>
            </c:if>
        </ul>
    </div>

    <div class="span9">
        <h3><c:if test="${not empty fn:trim(person)}">${fn:escapeXml(person)}&nbsp;</c:if></h3>

        <c:if test="${currentNode.properties['j:title'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_user.j_title"/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:firstName')}">
                            <span id="popoverTitle${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="select"
                                  data-title="<fmt:message key='jnt_user.j_title'/>"
                                  data-property-value="${fn:escapeXml(fields['j:title'])}"
                                  data-property-jcrid="j:title"
                                  data-property-options='{<c:forEach items="${titleInit}" varStatus="status" var="title"><c:if test="${status.index > 0}">,</c:if>"${title.value.string}":"${title.displayName}"</c:forEach>}'>
                                <c:choose>
                                    <c:when test="${empty fields['j:title']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        <jcr:nodePropertyRenderer node="${user}" name="j:title" renderer="resourceBundle"/>
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            <jcr:nodePropertyRenderer node="${user}" name="j:title" renderer="resourceBundle"/>
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:firstName'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_firstName'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:firstName')}">
                            <span id="popoverFirstName${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_firstName'/>"
                                  data-property-value="${fn:escapeXml(fields['j:firstName'])}"
                                  data-property-jcrid="j:firstName">
                                <c:choose>
                                    <c:when test="${empty fields['j:firstName']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:firstName'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:firstName'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:lastName'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_lastName'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:lastName')}">
                            <span id="popoverLastName${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_lastName'/>"
                                  data-property-value="${fn:escapeXml(fields['j:lastName'])}"
                                  data-property-jcrid="j:lastName">
                                <c:choose>
                                    <c:when test="${empty fields['j:lastName']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:lastName'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:lastName'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:gender'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_user.profile.gender"/> : </dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:gender')}">
                            <span id="popoverGender${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="select"
                                  data-title="<fmt:message key='jnt_user.profile.gender'/>"
                                  data-property-value="${fn:escapeXml(fields['j:gender'])}"
                                  data-property-jcrid="j:gender"
                                  data-property-options='{<c:forEach items="${genderInit}" varStatus="status" var="gender"><c:if test="${status.index > 0}">,</c:if>"${gender.value.string}":"${gender.displayName}"</c:forEach>}'>
                                <c:choose>
                                    <c:when test="${empty fields['j:gender']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:gender'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:gender'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:birthDate'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_user.j_birthDate"/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:birthDate')}">
                            <span id="popoverBirthdate${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="datepicker"
                                  data-title="<fmt:message key='jnt_user.j_birthDate'/>"
                                  data-property-value=""
                                  data-property-jcrid="j:birthDate">
                                <fmt:message key="wsf.label.clickToEdit"/>
                            </span>
                            <div id="originDatePickerDiv_popoverBirthdate${currentNode.identifier}" class="hide">
                                <div id="datePickerDiv_popoverBirthdate${currentNode.identifier}" class="input-append">
                                    <input id="datepicker_popoverBirthdate${currentNode.identifier}" type="text" data-format="yyyy-MM-dd" value="" disabled>
                                    <span class="add-on"><i class="fa fa-calendar"></i></span>
                                </div>
                            </div>
                            <script type="text/javascript">
                                $(document).ready(function() {
                                    $("#datePickerDiv_popoverBirthdate${currentNode.identifier}").datetimepicker({
                                        language: '${currentResource.locale}',
                                        pickTime: false
                                    });
                                });
                            </script>
                        </c:when>
                        <c:otherwise>
                            <span id="popoverBirthdate${currentNode.identifier}">

                            </span>
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>

            <c:if test="${currentNode.properties['age'].boolean}">
                <dl class="dl-horizontal">
                    <dt><fmt:message key="jnt_user.age"/></dt>
                    <dd id="currentAge${currentNode.identifier}">0&nbsp;<fmt:message key="jnt_user.profile.years"/></dd>
                </dl>
            </c:if>
        </c:if>

        <c:if test="${currentNode.properties['j:organization'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_organization'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:organization')}">
                            <span id="popoverOrganization${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_organization'/>"
                                  data-property-value="${fn:escapeXml(fields['j:organization'])}"
                                  data-property-jcrid="j:organization">
                                <c:choose>
                                    <c:when test="${empty fields['j:organization']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:organization'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:organization'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:function'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_function'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:function')}">
                            <span id="popoverFunction${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_function'/>"
                                  data-property-value="${fn:escapeXml(fields['j:function'])}"
                                  data-property-jcrid="j:function">
                                <c:choose>
                                    <c:when test="${empty fields['j:function']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:function'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:function'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:address'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_address'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:address')}">
                            <span id="popoverAddress${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_address'/>"
                                  data-property-value="${fn:escapeXml(fields['j:address'])}"
                                  data-property-jcrid="j:address">
                                <c:choose>
                                    <c:when test="${empty fields['j:address']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:address'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:address'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:zipCode'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_zipCode'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:zipCode')}">
                            <span id="popoverZipCode${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_zipCode'/>"
                                  data-property-value="${fn:escapeXml(fields['j:zipCode'])}"
                                  data-property-jcrid="j:zipCode">
                                <c:choose>
                                    <c:when test="${empty fields['j:zipCode']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:zipCode'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:zipCode'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:city'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_city'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:city')}">
                            <span id="popoverCity${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_city'/>"
                                  data-property-value="${fn:escapeXml(fields['j:city'])}"
                                  data-property-jcrid="j:city">
                                <c:choose>
                                    <c:when test="${empty fields['j:city']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:city'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:city'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:country'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_country'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:country')}">
                            <span id="popoverCountry${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_country'/>"
                                  data-property-value="${fn:escapeXml(fields['j:country'])}"
                                  data-property-jcrid="j:country">
                                <c:choose>
                                    <c:when test="${empty fields['j:country']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:country'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:country'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:phoneNumber'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_phoneNumber'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:phoneNumber')}">
                            <span id="popoverPhoneNumber${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_phoneNumber'/>"
                                  data-property-value="${fn:escapeXml(fields['j:phoneNumber'])}"
                                  data-property-jcrid="j:phoneNumber">
                                <c:choose>
                                    <c:when test="${empty fields['j:phoneNumber']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:phoneNumber'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:phoneNumber'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:mobileNumber'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key='jnt_user.j_mobileNumber'/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:mobileNumber')}">
                            <span id="popoverMobileNumber${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_mobileNumber'/>"
                                  data-property-value="${fn:escapeXml(fields['j:mobileNumber'])}"
                                  data-property-jcrid="j:mobileNumber">
                                <c:choose>
                                    <c:when test="${empty fields['j:mobileNumber']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:mobileNumber'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:mobileNumber'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:email'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_user.j_email"/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:email')}">
                            <span id="popoverEmail${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="input"
                                  data-title="<fmt:message key='jnt_user.j_email'/>"
                                  data-property-value="${fn:escapeXml(fields['j:email'])}"
                                  data-property-jcrid="j:email">
                                <c:choose>
                                    <c:when test="${empty fields['j:email']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fn:escapeXml(fields['j:email'])}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(fields['j:email'])}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['j:about'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_userDetails.workspace-factory.aboutMe"/></dt>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'j:about')}">
                            <span id="popoverAbout${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="ckeditor"
                                  data-title="<fmt:message key='jnt_user.j_about'/>"
                                  data-property-value="${fn:escapeXml(fields['j:about'])}"
                                  data-property-jcrid="j:about">
                                <c:choose>
                                    <c:when test="${empty fields['j:about']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${fields['j:about']}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${fields['j:about']}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['preferredLanguage'].boolean}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="jnt_user.preferredLanguage"/></dt>
                <jcr:nodeProperty node="${user}" name="preferredLanguage" var="prefLang"/>
                <c:set var="prefLocale" value="${functions:toLocale(functions:default(prefLang.string, 'en'))}"/>
                <dd>
                    <c:choose>
                        <c:when test="${user:isPropertyEditable(user,'preferredLanguage')}">
                            <span id="popoverPreferredLanguage${currentNode.identifier}" class="text-info popoverTooltip popoverEdit${currentNode.identifier}"
                                  data-element-type="select"
                                  data-title="<fmt:message key='jnt_user.preferredLanguage'/>"
                                  data-property-value="${prefLocale}"
                                  data-property-jcrid="preferredLanguage"
                                  data-property-options='{<c:forEach items="${functions:availableAdminBundleLocale(renderContext.mainResourceLocale)}" var="adLocale" varStatus="status"><c:if test="${status.index > 0}">,</c:if>"${adLocale}":"${functions:escapeJavaScript(functions:displayLocaleNameWith(adLocale, adLocale))}"</c:forEach>}'>
                                <c:choose>
                                    <c:when test="${empty fields['preferredLanguage']}">
                                        <fmt:message key="wsf.label.clickToEdit"/>
                                    </c:when>
                                    <c:otherwise>
                                        ${functions:displayLocaleNameWith(prefLocale, prefLocale)}
                                    </c:otherwise>
                                </c:choose>
                            </span>
                        </c:when>
                        <c:otherwise>
                            ${functions:displayLocaleNameWith(prefLocale, prefLocale)}
                        </c:otherwise>
                    </c:choose>
                </dd>
            </dl>
        </c:if>

        <c:if test="${currentNode.properties['password'].boolean and !(user.properties['j:external'].boolean)}">
            <dl class="dl-horizontal">
                <dt><fmt:message key="wsf.label.password"/></dt>
                <dd>
                    <span id="popoverPassword${currentNode.identifier}" class="text-info popoverTooltip popoverPasswordEdit${currentNode.identifier}"
                          data-title="<fmt:message key='wsf.label.password'/>"
                          data-property-value="${fields['j:about']}"
                          data-property-jcrid="j:about">
                        <fmt:message key="wsf.label.clickToEdit"/>
                    </span>
                </dd>
            </dl>

            <script type="text/javascript">
                $(document).ready(function () {

                    $('.popoverPasswordEdit${currentNode.identifier}').popover({
                        html : true,
                        placement: 'top',
                        content: function() {
                            return '<form>' +
                                        '<fmt:message key="mySettings.oldPassword"/>' +
                                        '<input type="password" id="oldpassword${currentNode.identifier}" name="oldpassword${currentNode.identifier}" autocomplete="off"/>' +
                                        '<fmt:message key="wsf.label.password"/>' +
                                        '<input type="password" id="password${currentNode.identifier}" name="password${currentNode.identifier}" autocomplete="off"/>' +
                                        '<fmt:message key="label.confirmPassword"/>' +
                                        '<input type="password" id="passwordconfirm${currentNode.identifier}" name="passwordconfirm${currentNode.identifier}" autocomplete="off"/>' +
                                        '<button class="btn btn-primary margin-right-10" type="button" onclick="checkAndSubmitPassword()">' +
                                        '<fmt:message key="label.ok"/>' +
                                        '</button>' +
                                        '<button class="btn btn-danger" type="button" onclick="closePopover(\'popoverPassword${currentNode.identifier}\')">' +
                                        wsfi18n['wsf.label.cancel'] +
                                        '</button>' +
                                        '<div id="passwordMessage${currentNode.identifier}" class="text-error hide"></div>' +
                                    '</form>';
                        }
                    });
                });

                function checkAndSubmitPassword() {
                    if ($("#oldpassword${currentNode.identifier}").val() == "") {
                        $('#passwordMessage${currentNode.identifier}').html('<fmt:message key="mySettings.errors.oldPassword.mandatory"/>');
                        $('#passwordMessage${currentNode.identifier}').show();
                        return false;
                    }

                    if ($("#password${currentNode.identifier}").val() == "") {
                        $('#passwordMessage${currentNode.identifier}').html('<fmt:message key="mySettings.errors.password.mandatory"/>');
                        $('#passwordMessage${currentNode.identifier}').show();
                        return false;
                    }

                    if ($("#password${currentNode.identifier}").val() != $("#passwordconfirm${currentNode.identifier}").val()) {
                        $('#passwordMessage${currentNode.identifier}').html('<fmt:message key='mySettings.errors.password.not.matching'/>');
                        $('#passwordMessage${currentNode.identifier}').show();
                        return false;
                    }

                    $.post('<c:url value="${url.basePreview}${functions:escapePath(user.path)}.changePassword.do"/>',
                        {oldpassword: $("#oldpassword${currentNode.identifier}").val(), password: $("#password${currentNode.identifier}").val(), passwordconfirm: $("#passwordconfirm${currentNode.identifier}").val()}, function (data) {
                        if (data['result'] == 'success') {
                            $('#passwordMessage${currentNode.identifier}').html(data['errorMessage']);
                            $('#passwordMessage${currentNode.identifier}').removeClass('text-error');
                            $('#passwordMessage${currentNode.identifier}').addClass('text-success');
                            $('#passwordMessage${currentNode.identifier}').show();
                            setTimeout(function(){
                                closePopover('popoverPassword${currentNode.identifier}');
                            }, 2000);
                        } else {
                            $('#' + data['focusField'] + '${currentNode.identifier}').focus();
                            $('#passwordMessage${currentNode.identifier}').html(data['errorMessage']);
                            $('#passwordMessage${currentNode.identifier}').show();
                        }
                    }, 'json');
                }
            </script>
        </c:if>
    </div>
</div>