<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="doc" uri="http://www.jahia.org/tags/docspace" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="files.css"/>
<template:addResources type="css" resources="vendor/datatables/dataTables.responsive.css"/>
<template:addResources type="css" resources="vendor/datatables/dataTables.bootstrap.css"/>
<%--<template:addResources type="css" resources="vendor/datatables/dataTables-themescroller.css"/>--%>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.responsive.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.scroller.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.bootstrap.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:include view="hidden.header"/>
<template:addResources type="inlinejavascript">
    <script type="text/javascript">
        $(document).ready(function() {
            $(".checkAll").click(function () {
                $(".fileCheckbox").each(function (index) {
                    if ($(".checkAll").attr("checked") == "checked") {
                        $(this).attr("checked", "checked");
                    } else {
                        $(this).removeAttr("checked");
                    }
                });
                fileCheckBoxChecked();
            });

            libraryViewDatatable = $('#fileListTable').DataTable({
                serverSide:false,
                deferRender:true,
                processing:false,
                responsive:{details:false},
                dom: "frtiS",
                order:[[2,'asc']],

                "scrollY": "400px",
                "scrollCollapse": true,
                "paging": true,
                "language": {
                    "emptyTable": wsfi18n['jnt_folder.docspace.noDocumentsAvailable']
                },
                columnDefs:[
                    {
                        targets:0,
                        searchable: false,
                        orderable: false,
                        render: function ( data, type, full, meta ) {
                            return '<input class="'+data.css+'" type="checkbox" name="'+data.identifier+'" path="'+data.path+'" alt="'+data.fullName+'"/>';
                        }
                    },
                    {
                        targets:1,
                        searchable: true,
                        orderable: true,
                        render: function (data, type, full, meta) {
                            if(type != "display") return data;
                            else {
                                if (data === 'file') {
                                    var filePath = full[0].path;
                                    if (filePath.match('.gdoc$')) {
                                        data = 'gdoc';
                                    } else if (filePath.match('.gsheet$')) {
                                        data = 'gsheet';
                                    } else if (filePath.match('.gslides$')) {
                                        data = 'gslides';
                                    }
                                }
                                switch (data) {
                                    case "img": return '<span class="fa fa-file-image-o"></span>';
                                    case "video": return '<span class="fa fa-file-video-o"></span>';
                                    case "sound": return '<span class="fa fa-file-audio-o"></span>';
                                    case "pdf": return '<span class="fa fa-file-pdf-o" style="color: red;"></span>';
                                    case "rar":
                                    case "zip": return '<span class="fa fa-file-zip-o" style="color: darkgoldenrod;"></span>';
                                    case "doc": return '<span class="fa fa-file-word-o" style="color: mediumblue;"></span>';
                                    case "gdoc": return '<span class="fa fa-file-text-o" style="color: mediumblue;"></span>';
                                    case "xls": return '<span class="fa fa-file-excel-o" style="color: green;"></span>';
                                    case "gsheet": return '<span class="fa fa-file-text-o" style="color: green;"></span>';
                                    case "ppt": return '<span class="fa fa-file-powerpoint-o" style="color: orangered;"></span>';
                                    case "gslides": return '<span class="fa fa-file-text-o" style="color: orangered;"></span>';
                                    case "java":
                                    case "html": return '<span class="fa fa-file-code-o" style="color: mediumpurple"></span>';
                                    case "text": return '<span class="fa fa-file-text-o"></span>';
                                    case "txt": return '<span class="fa fa-file-text-o"></span>';
                                    case "folder": return '<span class="fa fa-folder"></span>';
                                    default: return '<span class="fa fa-file-o"></span>';
                                }
                            }
                        }
                    },
                    {
                        targets:2,
                        searchable: true,
                        orderable: true,
                        className: "span4",
                        render: function ( data, type, full, meta ) {
                            var urlBase="<c:url value='${url.base}'/>";
                            if(type != "display") return data.fullName;
                            var rendering = "";
                            if(data.locked){
                                rendering = '<span class="icon-lock'+(data.archived?"-archive":"")+'"></span>&nbsp;'
                            }
                            if (data.folder) {
                                return rendering+'<a href="'+urlBase+data.path+'.workspace-library.html" title="'+data.displayName+'">'+data.fullName+'</a>';
                            } else {
                                return rendering+'<a href="'+urlBase+data.path+'.workspace-document-details.html" title="'+data.displayName+'">'+data.fullName+'</a>';
                            }
                        }
                    },
                    {
                        targets:3,
                        searchable: false,
                        orderable: false,
                        className: "span2",
                        render: function ( data, type, full, meta ) {
                            if(data.officeURL != ''){
                                return '<a title="' + wsfi18n['wsf.label.download'] + '" href="'+data.download+'"><span class="fa fa-download"></span></a>&nbsp;<a title="' + wsfi18n['wsf.label.openInOffice'] + '" href="' + data.officeURL + '"><span class="fa fa-windows"></span></a>'
                            }
                            else if (data.download != '') {
                                return '<a title="' + wsfi18n['wsf.label.download'] + '" href="'+data.download+'"><span class="fa fa-download"></span></a>'
                            }
                            return "<span></span>"
                        }
                    },
                    {
                        targets:4,
                        searchable: true,
                        orderable: true,
                        type:"date",
                        className: "span2",
                        render: function ( data, type, full, meta ) {
                            if (type == "display") {
                                return '<span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL" data-moment-locale="${renderContext.mainResourceLocale}" data-moment="'+data+'">'+moment(data).fromNow()+'</span>'
                            }
                            return data;
                        }
                    },
                    {
                        targets:5,
                        searchable: true,
                        orderable: true,
                        type:"date",
                        className: "span3",
                        render: function ( data, type, full, meta ) {
                            if (type == "display") {
                                return '<span class="momentToFormat" data-moment-display-type="fromNow" data-moment-locale="${renderContext.mainResourceLocale}" data-moment="'+data+'">'+moment(data).fromNow()+'</span>'
                            }
                            return data;
                        }
                    }
                ],
                drawCallback : function() {
                    parseFileCheckboxes();
                    if (this[0].rows.length > 100) {
                        $(".checkAll").prop("checked", false);
                        $(".fileCheckbox").prop("checked", false);
                        $(".checkAll").hide();
                    }
                    else {
                        $(".checkAll").prop("checked", false);
                        $(".fileCheckbox").prop("checked", false);
                        $(".checkAll").show();
                    }
                    fileCheckBoxChecked();
                },
                initComplete: function(settings, json){
                    refreshMoment();
                },
                <c:choose>
                    <c:when test="${functions:length(moduleMap.currentList) gt 500}">
                        ajax: '<c:url value="/cms/wsfactory/default/${renderContext.mainResourceLocale}${functions:escapePath(renderContext.mainResource.node.path)}.datatable.json"/>'
                    </c:when>
                    <c:otherwise>
                        data: <template:include templateType="json" view="datatable"/>.data
                    </c:otherwise>
                </c:choose>
            });
            refreshMomentEvery(60000);
        });
    </script>
</template:addResources>
<div class="row-fluid">
    <%@include file="switchView.jspf" %>

        <table class="table table-hover table-condensed" summary="file List Table"
               id="fileListTable">
            <thead>
            <tr>
                <th class=" min-tablet-l"><input type="checkbox" class="allFileCheckbox checkAll"/></th>
                <th class=" all"><fmt:message key="wsf.label.type"/></th>
                <th class=" all"><fmt:message key="jnt_folder.docspace.fileName"/></th>
                <th class=" min-phone-l"><fmt:message key="wsf.label.download"/></th>
                <th class=" min-tablet-l"><fmt:message key="wsf.label.created"/></th>
                <th class=" min-tablet-l"><fmt:message key="wsf.label.lastModification"/></th>
                <th class="min-tablet-l"><fmt:message key="wsf.label.author"/></th>
                <th class="min-tablet-l"><fmt:message key="docmix_docspaceDocument.documentStatus"/></th>
            </tr>
            </thead>
            <tbody></tbody>
        </table>

        <template:include view="hidden.footer">
            <template:param name="searchUrl" value="${url.current}"/>
        </template:include>
</div>