<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>

<jcr:nodeProperty node="${currentNode}" name="maxPolls" var="maxPolls"/>
<jcr:nodeProperty node="${currentNode}" name="filter" var="filter"/>
<c:set var="lastPollsStatement" value="select * from [jnt:poll] as poll where ISDESCENDANTNODE(poll,'${functions:sqlencode(renderContext.mainResource.node.path)}') order by poll.['jcr:created'] desc"/>

<div class="accordion" id="pollAccordion_${currentNode.identifier}">
    <jcr:sql var="lastPolls" sql="${lastPollsStatement}"/>
    <c:forEach items="${lastPolls.nodes}" var="poll" varStatus="status">
        <c:if test="${status.index < maxPolls.string}">
            <div class="accordion-group">
                <div class="accordion-heading">
                    <a class="accordion-toggle" data-toggle="collapse" data-parent="#pollAccordion_${currentNode.identifier}" href="#collapse${status.index}">
                        <span class="badge margin-right-10">${status.index + 1}</span><strong>${poll.properties["question"].string}</strong>
                    </a>
                </div>
                <div id="collapse${status.index}" class="accordion-body collapse <c:if test="${status.first}">in</c:if>">
                    <div class="accordion-inner">
                        <template:module path="${poll.path}" view="docspace"/>
                    </div>
                </div>
            </div>
        </c:if>
    </c:forEach>
</div>
<c:if test="${not fn:endsWith(renderContext.mainResource.node.path,'polls')}">
<a class="pull-right" href="<c:url value="${url.base}${functions:escapePath(renderContext.mainResource.node.path)}/polls.workspace-polls.html"/>"><fmt:message key="jnt_lastPolls.docspace.viewAllPolls"/></a>
</c:if>
