<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="currentAliasUser" type="org.jahia.services.usermanager.JahiaUser"--%>

<c:if test="${not renderContext.loggedIn || currentAliasUser.username eq 'guest'}">
    <ui:loginArea class="loginForm" onsubmit="loginButton.disabled = true; return true;">
        <h3><i class="fa fa-lock"></i>&nbsp;${fn:escapeXml(currentNode.displayableName)}</h3>

            <label for="username"><fmt:message key="wsf.label.username"/></label>
            <input class="input-block-level" type="text" value="" maxlength="250" name="username" id="username"/>

            <label for="password"><fmt:message key="wsf.label.password"/></label>
            <input class="input-block-level" type="password" maxlength="250" name="password" id="password" autocomplete="off"/>

            <label for="rememberme" class="checkbox">
                <input type="checkbox" id="rememberme" name="useCookie"/>
                <fmt:message key="jnt_loginForm.docspace.rememberMe"/>
            </label>

            <button type="submit" name="loginButton" class="btn btn-primary">
                <fmt:message key="jnt_loginForm.docspace.login"/>
            </button>
            <ui:isLoginError var="loginResult">
                <span class="text-error"><fmt:message key="${loginResult == 'account_locked' ? 'message.accountLocked' : 'message.invalidUsernamePassword'}"/></span>
            </ui:isLoginError>
            <c:if test="${not empty param['loginError']}">
                <span class="text-error"><fmt:message key="${param['loginError'] == 'account_locked' ? 'message.accountLocked' : 'message.invalidUsernamePassword'}"/></span>
            </c:if>
    </ui:loginArea>
</c:if>
<c:if test="${renderContext.loggedIn &&  currentAliasUser.username ne 'guest'}">
    <jcr:node var="user" path="${renderContext.user.localPath}"/>
    <jcr:nodeProperty node="${user}" name="j:publicProperties" var="publicProperties" />
    <c:set var="publicPropertiesAsString" value=""/>

    <c:forEach items="${publicProperties}" var="value">
        <c:set var="publicPropertiesAsString" value="${value.string} ${publicPropertiesAsString}"/>
    </c:forEach>

    <div class="loginForm">
        <div class="pull-right">
            <c:choose>
                <c:when test="${fn:contains(publicPropertiesAsString, 'j:picture')}">
                    <jcr:nodeProperty var="picture" node="${user}" name="j:picture"/>
                    <c:if test="${not empty picture}">
                        <img class="img-polaroid img-circle" src="${picture.node.thumbnailUrls['avatar_120']}" alt="${fn:escapeXml(person)}"/>
                    </c:if>
                    <c:if test="${empty picture}">
                        <img class="img-polaroid img-circle" src="<c:url value='/modules/social/images/userBig.png'/>" alt="" border="0"/>
                    </c:if>
                </c:when>
                <c:otherwise>
                    <img class="img-polaroid img-circle" src="<c:url value='/modules/social/images/userBig.png'/>" alt="" border="0"/>
                </c:otherwise>
            </c:choose>
        </div>
        <h3><i class="fa fa-unlock"></i>&nbsp;<fmt:message key="wsf.label.logout"/></h3>
        <p>
            <fmt:message key="jnt_loginForm.docspace.loggedAs"/>&nbsp;${renderContext.user.username}<c:if test="${!empty currentAliasUser}"> (as ${currentAliasUser.username})</c:if>
        </p>
        <a class="btn btn-primary" href='<c:url value="${url.logout}"/>'>
            <fmt:message key="wsf.label.logout"/>
        </a>
    </div>
</c:if>
