<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.min.js"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}.setDocspacePermissions.do"/>
<c:url var="postUrl" value="${functions:escapeJavaScript(postUrl)}"/>
<c:set var="aclInheritanceBreak" value="${boundComponent.aclInheritanceBreak}"/>
<c:set var="parentWithAclBreak" value="${functions:getParentWithAclInheritanceBroken(boundComponent)}"/>

<c:if test="${not param.hideForm}">
<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {

            <c:if test="${!aclInheritanceBreak}">
            $('#document-permissions-members').hide();
            </c:if>
            $("input[name='document-permissions-inherited']").click(function () {
                var breakinheritance = $(this).val() == 'false';
                $.post("${postUrl}", {'inherited':!breakinheritance}, function (result) {
                    if (breakinheritance) {
                        $('#document-permissions-members').show('fast');
                    } else {
                        $('#document-permissions-members').hide('fast');
                    }
                }, "json");
            });
        });
    </script>
</template:addResources>
<c:if test="${param.display_title eq 'true'}">
    <c:if test="${!renderContext.ajaxRequest}" >
        <h3><fmt:message key="wsf.label.permissions"/></h3>
    </c:if>
</c:if>
<dl class="dl-horizontal">
<dt><label for="document-permissions-inherited" class="normal-font">
    <c:if test="${not empty parentWithAclBreak}">
        <fmt:message key="wsf.label.home" var="i18nHome"/>
        <fmt:message key="wsf.label.inheritedFrom"/>&nbsp;<a href="<c:url
            value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(parentWithAclBreak.path)}.html'/>">
        ${fn:escapeXml(jcr:isNodeType(parentWithAclBreak, "docmix:docspace") ?
    i18nHome : functions:abbreviate(parentWithAclBreak.displayableName, 20, 25, '...'))}</a>
    </c:if>
    <c:if test="${empty parentWithAclBreak}">
        <fmt:message key="wsf.label.inherited"/>
    </c:if>
</label></dt>
<dd><input id="document-permissions-inherited" name="document-permissions-inherited" type="radio"
       value="true"${!aclInheritanceBreak ? ' checked="checked"' : ''}/></dd>
<br/>
<dt><label for="document-permissions-customized" class="normal-font"><fmt:message
        key="jnt_membersManagement.docspace.customized"/></label></dt>
<dd><input id="document-permissions-customized" name="document-permissions-inherited" type="radio"
       value="false"${aclInheritanceBreak ? ' checked="checked"' : ''}/></dd>
<br/>

<div class="clearfix"></div>

<div id="document-permissions-members">
</c:if>
    <template:include view="default">
        <template:param name="membersManagementSourceNode"
                        value="${not empty parentWithAclBreak ? parentWithAclBreak.path : jcr:getParentOfType(boundComponent, 'docmix:docspace').path}"/>
    </template:include>
<c:if test="${not param.hideForm}">
</div>
</dl>
</c:if>