<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>

<c:if test="${not renderContext.editMode}">
    <script type="text/javascript">
        $(document).ready(function() {
            $('#modal-${currentNode.identifier}').appendTo(document.body);
        });
    </script>
</c:if>

<div id="modal-${currentNode.identifier}" class="${currentNode.properties['popupClass'].string} hide"
     tabindex="-1" role="dialog">
    <c:forEach items="${jcr:getChildrenOfType(currentNode,'jmix:droppableContent')}" var="child">
        <template:module path="${child.path}"/>
    </c:forEach>
</div>

<c:if test="${renderContext.editMode}">
    <div>
        <c:forEach items="${jcr:getChildrenOfType(currentNode,'jmix:droppableContent')}" var="child">
            <template:module path="${child.path}"/>
        </c:forEach>
        <template:module path="*"/>
    </div>
</c:if>

<a href="#" class="${currentNode.properties['buttonClass'].string}" data-toggle="modal"
   data-target="#modal-${currentNode.identifier}">
   ${currentNode.properties['buttonLabel'].string}
</a>
