<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.min.js,poll.js,pollResults.js"/>
<template:addResources type="javascript" resources="bootstrap-tooltip.js"/>
<template:addResources type="javascript" resources="bootstrap-popover.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>

<template:addResources type="css" resources="poll.css"/>

<jsp:useBean id="now" class="java.util.Date"/>
<jcr:node path="${renderContext.user.localPath}" var="user"/>
<template:addResources>

    <script type="text/javascript">
        jQuery.ajaxSettings.traditional = true;
        $.ajaxSetup({
            accepts: {
                script: "application/json"
            },
            cache:false
        });


        if (getCookie('poll${user.identifier}${currentNode.identifier}') == 'true') {
            showResults("<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>", '${currentNode.identifier}');
        }

        <c:if test="${not renderContext.editMode}">
            <c:if test="${currentNode.properties.status.string eq 'closed'}">
                showResults("<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>", '${currentNode.identifier}');
            </c:if>
        </c:if>

        function validateVote(a, b, c, d, e, t) {
            var answerUUID = null;
            $("#form_"+c+" input:checked[name='voteAnswer']").each(function() {
                answerUUID = $(this).val();
            });

            if (answerUUID == null) {
                $("#"+t.id).popover({
                    placement: 'right',
                    html: true,
                    content: "You must select an answer!"
                });
                $("#"+t.id).popover("show");
                setTimeout(function() {
                    $("#"+t.id).popover("hide");
                    $("#"+t.id).popover("destroy");
                }, 1500);
                return false;
            }
            doVote(a, b, c, d, e);
        }

    </script>
</template:addResources>

<div class="well">
    <h3>
        ${fn:escapeXml(currentNode.propertiesAsString['question'])}
    </h3>
    <c:if test="${currentNode.properties.status.string ne 'closed' && renderContext.ajaxRequest}">
        <div class="row-fluid">
            <a href="${url.context}${url.base}${renderContext.ajaxResource.node.resolveSite.path}/files/workspaces/${renderContext.ajaxResource.node.name}/polls.workspace-polls.html">
                Vote here
            </a>

        </div>
    </c:if>
    <c:if test="${currentNode.properties.status.string ne 'closed' && !renderContext.ajaxRequest}">
        <div class="pollForm${currentNode.identifier}">
            <c:choose>
                <c:when test="${renderContext.editMode}">
                    <div>
                        <span><fmt:message key="jnt_poll.docspace.addAnswers"/></span>
                        <template:list path="answers" listType="jnt:answersList" editable="true"/>
                    </div>
                </c:when>
                <c:otherwise>
                    <div id="formContainer_${currentNode.identifier}">
                        <template:tokenizedForm>
                            <form id="tokenform_${currentNode.identifier}" name="tokenform_${currentNode.identifier}"
                                  method="post" action="<c:url value="${url.base}${functions:escapePath(currentNode.path)}"/>.pollVote.do">
                            </form>
                        </template:tokenizedForm>
                        <form id="form_${currentNode.identifier}"
                              name="form_${currentNode.identifier}" method="post">

                            <c:forEach items="${currentResource.node.nodes}" var="child">
                                <c:if test="${child.properties['jcr:primaryType'].string eq 'jnt:answersList'}">
                                    <c:forEach items="${child.nodes}" var="answer">
                                        <div>
                                        <label class="radio">
                                            <input id="${currentResource.node.properties['j:nodename'].string}_voteAnswer_${answer.identifier}"
                                                   type="radio" value="${answer.identifier}" name="voteAnswer"/>
                                                ${answer.properties["label"].string}
                                        </label>
                                        </div>
                                    </c:forEach>
                                </c:if>
                            </c:forEach>

                            <input type="hidden" name="jcrReturnContentType" value="json"/>

                            <div class="validation"></div>
                            <c:set var="ajax" value="" />
                            <c:set var="sitePath" value="${url.base}${functions:escapePath(renderContext.site.path)}" />
                            <c:if test="${renderContext.ajaxRequest}">
                                <c:set var="sitePath" value="${url.base}${renderContext.ajaxResource.node.resolveSite.path}" />
                                <c:set var="ajax" value="_ajax" />
                            </c:if>
                            <button class="btn btn-primary" type="button" selenid="voteButton_${fn:replace(currentNode.propertiesAsString['question'], " ", "-")}" id="voteButton_${currentNode.identifier}"
                                    onclick="validateVote($('${currentNode.identifier}_voteAnswer').value, '<c:url value="${url.base}${functions:escapePath(currentNode.path)}"/>','${currentNode.identifier}', '<c:url value="${sitePath}"/>','${user.identifier}', this);">
                                <fmt:message key="jnt_poll.docspace.vote"/>
                            </button>
                        </form>
                    </div>
                </c:otherwise>
            </c:choose>
        </div>
    </c:if>
    <c:if test="${!renderContext.ajaxRequest || currentNode.properties.status.string eq 'closed'}">
        <div class="stats_${currentNode.identifier}"></div>
    </c:if>
</div>