<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="forum.css"/>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery.validate.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<uiComponents:ckeditor selector="jahia-forum-thread-${currentNode.identifier}"/>

<c:choose>
    <c:when test="${fn:endsWith(renderContext.mainResource.path, 'forum.forum-newTopic.html')}">
        <c:url var="redirectTo" value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace').path)}/forum.html"/>
    </c:when>
    <c:otherwise>
        <c:url var="redirectTo" value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(fn:substringBefore(renderContext.mainResource.path, 'forum-topic-newPost.html'))}html"/>
    </c:otherwise>
</c:choose>

<template:addResources type="inlinejavascript">
    <script type="text/javascript">
        var initTitle;
        $(document).ready(function () {
            $("#newTopicForm").validate({
                rules: {
                    'jcr:title': "required",
                    <c:if test="${not renderContext.loggedIn}">
                        pseudo: "required",
                        captcha: "required"
                    </c:if>
                },
                errorClass: "text-error"
            });
            initTitle = $('#newTopic_title').val();
        });

        function confirmResetPost() {
            if (CKEDITOR.instances['jahia-forum-thread-${currentNode.identifier}'].getData() !== '' || $('#newTopic_title').val() !== initTitle) {
                bootbox.confirm(wsfi18n['jnt_postForm.resetPostConfirm'], function(result) {
                    if (result) {
                        CKEDITOR.instances['jahia-forum-thread-${currentNode.identifier}'].setData(initPostValue);
                        $('#newTopic_title').val(initTitle);
                    }
                });
            }
        }

        function confirmCancelPost() {
            if (CKEDITOR.instances['jahia-forum-thread-${currentNode.identifier}'].getData() !== '' || $('#newTopic_title').val() !== initTitle) {
                bootbox.confirm(wsfi18n['jnt_postForm.cancelPostConfirm'], function(result) {
                    if (result) {
                        window.location = '${redirectTo}';
                    }
                });
            } else {
                window.location = '${redirectTo}';
            }
        }
    </script>
</template:addResources>

<c:set var="linkedNode" value="${uiComponents:getBoundComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<a name="threadPost"></a>
<c:if test="${!empty param.reply}">
    <jcr:node uuid="${param.reply}" var="reply"/>
    <template:addCacheDependency node="${reply}"/>
</c:if>
<c:if test="${not empty linkedNode}">
    <c:choose>
        <c:when test="${jcr:isNodeType(linkedNode,'jnt:topic')}">
            <c:set value="${jcr:getParentOfType(linkedNode.parent, 'jmix:moderated')}" var="moderated"/>
        </c:when>
        <c:otherwise>
            <c:set value="${jcr:getParentOfType(linkedNode, 'jmix:moderated')}" var="moderated"/>
        </c:otherwise>
    </c:choose>
</c:if>
<template:tokenizedForm>
    <div class="hero-unit">
    <h2>${fn:escapeXml(currentNode.displayableName)}</h2>
    <div class="row-fluid">
    <div class="span10">
    <form action="<c:url value='${url.base}${functions:escapePath(linkedNode.path)}.addTopic.do'/>" method="post" name="newTopicForm"
          id="newTopicForm"
          class="form-horizontal">
        <input type="hidden" name="jcrNodeType" value="jnt:post"/>
        <input type="hidden" name="jcrRedirectTo"
               value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.${renderContext.mainResource.template}'/>"/>
        <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
        <input type="hidden" name="jcrResourceID" value="${currentNode.identifier}"/>
        <input type="hidden" name="jcr:mixinTypes" value="jmix:rating"/>
        <c:if test="${not empty moderated}">
            <input type="hidden" name="jcr:mixinTypes" value="jmix:moderated"/>
        </c:if>
        <c:if test="${not empty moderated}">
            <p>
                <span><fmt:message key="jnt_post.forum.moderatedPost"/></span>
            </p>
        </c:if>
        <c:if test="${not renderContext.loggedIn}">
            <div class="control-group">

                <label for="newTopic_pseudo" class="control-label"><fmt:message key="wsf.label.pseudo"/></label>

                <div class="controls">
                    <c:if test="${not empty sessionScope.formDatas['pseudo']}">
                        <input value="${sessionScope.formDatas['pseudo'][0]}"
                               type="text" size="35" name="pseudo" id="newTopic_pseudo"/>
                    </c:if>
                    <c:if test="${empty sessionScope.formDatas['pseudo']}">
                        <input value="" type="text" size="35" name="pseudo" id="newTopic_pseudo"/>
                    </c:if>

                </div>
            </div>
        </c:if>
        <div class="control-group">
            <fmt:message key="jnt_post.forum.replyPrefix" var="replyPrefix"/>
            <c:set var="replyPrefix" value="${replyPrefix} "/>
            <c:set var="replyTitle" value="${reply.properties['jcr:title'].string}"/>
            <label for="newTopic_title" class="control-label">
                <fmt:message key="wsf.label.title"/>
            </label>

            <div class="controls">
                <c:choose>
                    <c:when test="${not empty sessionScope.formDatas['jcr:title']}">
                        <input value="${sessionScope.formDatas['jcr:title'][0]}"
                               type="text" size="35" id="newTopic_title" name="jcr:title"/>
                    </c:when>
                    <c:otherwise>
                        <input value="${not empty replyTitle ? replyPrefix : ''}${not empty replyTitle ? fn:escapeXml(replyTitle) : ''}"
                               type="text" size="35" id="newTopic_title" name="jcr:title"/>
                    </c:otherwise>
                </c:choose>
            </div>
        </div>

        <div class="control-group">
            <label for="jahia-forum-thread-${currentNode.identifier}" class="control-label">
                <fmt:message key="wsf.label.description"/>
            </label>

            <div class="controls">
                        <textarea rows="7" cols="35" id="jahia-forum-thread-${currentNode.identifier}" name="content"
                                  class="jahia-ckeditor">
                            <c:if test="${not empty sessionScope.formDatas['content']}">
                                ${fn:escapeXml(sessionScope.formDatas['content'][0])}
                            </c:if>
                            <c:if test="${(not empty reply.properties['content'].string) && (not empty param.quote)}">
                                <blockquote><c:out value="${reply.properties['content'].string}"/></blockquote>
                                <br/>

                                <p>
                                </p>
                            </c:if></textarea>
            </div>
        </div>
        <script>
            initPostValue = $('#jahia-forum-thread-${currentNode.identifier}').val();
        </script>
        <c:if test="${not renderContext.loggedIn}">
            <div class="control-group">
                <label for="newTopic_captcha" class="control-label">Captcha</label><br/> <template:captcha/>
                <div class="controls">
                    <c:if test="${not empty sessionScope.formError}">
                        <label class="error">${sessionScope.formError}</label>
                    </c:if>
                    <input type="text" id="newTopic_captcha" name="jcrCaptcha"/>
                </div>
            </div>
        </c:if>
        <div class="control-group">
            <div class="controls">
                <button type="button" class="btn" onclick="confirmCancelPost()">
                    <i class="fa fa-times fa-fw"></i>
                    <fmt:message key='wsf.label.cancel'/>
                </button>
                <button type="button" class="btn btn-danger" onclick="confirmResetPost()">
                    <i class="fa fa-trash-o fa-fw"></i>
                    <fmt:message key='wsf.label.reset'/>
                </button>
                <button type="submit" class="btn btn-primary">
                    <i class="fa fa-check fa-fw"></i>
                    <fmt:message key='wsf.label.submit'/>
                </button>
            </div>
        </div>
        <!--stop post-reply-->
    </form>
</template:tokenizedForm>
</div>
</div>
</div>