<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="forum.css"/>
<template:addResources type="javascript" resources="jquery.min.js,jquery.cuteTime.js,jquery.jeditable.mini.js"/>
<template:addResources type="javascript" resources="ckeditor.js,adapters/jquery.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.ckeditor.js"/>

<template:include view="hidden.header"/>

<script>
    $(document).ready(function () {

        $(".editablePost").editable(function (value, settings) {
            var data = {'jcrMethodToCall': 'put'};
            var submitId = $(this).attr('jcr:id');
            data[submitId] = value;
            $.post($(this).attr('jcr:url'), data, null, "json");
            return (value);
        }, {
            type: 'ckeditor',
            ckeditorType: 'Mini',
            onblur: 'ignore',
            submit: '<button type="submit"><span class="icon-contribute icon-accept"></span>' + wsfi18n['wsf.label.ok'] + '</button>',
            cancel: '<button type="submit"><span class="icon-contribute icon-cancel"></span>' + wsfi18n['wsf.label.cancel'] + '</button>',
            tooltip: wsfi18n['wsf.label.edit'],
            event: "dblclick"
        });
    });
</script>
<div class="well" id="forum-body">
    <c:forEach items="${moduleMap.currentList}" var="subchild" varStatus="status" begin="${moduleMap.begin}"
               end="${moduleMap.end}">
        <template:addCacheDependency node="${subchild}"/>
        <div class="row-fluid" id="${currentNode.UUID}">
            <c:if test="${jcr:isNodeType(subchild, 'jnt:post')}">
                <c:if test="${status.first}">
                    <c:set value="${jcr:getParentOfType(subchild, 'jmix:moderated')}" var="moderated"/>
                </c:if>
                <c:choose>
                    <c:when test="${not empty moderated}">
                        <c:choose>
                            <c:when test="${jcr:isNodeType(subchild, 'jmix:moderated')}">
                                <c:if test="${jcr:hasPermission(subchild, 'moderatePost') or subchild.properties.moderated.boolean}">
                                        <template:module node="${subchild}" view="${moduleMap.subNodesView}">
                                            <template:param name="postIsFirst" value="${status.first}"/>
                                        </template:module>
                                </c:if>
                            </c:when>
                            <c:otherwise>
                                    <template:module node="${subchild}" view="${moduleMap.subNodesView}">
                                        <template:param name="postIsFirst" value="${status.first}"/>
                                    </template:module>
                            </c:otherwise>
                        </c:choose>
                    </c:when>
                    <c:otherwise>
                            <template:module node="${subchild}" view="${moduleMap.subNodesView}">
                                <template:param name="postIsFirst" value="${status.first}"/>
                            </template:module>
                    </c:otherwise>
                </c:choose>
            </c:if>
        </div>
    </c:forEach>
</div>