<%@ page import="org.jahia.services.content.JCRNodeWrapper" %>
<%@ page import="org.joda.time.DateTime" %>
<%@ page import="org.joda.time.Days" %>
<%@ page import="java.text.SimpleDateFormat" %>
<%@ page import="java.util.*" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources condition="if lt IE 9" type="javascript" resources="excanvas.min.js"/>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="underscore.min.js"/>
<template:addResources type="javascript" resources="chart.js"/>

<%--Chartjs integration--%>
<div id="chartDiv">
    <fmt:message key="jnt_socialActivitiesDisplay.charts.historyOfActivities" var="i18nHistory"/>
    <div id="chartTitle" class="span12 text-center"><strong>${i18nHistory}</strong></div>
    <canvas id="chartCanvas" width="" height="400"></canvas>
</div>
<template:addResources>
    <template:include view="dataBuilder.hidden">
        <template:param name="previousMonths" value="12"/>
    </template:include>
    <jcr:propertyInitializers var="activityTypes" nodeType="jnt:socialActivitiesDisplay" name="j:activityTypes"/>
    <script type="text/javascript">
        var ctx = $("#chartCanvas").get(0).getContext("2d");
        var barChart = "";
        var options = {
            //Boolean - Whether the scale should start at zero, or an order of magnitude down from the lowest value
            scaleBeginAtZero : true,

             //Boolean - Whether grid lines are shown across the chart
            scaleShowGridLines : true,

            //String - Colour of the grid lines
            scaleGridLineColor : "rgba(0,0,0,.05)",

            //Number - Width of the grid lines
            scaleGridLineWidth : 1,

            //Boolean - Whether to show horizontal lines (except X axis)
            scaleShowHorizontalLines: true,

            //Boolean - Whether to show vertical lines (except Y axis)
            scaleShowVerticalLines: true,

            //Boolean - If there is a stroke on each bar
            barShowStroke : true,

            //Number - Pixel width of the bar stroke
            barStrokeWidth : 2,

            //Number - Spacing between each of the X value sets
            barValueSpacing : 5,

            //Number - Spacing between data sets within X values
            barDatasetSpacing : 1,

            //Set this property to false, 'twoDays', 'week', 'month', 'year' to determine the number of x-axis markers
            labelFilter: 'twoDays',

            tooltipFontSize: 12,

            tooltipFillColor: "rgba(216,238,206,1)"
        };

        function drawChart() {
            //Get activities
            <c:forEach items="${socactData}" var="activityMap" varStatus="idx">
            var activities${idx.count} = [
                <c:forEach items="${activityMap.value}" var="activity" varStatus="status">
                <c:if test="${!status.first}">,
                </c:if>
                ['${activity.key}', ${activity.value}]
                </c:forEach>
            ];
            <c:set var="nbActivities" value="${idx.count}"/>
            </c:forEach>
            var acts = [<c:forEach var="i" begin="1" end="${nbActivities}" varStatus="stat">
                            <c:if test="${not stat.first}">,</c:if> activities${i}
                        </c:forEach>];
            var dates = [];
            var data = [];
            for (var i = 0; i < acts[0].length; i++) {
                dates.push(acts[0][i][0]);
                data.push(acts[0][i][1])
            }

            var data = {
                labels: dates,
                datasets: [
                    {
                        label: "Data set",
                        fillColor: "rgba(72, 179, 216,0.5)",
                        strokeColor: "rgba(72, 179, 216,0.5)",
                        highlightFill: "rgba(37,99,171,0.75)",
                        highlightStroke: "rgba(37,99,171,0.75)",
                        data: data
                    }
                ]
            };
            barChart = new Chart(ctx).Bar(data, options);
        }//drawChart

        function setChartSize() {
            var canvas = document.getElementById("chartCanvas");
            var width = document.getElementById("chartDiv").offsetWidth;
            canvas.style.width = (width - (width / 100)) + "px";
            canvas.style.height = "300px";
        }

        $(document).ready(function() {
            setChartSize();
            drawChart();
        });
        $(window).resize(function() {
            barChart.destroy();
            setChartSize();
            drawChart();
        });
    </script>
</template:addResources>