<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<script type="text/javascript">
    $(document).ready(function() {
        refreshMoment();
        refreshMomentEvery(60000);
    });
</script>

<template:include view="hidden.header"/>
<table class="table table-striped">
    <tbody>
    <c:forEach items="${moduleMap.currentList}" var="activity" begin="${moduleMap.begin}" end="${moduleMap.end}">
        <c:set var="activityType" value="${activity.properties['j:activityType'].string}"/>
        <tr>
            <td>
                <c:choose>
                    <c:when test="${activityType eq 'text'}">
                        <template:module path="${activity.path}" view="docspace"/>
                    </c:when>
                    <c:otherwise>
                        <template:module path="${activity.path}"/>
                    </c:otherwise>
                </c:choose>
            </td>
        </tr>
    </c:forEach>
    </tbody>
</table>
<template:include view="hidden.footer"/>