<%@ page import="javax.servlet.jsp.jstl.fmt.LocalizationContext" %>
<%@ page import="org.jahia.services.render.Resource" %>
<%@ page import="org.jahia.utils.i18n.JahiaResourceBundle" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
            refreshMomentEvery(60000);
        });
    </script>
</template:addResources>

<jcr:node var="adminSite" path="/sites/wsfaccess"/>
<c:set var="fromUser" value="${jcr:getParentOfType(currentNode,'jnt:user')}"/>
<c:url var="userUrl"
       value='${url.baseLive}${functions:escapePath(fromUser.path)}.workspace-public-user.html?jsite=${adminSite.identifier}'/>

<c:set var="message" value="${currentNode.properties['j:message'].string}"/>
<c:if test="${currentNode.properties['j:activityType'].string eq 'resourceBundle'}">
    <c:if test="${fn:contains(message,':')}">
        <c:set value="${fn:substringAfter(message,':')}" var="key"/>
        <c:set value="${fn:substringBefore(message,':')}" var="bundleName"/>

        <%
            Resource currentResource = (Resource) pageContext.findAttribute("currentResource");
            LocalizationContext ctx = new LocalizationContext(
                    new JahiaResourceBundle(currentResource.getLocale(), (String) pageContext.findAttribute("bundleName")),
                    currentResource.getLocale());
            pageContext.setAttribute("bundle", ctx);
        %>
        <c:set var="message"><fmt:message bundle="${bundle}" key="${key}"/></c:set>
    </c:if>
    <c:if test="${not fn:contains(fields['j:messageKey'],':')}">
        <c:set var="message"><fmt:message key="${message}"/></c:set>
    </c:if>
</c:if>

<div class="row-fluid">
    <jcr:nodeProperty var="picture" node="${fromUser}" name="j:picture"/>
    <c:if test="${not empty picture}">
        <div class="span1">
            <a href="${userUrl}"><img class="margin-right-10 img-polaroid img-circle"
                                      src="${picture.node.thumbnailUrls['avatar_120']}"/></a>
        </div>
    </c:if>
    <c:if test="${empty picture}">
        <div class="span1">
            <a href="${userUrl}">
                <img class="margin-right-10 img-polaroid img-circle"
                     alt=" " src="<c:url value='/modules/social/images/userBig.png'/>" border="0"/>
            </a>
        </div>
    </c:if>

    <div class="span6">
        <p>
            <a href="${userUrl}">${fn:escapeXml(not empty fromUser ? user:userFullName(fromUser) : fields["jcr:createdBy"])}</a>
        </p>
    </div>

    <jcr:nodeProperty node="${currentNode}" name="jcr:lastModified" var="lastModified"/>

    <div class="momentToFormat span5 text-right" data-moment-display-type="fromNow" data-moment-locale="${currentResource.locale}"
         data-moment="<fmt:formatDate value="${lastModified.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></div>

    <div class="row offset1">
        <div class="span12">
            <strong>${fn:escapeXml(message)}</strong>
        </div>
    </div>
</div>
<div class='clearfix'></div>