<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="acl" type="java.lang.String"--%>
<c:set var="boundComponent" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<c:choose>
    <c:when test="${not empty boundComponent and not jcr:isLockedAndCannotBeEdited(boundComponent)}">
        <template:addResources type="css" resources="vendor/bootstrap-tags/bootstrap-tags.css"/>
        <template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>

        <template:addResources type="javascript" resources="jquery.min.js"/>
        <template:addResources type="javascript" resources="vendor/bootstrap-tags/bootstrap-tags.js"/>
        <template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>

        <%--These are tags currently in the system for the main resource--%>
        <jcr:nodeProperty node="${boundComponent}" name="j:tagList" var="assignedTagsList"/>
        <c:forEach items="${assignedTagsList}" var="tag" varStatus="status">
            <c:if test="${status.first}">
                <c:set var="assignedTags" value="${tag.string}"/>
            </c:if>
            <c:set var="assignedTags" value="${assignedTags},${tag.string}"/>
        </c:forEach>

        <script type="text/javascript">
            $(document).ready(function() {
                // typeahead
                var ta = new Bloodhound({
                    datumTokenizer: Bloodhound.tokenizers.whitespace(),
                    queryTokenizer: Bloodhound.tokenizers.whitespace,
                    remote: {
                        url: '<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.matchingTags.do'/>' + '?q=___QUERY',
                        filter: function(data) {
                            var arr = [];
                            for (var i = 0; i < data.tags.length; i++)
                                arr.push({name: data.tags[i].name});
                            return arr;
                        },
                        wildcard: '___QUERY',
                        ajax : {
                            type: 'GET',
                            dataType: 'json',
                            data: {
                                limit: 5,
                                emptyResultForBadQuery: true
                            }
                        }
                    },
                    limit: 10
                });

                // Initialize the Bloodhound suggestion engine
                ta.initialize();

                // Instantiate the Typeahead UI
                $('.tagInput_${currentNode.identifier}').tagsinput('input');
                var tagTypeahead = $('.tagInput_${currentNode.identifier}').tagsinput('input').typeahead(null, {
                    displayKey: 'name',
                    source: ta.ttAdapter(),
                    highlight: true,
                    autocomplete: true
                });

                $('.tt-input').attr('placeholder', wsfi18n['jnt_tagging.docspace.addTags']);

                //Tagging listeners
                var isAlreadyInEvent = false;
                $(".tagInput_${currentNode.identifier}").on("beforeItemAdd", function(e){
                    if (!isAlreadyInEvent) {
                        isAlreadyInEvent = true;
                        e.cancel = true;
                        $.ajax({
                            url: "<c:url value="${url.base}${functions:escapePath(boundComponent.path)}.transformTag.do"/>",
                            type: "POST",
                            dataType: "json",
                            data: {tag: e.item},
                            traditional: true
                        })
                        .done(function (result) {
                            if(result.tags){
                                var tagToAdd = result.tags[0];
                                $('#newBlogEntryForm').append('<input type="hidden" name="j:tagList" value="' + tagToAdd + '"/>');
                                $('.tagInput_${currentNode.identifier}').tagsinput('add', tagToAdd);
                            }
                        });
                    } else {
                        isAlreadyInEvent = false;
                    }
                    tagTypeahead.typeahead('val', '');
                })
                .on("itemRemoved", function(e) {
                    $('input[value="' + e.item + '"]').remove();
                });
            });

        </script>
        <c:if test="${renderContext.user.name != 'guest'}">
            <input class="tagInput_${currentNode.identifier}" type="hidden" value="${assignedTags}"
                   placeholder="<fmt:message key='jnt_tagging.docspace.addTags'/>"/>
        </c:if>
    </c:when>
    <c:otherwise>
        <fmt:message key="nt_base.workflowMonitor.docspace.documentLocked"/>
    </c:otherwise>
</c:choose>
