<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="acl" type="java.lang.String"--%>
<template:addResources type="css" resources="vendor/bootstrap-tags/bootstrap-tags.css"/>
<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>

<template:addResources type="javascript" resources="vendor/bootstrap-tags/bootstrap-tags.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>

<c:set var="boundComponent" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<c:choose>
    <c:when test="${not empty boundComponent and not jcr:isLockedAndCannotBeEdited(boundComponent)}">
        <template:addResources type="css" resources="vendor/bootstrap-tags/bootstrap-tags.css"/>

        <template:addResources type="javascript" resources="jquery.min.js"/>
        <template:addResources type="javascript" resources="vendor/bootstrap-tags/bootstrap-tags.js"/>

        <%--These are tags currently in the system for the main resource--%>
        <jcr:nodeProperty node="${boundComponent}" name="j:tagList" var="assignedTagsList"/>
        <c:forEach items="${assignedTagsList}" var="tag" varStatus="status">
            <c:if test="${status.first}">
                <c:set var="assignedTags" value="${fn:escapeXml(tag.string)}"/>
            </c:if>
            <c:set var="assignedTags" value="${assignedTags},${fn:escapeXml(tag.string)}"/>
        </c:forEach>

        <script type="text/javascript">
            $(document).ready(function() {
                $('.accordion-toggle').on("click", function() {
                    $(".tagsAccordionTabCollapse").css("overflow", "hidden");
                });
                // typeahead
                var ta = new Bloodhound({
                    datumTokenizer: Bloodhound.tokenizers.whitespace(),
                    queryTokenizer: Bloodhound.tokenizers.whitespace,
                    remote: {
                        url: '<c:url value='${url.base}${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.matchingTags.do'/>' + '?q=___QUERY',
                        filter: function(data) {
                            var arr = [];
                            for (var i = 0; i < data.tags.length; i++)
                                arr.push({name: data.tags[i].name});
                            return arr;
                        },
                        wildcard: '___QUERY',
                        ajax : {
                            beforeSend : function() {
                                $(".tagsAccordionTabCollapse").css("overflow", "visible");
                            },
                            type: "GET",
                            dataType: 'json',
                            data: {
                                limit: 5,
                                emptyResultForBadQuery: true
                            }
                        }
                    },
                    limit: 10
                });

                // Initialize the Bloodhound suggestion engine
                ta.initialize();

                // Instantiate the Typeahead UI
                var el = $('.tagInput_${currentNode.identifier}');
                var tagTypeahead = el.tagsinput("input").typeahead(null, {
                    displayKey: 'name',
                    source: ta.ttAdapter(),
                    highlight: true,
                    autocomplete: true
                });

                //Tagging listeners
                var isAlreadyInEvent = false;
                $(".tagInput_${currentNode.identifier}").on("beforeItemAdd", function(e){
                    if (!isAlreadyInEvent) {
                        isAlreadyInEvent = true;
                        e.cancel = true;
                        $.ajax({
                            url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.transformTag.do"/>",
                            type: "POST",
                            dataType: "json",
                            data: {tag: e.item},
                            traditional: true
                        })
                        .done(function (result) {
                            if(result.tags){
                                var tagToAdd = result.tags[0];
                                $('.tagInput_${currentNode.identifier}').tagsinput('add', tagToAdd);
                                Tagging.addTag(tagToAdd);
                            }
                        });
                    } else {
                        isAlreadyInEvent = false;
                        tagTypeahead.typeahead('val', '');
                    }
                }).on("itemRemoved", function(e) {
                    Tagging.removeTag(e.item);
                });
            });

            var Tagging = {
                addTag : function(newTag) {
                    if (newTag) {
                        var options = {
                            url: "<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}"/>.addTag.do",
                            type: "POST",
                            dataType: "json",
                            data: {tag: newTag},
                            traditional: true
                        };
                        $.ajax(options).done(function (result) {});
                    }
                },
                removeTag : function(oldTag) {
                    $.post("<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}"/>.removeTag.do", {"tag":oldTag, "unescape":true}, function(result) {}, "json");
                }
            };//Tagging

        </script>
        <c:if test="${renderContext.user.name != 'guest'}">
            <div>
            <input class="tagInput_${currentNode.identifier}" type="text" value="${assignedTags}" data-role="tagsinput"
                   placeholder="<fmt:message key='jnt_tagging.docspace.addTags'/>"/>
            </div>
        </c:if>
    </c:when>
    <c:otherwise>
        <fmt:message key="nt_base.workflowMonitor.docspace.documentLocked"/>
    </c:otherwise>
</c:choose>