<%@ page contentType="text/html; UTF-8" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="tasks.css"/>
<template:addResources type="javascript" resources="tasks.js"/>

<c:if test="${empty param['bindedComponent']}">
    <c:set var="bindedComponent"
           value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent').path}"/>
</c:if>
<c:if test="${not empty param['bindedComponent']}">
    <c:set var="bindedComponent" value="${param['bindedComponent']}"/>
</c:if>
<c:if test="${currentResource.workspace eq 'live'}">
    <div id="currentUserTasks${currentNode.identifier}">
        <script type="text/javascript">
            $('#currentUserTasks${currentNode.identifier}').load('<c:url value="${url.basePreview}${functions:escapePath(currentNode.path)}.html.ajax?bindedComponent=${bindedComponent}"/>');
        </script>
    </div>
</c:if>
<c:if test="${currentResource.workspace ne 'live'}">
    <c:set value="" var="todayDisplayed" scope="request"/>

    <c:choose>
        <c:when test="${not empty currentNode.properties['filterTaskOnTypes']}">
            <query:definition var="listQuery"
                              statement="SELECT * FROM [jnt:content] AS t WHERE isdescendantnode(t,['${functions:sqlencode(bindedComponent)}']) AND (( t.['jcr:primaryType'] = 'jnt:task' AND t.type='${currentNode.properties['filterTaskOnTypes'].string}') OR t.['jcr:primaryType'] = 'jnt:post') ORDER BY [jcr:created] DESC"/>
        </c:when>
        <c:otherwise>
            <query:definition var="listQuery"
                              statement="SELECT * FROM [jnt:content] AS t WHERE isdescendantnode(t,['${functions:sqlencode(bindedComponent)}']) AND ( t.['jcr:primaryType'] = 'jnt:task' OR t.['jcr:primaryType'] = 'jnt:post') ORDER BY [jcr:created] DESC"/>
        </c:otherwise>
    </c:choose>
    <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
    <c:set target="${moduleMap}" property="subNodesView" value="taskList.docspace"/>
</c:if>

<script type="text/javascript">
    function sendNewStatus(uuid, task, state, finalOutcome, reloadurl) {
        $(".taskAction-complete").addClass("taskaction-disabled");
        $(".taskAction").addClass("taskaction-disabled");
        $.post('<c:url value="${url.base}"/>' + task,
                {"jcrMethodToCall":"put", "state":state, "finalOutcome":finalOutcome, "form-token":document.forms['tokenForm_' +
                                                                                                                  uuid].elements['form-token'].value},
                function () {
                    $('#task_' + uuid).load(encodeURI(reloadurl), null, function () {
                        $(".taskAction-complete").removeClass("taskaction-disabled");
                        $(".taskAction").removeClass("taskaction-disabled");
                    });
                    if (state == 'finished') {
                        $("#task_" + uuid).removeClass("alert-success");
                        $("#task_" + uuid).addClass("alert-info");
                        $("#taskPhase_" + uuid).html("Finished Task");
                    }
                }, "json");
    }

    function sendNewAssignee(uuid, task, key, reloadurl) {
        $(".taskAction-complete").addClass("taskaction-disabled");
        $(".taskAction").addClass("taskaction-disabled");
        $.post('<c:url value="${url.base}"/>' + task,
                {"jcrMethodToCall":"put", "state":"active", "assigneeUserKey":key, "form-token":document.forms['tokenForm_' +
                                                                                                               uuid].elements['form-token'].value},
                function () {
                    $('#task_' + uuid).load(encodeURI(reloadurl), null, function () {
                        $(".taskAction-complete").removeClass("taskaction-disabled");
                        $(".taskAction").removeClass("taskaction-disabled");
                    });
                }, "json");
    }
</script>