<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<script type="text/javascript">
    $(document).ready(function(){
        refreshMoment();
    });
</script>

<c:set value="${jcr:getParentOfType(currentNode, 'jmix:moderated')}" var="moderated"/>
<c:choose>
    <c:when test="${not jcr:hasPermission(currentNode, 'moderatePost') and not empty moderated}">
        <jcr:sql var="numberOfPostsQuery"
                 sql="select * from [jnt:post] as post  where isdescendantnode(post, ['${functions:sqlencode(currentNode.path)}']) and post.[moderated]='true' and (not post.['jcr:mixinTypes'] = 'jmix:spamFilteringSpamDetected') order by post.[jcr:lastModified] desc"/>
    </c:when>
    <c:otherwise>
        <jcr:sql var="numberOfPostsQuery"
                 sql="select * from [jnt:post] as post  where isdescendantnode(post, ['${functions:sqlencode(currentNode.path)}']) and (not post.['jcr:mixinTypes'] = 'jmix:spamFilteringSpamDetected') order by post.[jcr:lastModified] desc"/>
    </c:otherwise>
</c:choose>

<c:set var="numberOfPosts" value="${numberOfPostsQuery.nodes.size}"/>
<c:forEach items="${numberOfPostsQuery.nodes}" var="node" varStatus="status" end="2">
    <c:if test="${status.first}">
        <c:set value="${node}" var="lastModifiedNode"/>
        <jcr:nodeProperty node="${node}" name="jcr:lastModified" var="lastModified"/>
        <jcr:nodeProperty node="${lastModifiedNode}" name="jcr:createdBy" var="createdBy"/>
    </c:if>
</c:forEach>
<c:if test="${jcr:hasPermission(currentNode, 'deleteTopic')}">
    <template:tokenizedForm>
        <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post"
              id="jahia-forum-topic-delete-${currentNode.identifier}">
            <input type="hidden" name="jcrRedirectTo"
                   value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <%-- Define the output format for the newly created node by default html or by redirectTo--%>
            <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
            <input type="hidden" name="jcrMethodToCall" value="delete"/>
        </form>
    </template:tokenizedForm>
</c:if>

<td class="span6">
    <c:if test="${jcr:hasPermission(currentNode, 'deleteTopic')}">
        <a title="<fmt:message key='jnt_topic.forum.delete'/>" href="#" class="btn btn-mini btn-danger pull-right"
           onclick="bootbox.confirm(wsfi18n['jnt_topic.forum.confirmDelete'], function(result){ if(result) {$('#jahia-forum-topic-delete-${currentNode.identifier}').submit();}});return false;">
            <i class="fa fa-trash-o"></i>
        </a>
    </c:if>
    <c:if test="${numberOfPosts > 0}">
        <a href="<c:url value='${url.base}${functions:escapePath(currentNode.path)}.html'/>"><h4><c:out
                value="${currentNode.properties.topicSubject.string}"/></h4></a>
    </c:if>
    <c:if test="${numberOfPosts == 0}">
        <h4><c:out value="${currentNode.properties.topicSubject.string}"/></h4>
    </c:if>
    <p>
        <small><fmt:message
                key="wsf.label.createdBy"/>&nbsp;${currentNode.properties["jcr:createdBy"].string}&nbsp;<span
                class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                data-moment-locale="${renderContext.mainResourceLocale}"
                data-moment="${currentNode.properties['jcr:created'].string}"></span></small>
    </p>

</td>
<%--<dd class="topics">30</dd>--%>
<td class="span2"><span class="text">${numberOfPosts}</span></td>
<td class="span1"><span class="text">${currentNode.properties["nbOfViews"].string}</span></td>
<c:if test="${numberOfPosts > 0}">
    <td class="span3">
        <p>
            <small>
                <em><fmt:message key="jnt_topic.forum.lastPost"/>&nbsp;<fmt:message key="wsf.label.by"/></em>
                <c:if test="${createdBy.string eq 'guest'}">
                    ${createdBy.string}<fmt:formatDate value="${lastModified.time}" dateStyle="full"
                                                       type="both"/>
                </c:if>
                <c:if test="${createdBy.string ne 'guest'}">
                    <jcr:node var="adminSite" path="/sites/wsfaccess"/>
                    <a href="<c:url value='${url.baseLive}${functions:escapePath(functions:lookupUser(createdBy.string).localPath)}.workspace-user.html?jsite=${adminSite.identifier}'/>">${createdBy.string}
                    </a>
                </c:if>
                <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LLL"
                      data-moment-locale="${renderContext.mainResourceLocale}"
                      data-moment="${currentNode.properties['jcr:created'].string}"></span>
            </small>
        </p>
    </td>
</c:if>