<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:include view="hidden.header"/>
<c:set var="linked" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:if test="${not empty linked}">
    <c:set value="${jcr:getParentOfType(renderContext.mainResource.node, 'jmix:moderated')}" var="moderated"/>
    <c:choose>
        <c:when test="${empty moderated or jcr:hasPermission(moderated, 'moderatePost')}">
            <jcr:sql var="numberOfPostsQuery"
                     sql="select [jcr:uuid] from [jnt:post] as p  where isdescendantnode(p,['${functions:sqlencode(linked.path)}'])"/>
            <jcr:sql var="numberOfThreadsQuery"
                     sql="select [jcr:uuid] from [jnt:topic] as t  where isdescendantnode(t,['${functions:sqlencode(linked.path)}'])"/>
        </c:when>
        <c:otherwise>
            <jcr:sql var="numberOfPostsQuery"
                     sql="select [jcr:uuid] from [jnt:post] as p  where isdescendantnode(p,['${functions:sqlencode(linked.path)}']) and p.['moderated']=true"/>
            <jcr:sql var="numberOfThreadsQuery"
                     sql="select [jcr:uuid] from [jnt:topic] as t  where isdescendantnode(t,['${functions:sqlencode(linked.path)}']) and t.['moderated']=true"/>
        </c:otherwise>
    </c:choose>
    <c:set var="numberOfPosts" value="${numberOfPostsQuery.rows.size}"/>
    <c:set var="numberOfThreads" value="${numberOfThreadsQuery.rows.size}"/>
    <template:addCacheDependency node="${linked}"/>
    <div class="well">
        <div class="row-fluid">
            <div class="span2 pull-right">
                <dl class="dl-horizontal-topic alert alert-success">
                    <dt>${numberOfThreads}</dt>
                    <dd><fmt:message key="jnt_topicList.threads"/></dd>
                    <dt>${numberOfPosts}</dt>
                    <dd><fmt:message key="jnt_topicList.posts"/></dd>
                </dl>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <table class="table table-striped">
                    <thead>
                    <th class="span6"><fmt:message key="jnt_topicList.topic"/></th>
                    <th class="span2"><fmt:message key="jnt_topicList.posts"/></th>
                    <th class="span1"><fmt:message key="jnt_topicList.views"/></th>
                    <th class="span3"><fmt:message key="jnt_topicList.lastPosts"/></th>
                    </thead>


                    <tbody>
                    <c:forEach items="${moduleMap.currentList}" var="subchild" varStatus="status"
                               begin="${moduleMap.begin}"
                               end="${moduleMap.end}">
                        <c:if test="${jcr:isNodeType(subchild, 'jnt:topic')}">
                            <template:addCacheDependency node="${subchild}"/>
                            <tr>
                                <template:module node="${subchild}" view="${moduleMap.subNodesView}"/>
                            </tr>
                            <c:set var="found" value="true"/>
                        </c:if>
                    </c:forEach>

                    <c:if test="${not found}">
                        <tr>
                            <td><fmt:message key="jnt_topicList.noTopicFound"/></td>
                        </tr>
                    </c:if>
                    </tbody>
                </table>
            </div>
        </div>
    </div>

</c:if>