<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<c:set var="user" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:if test="${!empty param.userUuid}">
    <jcr:node var="user" uuid="${param.userUuid}"/>
</c:if>
<c:if test="${empty user or not jcr:isNodeType(user, 'jnt:user')}">
    <jcr:node var="user" path="${renderContext.user.localPath}"/>
</c:if>
<c:set var="user" value="${user:lookupUser(user.path)}"/>

<template:addCacheDependency node="${user}"/>

<c:if test="${currentNode.properties['j:title'].boolean}">
    <jcr:nodePropertyRenderer node="${user}" name="j:title" renderer="resourceBundle" var="title"/>
</c:if>
<c:if test="${not empty title and (not empty user.properties['j:firstName'].string and currentNode.properties['j:firstName'].boolean) and (not empty user.properties['j:lastName'].string and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${title.displayName} ${user.properties['j:firstName'].string} ${user.properties['j:lastName'].string}"/>
</c:if>
<c:if test="${empty title and (not empty user.properties['j:firstName'].string and currentNode.properties['j:firstName'].boolean) and (not empty user.properties['j:lastName'].string and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${user.properties['j:firstName'].string} ${user.properties['j:lastName'].string}"/>
</c:if>
<c:if test="${empty title and (empty user.properties['j:firstName'].string or not currentNode.properties['j:firstName'].boolean) and (not empty user.properties['j:lastName'].string and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${user.properties['j:lastName'].string}"/>
</c:if>
<c:if test="${empty title and (not empty user.properties['j:firstName'].string and currentNode.properties['j:firstName'].boolean) and (empty user.properties['j:lastName'].string or not currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${user.properties['j:firstName'].string}"/>
</c:if>
<c:if test="${empty title and empty user.properties['j:firstName'].string and empty user.properties['j:lastName'].string}">
    <c:set var="person" value=""/>
</c:if>

<div class="row-fluid">
    <div class="span10">
        <div class="hero-unit row-fluid">
            <div class="span2">
                <c:if test="${currentNode.properties['j:picture'].boolean}">
                    <jcr:nodeProperty var="picture" node="${user}" name="j:picture"/>
                    <c:choose>
                        <c:when test="${not empty picture}">
                            <img class="img-circle img-polaroid" src="${picture.node.thumbnailUrls['avatar_120']}" alt="${fn:escapeXml(person)}"/>
                        </c:when>
                        <c:otherwise>
                            <img class="img-circle img-polaroid" src="<c:url value='${url.currentModule}/img/userbig.png'/>" alt="" border="0"/>
                        </c:otherwise>
                    </c:choose>
                </c:if>
                <ul class="unstyled">
                    <c:if test="${currentNode.properties['j:skypeID'].boolean and not empty user.properties['j:skypeID'].string}">
                        <script type="text/javascript" src="http://www.skypeassets.com/i/scom/js/skype-uri.js"></script>
                        <li>
                            <div id="SkypeButton_Call_${user.properties['j:skypeID'].string}_1">
                                <script type="text/javascript">
                                    Skype.ui({
                                        "name": "dropdown",
                                        "element": "SkypeButton_Call_${user.properties['j:skypeID'].string}_1",
                                        "participants": ["${user.properties['j:skypeID'].string}"],
                                        "imageSize": 24
                                    });
                                    $('#SkypeButton_Call_' + '${user.properties['j:skypeID'].string}' + '_1_paraElement').css('height', '35px');
                                </script>
                            </div>
                        </li>
                    </c:if>
                    <c:if test="${currentNode.properties['j:twitterID'].boolean and not empty user.properties['j:twitterID'].string}">
                        <li>
                            <a href="https://twitter.com/${user.properties['j:twitterID'].string}" class="twitter-follow-button" data-show-count="false">
                                Follow @${user.properties['j:twitterID'].string}
                            </a>
                            <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
                        </li>
                    </c:if>
                    <c:if test="${currentNode.properties['j:facebookID'].boolean and not empty user.properties['j:facebookID'].string}">
                        <li>
                            <a href="http://www.facebook.com/${user.properties['j:facebookID'].string}" target="_blank" title="${user.properties['j:facebookID'].string}">
                                <i class="fa fa-facebook"></i>
                                    ${user.properties['j:facebookID'].string}
                            </a>
                        </li>
                    </c:if>
                    <c:if test="${currentNode.properties['j:linkedinID'].boolean and not empty user.properties['j:linkedinID'].string}">
                        <li>
                            <a href="http://www.linkedin.com/in/${user.properties['j:linkedinID'].string}" target="_blank" title="${user.properties['j:linkedinID'].string}">
                                <i class="fa fa-linkedin"></i>
                                    ${user.properties['j:linkedinID'].string}
                            </a>
                        </li>
                    </c:if>
                </ul>
            </div>

            <div class="span8">
                <h3>
                    <c:choose>
                        <c:when test="${not empty fn:trim(person)}">
                            ${fn:escapeXml(person)}&nbsp;
                        </c:when>
                        <c:otherwise>
                            ${fn:escapeXml(user.displayableName)}&nbsp;
                        </c:otherwise>
                    </c:choose>
                </h3>

                <c:if test="${currentNode.properties['j:birthDate'].boolean and not empty user.properties['j:birthDate'].date.time}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_birthDate"/></dt>
                        <dd class="momentToFormat" data-moment-display-type="format"
                            data-moment-format="LL" data-moment-locale="${currentResource.locale}"
                            data-moment="<fmt:formatDate value="${user.properties['j:birthDate'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></dd>
                    </dl>
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.age"/></dt>
                        <dd class="momentToFormat" data-moment-display-type="fromNow"
                            data-moment-format="true" data-moment-locale="${currentResource.locale}"
                            data-moment="<fmt:formatDate value="${user.properties['j:birthDate'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>">
                        </dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:organization'].boolean and not empty user.properties['j:organization'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_organization"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:organization'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:function'].boolean and not empty user.properties['j:function'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_function"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:function'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:address'].boolean and not empty user.properties['j:address'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_address"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:address'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:zipCode'].boolean and not empty user.properties['j:zipCode'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_zipCode"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:zipCode'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:city'].boolean and not empty user.properties['j:city'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_city"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:city'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:country'].boolean and not empty user.properties['j:country'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_country"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:country'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:phoneNumber'].boolean and not empty user.properties['j:phoneNumber'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_phoneNumber"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:phoneNumber'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:mobileNumber'].boolean and not empty user.properties['j:mobileNumber'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_mobileNumber"/></dt>
                        <dd>${fn:escapeXml(user.properties['j:mobileNumber'].string)}</dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:email'].boolean and not empty user.properties['j:email'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_user.j_email"/></dt>
                        <dd><a href="mailto:${user.properties['j:email'].string}">${user.properties['j:email'].string}</a></dd>
                    </dl>
                </c:if>

                <c:if test="${currentNode.properties['j:about'].boolean and not empty user.properties['j:about'].string}">
                    <dl class="dl-horizontal">
                        <dt><fmt:message key="jnt_userDetails.workspace-factory.aboutMe"/></dt>
                        <dd>${user.properties['j:about'].string}</dd>
                    </dl>
                </c:if>
            </div>
            <c:if test="${renderContext.user.username == user.name and jcr:hasPermission(renderContext.site, 'jcr:read_default')}">
                <fmt:message key="jnt_userDetails.docspace.editProfile" var="editProfile"/>
                <a class="pull-right" title="${fn:escapeXml(editProfile)}"
                   href="<c:url value="/cms/wsfactory/default/${currentResource.locale}/sites/wsfaccess/user-profile.html"/>">
                    ${editProfile}
                </a>
            </c:if>
        </div>
    </div>
</div>



