<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.min.js,jquery.validate.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>

<c:if test="${not renderContext.liveMode || not renderContext.loggedIn}">
    <script type="text/javascript">
        $(document).ready(function() {
            $("#newUser").validate({
                rules: {
                    desired_firstname : "required",
                    desired_lastname: "required",
                    username: {
                        required: true,
                        minlength: 2
                    },
                    password: {
                        required: true
                    },
                    confirm_password: {
                        required: true,
                        equalTo: "#desired_password"
                    },
                    desired_email: {
                        required: true,
                        email: true
                    },
                    confirm_email: {
                        required: true,
                        equalTo: "#desired_email"
                    }
                },
                messages: {
                    desired_firstname: wsfi18n['jnt_userRegistration.bootstrap.askFirstname'],
                    desired_lastname: wsfi18n['jnt_userRegistration.bootstrap.askLastname'],
                    username: {
                        required: wsfi18n['jnt_userRegistration.bootstrap.askUsername'],
                        minlength: wsfi18n['jnt_userRegistration.bootstrap.usernameSizeWarning']
                    },
                    password: wsfi18n['jnt_userRegistration.bootstrap.askPassword'],
                    confirm_password: {
                        required: wsfi18n['jnt_userRegistration.bootstrap.askPassword'],
                        equalTo: wsfi18n['jnt_userRegistration.bootstrap.validatePassword']
                    },
                    desired_email: wsfi18n['jnt_userRegistration.bootstrap.askEmail'],
                    confirm_email: {
                        required: wsfi18n['jnt_userRegistration.bootstrap.askEmail'],
                        equalTo: wsfi18n['jnt_userRegistration.bootstrap.validateEmail']
                    }
                },
                errorClass: "text-error",
                validClass: "text-success"
            });
        });
    </script>

    <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h3><fmt:message key="jnt_userRegistration.bootstrap.name"/></h3>
    </div>
    <template:tokenizedForm>
        <form method="post" class="form-horizontal no-margin-bottom" name="newUser" id="newUser"
              action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}.newUser.do'/>">
            <div class="modal-body">
                <input type="hidden" name="userredirectpage" value="${currentNode.properties['userRedirectPage'].node.path}"/>
                <c:if test="${not empty currentNode.properties['from']}">
                    <input type="hidden" name="from" value="${currentNode.properties['from'].string}"/>
                </c:if>
                <c:if test="${not empty currentNode.properties['to']}">
                    <input type="hidden" name="to" value="${currentNode.properties['to'].string}"/>
                </c:if>
                <c:if test="${not empty currentNode.properties['cc']}">
                    <input type="hidden" name="cc" value="${currentNode.properties['cc'].string}"/>
                </c:if>
                <c:if test="${not empty currentNode.properties['bcc']}">
                    <input type="hidden" name="bcc" value="${currentNode.properties['bcc'].string}"/>
                </c:if>
                <input type="hidden" name="toAdministrator" value="${currentNode.properties['toAdministrator'].string}"/>

                <div class="control-group">
                    <label class="control-label" for="desired_login">
                        <fmt:message key="jnt_userRegistration.bootstrap.login"/>
                    </label>
                    <div class="controls">
                        <input type="text" name="username" id="desired_login" value=""/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="desired_firstname">
                        <fmt:message key="jnt_userRegistration.bootstrap.firstname"/>
                    </label>
                    <div class="controls">
                        <input type="text" name="desired_firstname" id="desired_firstname"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="desired_lastname">
                        <fmt:message key="jnt_userRegistration.bootstrap.lastname"/>
                    </label>
                    <div class="controls">
                        <input type="text" name="desired_lastname" id="desired_lastname"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="desired_email">
                        <fmt:message key="jnt_userRegistration.bootstrap.email"/>
                    </label>
                    <div class="controls">
                        <input type="email" name="desired_email" id="desired_email"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="confirm_email">
                        <fmt:message key="jnt_userRegistration.bootstrap.confirmEmail"/>
                    </label>
                    <div class="controls">
                        <input type="email" name="confirm_email" id="confirm_email" autocomplete="off"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="desired_password">
                        <fmt:message key="jnt_userRegistration.bootstrap.password"/>
                    </label>
                    <div class="controls">
                        <input type="password" name="password" id="desired_password" autocomplete="off"/>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="confirm_password">
                        <fmt:message key="jnt_userRegistration.bootstrap.confirmPassword"/>
                    </label>
                    <div class="controls">
                        <input type="password" name="confirm_password" id="confirm_password" autocomplete="off"/>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-danger" data-dismiss="modal" aria-hidden="true">
                    <fmt:message key="wsf.label.cancel"/>
                </button>
                <button type="submit" class="btn btn-primary">
                    <fmt:message key='jnt_userRegistration.bootstrap.create'/>
                </button>
            </div>
        </form>
    </template:tokenizedForm>
</c:if>