<%@ page import="org.jahia.services.workflow.WorkflowService" %>
<%@ page import="org.jahia.services.workflow.HistoryWorkflow" %>
<%@ page import="java.util.List" %>
<%@ page import="org.jahia.services.workflow.HistoryWorkflowTask" %>
<%@ page import="java.util.Locale" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="loading.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="loading.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<workflow:activeWorkflow node="${currentNode}" var="activeWorkflows" locale="${currentResource.locale}"/>
<c:forEach items="${activeWorkflows}" var="currentActiveWorkflow">
    <c:if test="${currentActiveWorkflow.workflowDefinition.workflowType eq currentResource.moduleParams.workflowType}">
        <c:set var="activeWorkflow" value="${currentActiveWorkflow}"/>
        <c:set var="workflowDefinition" value="${currentActiveWorkflow.workflowDefinition}"/>

        <script type="text/javascript">
            $(document).ready(function () {
                $(".workflowStartLink").hide();
                $(".workflowExecuteLink").show();
            });
        </script>
    </c:if>
</c:forEach>

<%--Identify workflow kind--%>
<c:set var="workFlowName" value=""/>
<c:forEach items="${renderContext.mainResource.node.parent.nodes}" var="n">
    <c:if test="${jcr:isNodeType(n, 'jnt:workflowRules')}">
        <c:forEach items="${n.nodes}" var="c">
                <c:if test="${jcr:isNodeType(c, 'jnt:workflowRule')}">
                    <c:set var="workFlowName" value="${c.properties['j:workflow'].string}"/>
                </c:if>
        </c:forEach>
    </c:if>
</c:forEach>

<c:if test="${empty activeWorkflow}">
    <c:if test="${not currentNode.locked}">
        <workflow:workflowsForNode checkPermission="false" node="${currentNode}" var="workflowDefinitions"
                                   workflowAction="${currentResource.moduleParams.workflowType}"
                                   locale="${currentResource.locale}"/>
        <c:forEach items="${workflowDefinitions}" var="currentWorkflowDefinition">
            <c:set var="workflowDefinition" value="${currentWorkflowDefinition}"/>
        </c:forEach>
        <c:if test="${empty workflowDefinitions}">
            <fmt:message key="nt_base.workflowMonitor.docspace.noWorkflowSet"/>: ${currentResource.moduleParams.workflowType}
        </c:if>
        <script type="text/javascript">
            $(document).ready(function () {
                $(".workflowStartLink").show();
                $(".workflowExecuteLink").hide();
            });
        </script>
    </c:if>
    <c:if test="${currentNode.locked}">
        <fmt:message key="nt_base.workflowMonitor.docspace.documentLocked"/>

        <script type="text/javascript">
            $(document).ready(function () {
                $(".workflowStartLink").hide();
                $(".workflowExecuteLink").hide();
            });
        </script>
    </c:if>
</c:if>

<c:if test="${empty workflowDefinition}">
    <script type="text/javascript">
        $(document).ready(function () {
            $(".workflowStatusLink").hide();
        });
    </script>
</c:if>

<c:if test="${not empty workflowDefinition}">
    <workflow:tasksForNode node="${currentNode}" var="tasksForNode" locale="${currentResource.locale}"/>
    <jsp:useBean id="tasks" class="java.util.HashMap"/>
    <c:forEach items="${tasksForNode}" var="task" varStatus="status">
        <c:if test="${task.workflowDefinition == workflowDefinition}">
            <c:set target="${tasks}" property="${task.name}" value="${task}"/>
        </c:if>
    </c:forEach>

    <p>
        <a href="#" title="" onclick="viewWorkflowStatus()">
            <fmt:message key="docnt_docspaceActions.workflow.viewWorkflowStatus"/>
        </a>
        <script type="text/javascript">
            var viewWorkflowStatus = function () {
                animateWorkflowTask${fn:replace(currentNode.identifier,'-','')}${fn:replace(workflowDefinition.key,'-','')}();
                $('#wfStatusHolder').modal();
            }
        </script>
    </p>

    <jsp:useBean id="historyTasks" class="java.util.HashMap"/>
    <c:if test="${not empty activeWorkflow}">
        <c:if test="${currentResource.moduleParams.showHistory == 'true'}">
            <workflow:workflowHistory var="history" workflowId="${activeWorkflow.id}"
                                      workflowProvider="${activeWorkflow.provider}" locale="${currentResource.locale}"/>
            <fmt:message key="nt_base.workflowMonitor.docspace.history"/>:
            <ul>
                <c:forEach items="${history}" var="historyTask">
                    <c:set target="${historyTasks}" property="${historyTask.name}" value="${historyTask}"/>
                    <c:if test="${not empty historyTask.endTime}">
                        <li>
                                ${historyTask.displayName}
                            <ul>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.user"/>: ${historyTask.user}</li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.duration"/>: ${historyTask.duration/1000}s</li>
                                <li>
                                    <fmt:message key="nt_base.workflowMonitor.docspace.started"/>:
                                    <span class="momentToFormat" data-moment-display-type="format"
                                          data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                          data-moment="<fmt:formatDate value="${historyTask.startTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                                </li>
                                <li>
                                    <fmt:message key="nt_base.workflowMonitor.docspace.ended"/>:
                                    <span class="momentToFormat" data-moment-display-type="format"
                                          data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                          data-moment="<fmt:formatDate value="${historyTask.endTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                                </li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.outcome"/>: ${historyTask.displayOutcome}</li>
                            </ul>
                        </li>
                    </c:if>
                </c:forEach>
            </ul>
        </c:if>
        <fmt:message key="nt_base.workflowMonitor.docspace.openTasks"/>:
        <ul>
            <c:forEach items="${activeWorkflow.availableActions}" var="action">
                <c:if test="${(empty currentResource.moduleParams.task) or (!empty currentResource.moduleParams.task and currentResource.moduleParams.task == action.name)}">
                    <li>
                            ${action.displayName} <c:if test="${not empty tasks[action.name]}"> - <a
                            href="#task_${currentNode.identifier}_${activeWorkflow.id}" data-toggle="modal"
                            title="<fmt:message key="nt_base.workflowMonitor.docspace.execute"/>">
                                <fmt:message key="nt_base.workflowMonitor.docspace.execute"/>
                            </a></c:if>
                        <ul>
                            <li>
                                <fmt:message key="nt_base.workflowMonitor.docspace.started"/>:
                                <span class="momentToFormat" data-moment-display-type="format"
                                      data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                      data-moment="<fmt:formatDate value="${action.createTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                            </li>
                            <li><fmt:message key="nt_base.workflowMonitor.docspace.dueFor"/>:
                                <span class="momentToFormat" data-moment-display-type="format"
                                      data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                      data-moment="<fmt:formatDate value="${action.dueDate}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                            </li>
                        </ul>
                    </li>
                </c:if>
            </c:forEach>
        </ul>
    </c:if>

    <div id="wfStatusHolder" class="modal hide fade
    <c:if test="${workFlowName eq 'jBPM:docspace-workflow-archive-publish'}"> width-auto</c:if>">
        <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true"
                    onclick="stopAnimateWorkflowTask()">&times;</button>
            <h3><fmt:message key="nt_base.workflowMonitor.docspace.workflow"/></h3>
        </div>
        <div id="workflowImage${fn:replace(currentNode.identifier,'-','')}${fn:replace(workflowDefinition.key,'-','')}" class="modal-body
             <c:if test="${workFlowName eq 'jBPM:docspace-workflow-archive-publish'}"> max-height-600</c:if>">
            <div id="workflowImageDiv${fn:replace(currentNode.identifier,'-','')}${fn:replace(workflowDefinition.key,'-','')}"
                 class="workflowImageDiv">
                <div class="height-50"></div>
                <img src="<c:url value='/cms/wfImage?workflowKey=${workflowDefinition.packageName}:${workflowDefinition.key}&language=${currentResource.locale}'/>"/>

                <div class="height-50"></div>

                <c:forEach items="${activeWorkflow.availableActions}" var="task"
                           varStatus="status">
                    <div id="running${task.id}" class="runningtask-div"
                         onmouseover="$('#runningInfo${task.id}').show();"
                         onmouseout="$('#runningInfo${task.id}').hide()"
                         onclick="$('#wfStatusHolder').modal('hide');stopAnimateWorkflowTask();"
                         data-toggle="modal" data-target="#task_${currentNode.identifier}_${activeWorkflow.id}">
                    </div>
                    <div id="runningInfo${task.id}" class="runningInfo">
                        <ul>
                            <li><fmt:message key="nt_base.workflowMonitor.docspace.started"/>:
                                <span class="momentToFormat" data-moment-display-type="format"
                                      data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                      data-moment="<fmt:formatDate value="${task.createTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                            </li>
                            <li><fmt:message key="nt_base.workflowMonitor.docspace.dueFor"/>:
                                <span class="momentToFormat" data-moment-display-type="format"
                                      data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                      data-moment="<fmt:formatDate value="${task.dueDate}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                            </li>
                        </ul>
                    </div>
                </c:forEach>
                <c:forEach items="${historyTasks}" var="task" varStatus="status">
                    <c:if test="${not empty task.value.endTime}">
                        <div id="history${task.value.actionId}" class="historytask-div"
                             onmouseover="$('#historyInfo${task.value.actionId}').show()"
                             onmouseout="$('#historyInfo${task.value.actionId}').hide()"></div>
                        <div id="historyInfo${task.value.actionId}" class="historyInfo">
                            <ul>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.user"/>: ${task.value.user}</li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.duration"/>: ${task.value.duration/1000}s</li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.started"/>:
                                    <span class="momentToFormat" data-moment-display-type="format"
                                          data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                          data-moment="<fmt:formatDate value="${task.value.startTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                                </li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.ended"/>:
                                    <span class="momentToFormat" data-moment-display-type="format"
                                          data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                          data-moment="<fmt:formatDate value="${task.value.endTime}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
                                </li>
                                <li><fmt:message key="nt_base.workflowMonitor.docspace.outcome"/>: ${task.value.displayOutcome}</li>
                            </ul>
                        </div>
                    </c:if>
                </c:forEach>
            </div>
        </div>
        <div class="modal-footer">
            <button class="btn" data-dismiss="modal" aria-hidden="true" onclick="stopAnimateWorkflowTask()">
                <fmt:message key="wsf.label.close"/>
            </button>
        </div>
    </div>

    <script>
        function startWorkflow(process) {
            showLoading(wsfi18n['wsf.title.workInProgress']);
            $.post("<c:url value='${url.base}${functions:escapePath(currentNode.path)}.startWorkflow.do'/>", {"process": process},
                    function (result) {
                        location.reload();
                    },
                    'json'
            );
        }


        function executeTask(action, taskID) {
            var outcome = $('#selectedOutcome_' + taskID).val();
            if (outcome == '') {
                $('#errorOutcome_' + taskID).show();
                return;
            }
            showLoading(wsfi18n['wsf.title.workInProgress']);
            $.post("<c:url value='${url.base}${functions:escapePath(currentNode.path)}.executeTask.do'/>",
                {"action": action,"outcome": outcome},
                function () {
                    location.reload();
                },
            'json');
        }

        var animated = false;

        function loop(value) {
            $("#" + value).fadeIn("slow", function () {
                $("#" + value).fadeOut("slow", function () {
                    if (animated) {
                        loop(value);
                    }
                });
            });
        }

        function animateWorkflowTask${fn:replace(currentNode.identifier,'-','')}${fn:replace(workflowDefinition.key,'-','')}() {
            animated = true;
            $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(currentNode.path))}.getWorkflowTasks.do"/>', {'workflowKey': '${workflowDefinition.key}'}, function (result) {
                <c:forEach items="${activeWorkflow.availableActions}" var="task" varStatus="status">
                coords = result['${task.name}'];
                var top = "";
                if (coords[1] > 200)
                    top = 35;
                else
                    top = 45;

                var left = 15;
                <c:if test="${workFlowName eq 'jBPM:docspace-workflow-archive-publish'}">
                    if (coords[1] > 200)
                        top = 50;

                    left = 0;
                </c:if>
                $("#running${task.id}").css('left', coords[0] - left + "px");
                $("#running${task.id}").css('top', (parseInt(coords[1]) + top) + "px");
                $("#running${task.id}").css('width', coords[2] + "px");
                $("#running${task.id}").css('height', coords[3] + "px");
                $("#runningInfo${task.id}").css('left', coords[0] - left + "px");
                $("#runningInfo${task.id}").css('top', (parseInt(coords[1]) + top + parseInt(coords[3])) + "px");
                $('#running${task.id}').fadeIn();
                </c:forEach>

                <c:forEach items="${tasks}" var="task" varStatus="status">
                    loop('running${task.value.id}');
                </c:forEach>

                <c:forEach items="${historyTasks}" var="task" varStatus="status">
                coords = result['${task.key}'];
                $("#history${task.value.actionId}").css('left', coords[0] - 15 + "px");
                $("#history${task.value.actionId}").css('top', (parseInt(coords[1]) + 35) + "px");
                $("#history${task.value.actionId}").css('width', coords[2] + "px");
                $("#history${task.value.actionId}").css('height', coords[3] + "px");
                $("#historyInfo${task.value.actionId}").css('left', coords[0] - 15 + "px");
                $("#historyInfo${task.value.actionId}").css('top', (parseInt(coords[1]) + 35 + parseInt(coords[3])) + "px");
                $('#history${task.value.actionId}').fadeIn();
                </c:forEach>
            }, 'json');
        }

        function stopAnimateWorkflowTask() {
            animated = false;
            $('.runningtask-div').hide();
            $('.historytask-div').hide();
        }
    </script>

    <c:choose>
        <c:when test="${empty activeWorkflow}">
            <c:choose>
                <c:when test="${not empty workflowDefinition.formResourceName}">
                    <a href="#" onclick="startCurrentWorkflow();return false;"
                       title="<fmt:message key="docnt_docspaceActions.workflow.startWorkflow"/>">
                        <fmt:message key="docnt_docspaceActions.workflow.startWorkflow"/>
                    </a>

                    <script type="text/javascript">
                        var startCurrentWorkflow = function () {
                            $('#wfStartHolder').modal();
                        }
                    </script>

                    <div id="wfStartHolder" class="modal hide fade
                         <c:if test="${workFlowName eq 'jBPM:docspace-workflow-archive-publish'}"> width-auto</c:if>">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                            <h3><fmt:message key="nt_base.workflowMonitor.docspace.startWorkflow"/></h3>
                        </div>
                        <c:url value="${url.current}.ajax" var="myUrl"/>
                        <template:include view="contribute.workflow.docspace">
                            <template:param name="resourceNodeType" value="${workflowDefinition.formResourceName}"/>
                            <template:param name="workflowStartForm"
                                            value="${workflowDefinition.provider}:${workflowDefinition.key}"/>
                            <template:param name="workflowStartFormWFName" value="${workflowDefinition.displayName}"/>
                            <template:param name="workflowStartAction" value="${url.base}${functions:escapePath(currentNode.path)}.startWorkflow.do"/>
                        </template:include>
                    </div>
                </c:when>
                <c:otherwise>
                    <script type="text/javascript">
                        var startCurrentWorkflow = function () {
                            startWorkflow('${workflowDefinition.provider}:${workflowDefinition.key}');
                        }
                    </script>
                    <a href="#" onclick="startWorkflow('${workflowDefinition.provider}:${workflowDefinition.key}')"
                       title="<fmt:message key="docnt_docspaceActions.workflow.startWorkflow"/>">
                        <fmt:message key="docnt_docspaceActions.workflow.startWorkflow"/>
                    </a>
                </c:otherwise>
            </c:choose>
        </c:when>
        <c:otherwise>
            <c:forEach items="${tasks}" var="entry">
                <c:set value="${entry.value}" var="task"/>
                <div id="task_${currentNode.identifier}_${task.id}" class="modal hide fade
                     <c:if test="${workFlowName eq 'jBPM:docspace-workflow-archive-publish'}"> width-auto</c:if>">
                    <c:choose>
                        <c:when test="${not empty task.formResourceName}">
                            <c:set var="workflowTaskFormTask" value="${task}" scope="request"/>
                            <c:url value="${url.current}.ajax" var="myUrl"/>
                            <template:include view="contribute.workflow.docspace">
                                <template:param name="resourceNodeType" value="${task.formResourceName}"/>
                                <template:param name="workflowTaskForm" value="${task.provider}:${task.id}"/>
                                <template:param name="workflowTaskFormTaskName" value="${task.name}"/>
                            </template:include>
                        </c:when>
                        <c:otherwise>
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                                <h3>${task.displayName}</h3>
                            </div>
                            <div class="modal-body">
                                <form class="form-horizontal">
                                    <label class="control-label">
                                        <fmt:message key="wsf.label.actions"/>
                                    </label>
                                    <div class="control-group">
                                        <div class="controls">
                                            <select id="selectedOutcome_${currentNode.identifier}_${task.id}">
                                                <option></option>
                                                <c:forEach items="${task.outcomes}" var="outcome" varStatus="status">
                                                    <option value="${outcome}">
                                                            ${task.displayOutcomes[status.index]}
                                                    </option>
                                                </c:forEach>
                                            </select>
                                        </div>
                                        <div id="errorOutcome_${currentNode.identifier}_${task.id}" class="controls text-error hide">
                                            <fmt:message key="nt_base.workflowMonitor.docspace.pleaseSelectAnAction"/>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button class="btn" data-dismiss="modal" aria-hidden="true" onclick="$('#errorOutcome_${currentNode.identifier}_${task.id}').hide();">
                                    <fmt:message key="wsf.label.close"/>
                                </button>
                                <button type="button" class="form-button btn btn-primary"
                                        onclick="executeTask('${task.provider}:${task.id}', '${currentNode.identifier}_${task.id}')">
                                    <fmt:message key="wsf.label.submit"/>
                                </button>
                            </div>
                        </c:otherwise>
                    </c:choose>
                </div>
            </c:forEach>
        </c:otherwise>
    </c:choose>
</c:if>
